#
# Autogenerated by Sandesh Compiler (1.0)
#
# DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
#
#  options string: py:new_style
# Copyright (c) 2013 Juniper Networks, Inc. All rights reserved.
#

from pysandesh.Thrift import TType, TMessageType, TException

from pysandesh.transport import TTransport
from pysandesh.protocol import TBinaryProtocol, TProtocol
try:
  from pysandesh.protocol import fastbinary
except:
  fastbinary = None

import cStringIO
import uuid
import netaddr
from sys import getsizeof
from itertools import chain
import bottle
from pysandesh import sandesh_base
from pysandesh.sandesh_http import SandeshHttp
from pysandesh.sandesh_uve import SandeshUVETypeMaps
from pysandesh.util import UTCTimestampUsec, UTCTimestampUsecToString
from pysandesh import util
from pysandesh.gen_py.sandesh.constants import *


class LldpSystemCapabilitiesMap(object):
  Other = 0
  Repeater = 1
  Bridge = 2
  WlanAccessPoint = 3
  Router = 4
  Telephone = 5
  DocsisCableDevice = 6
  StationOnly = 7

  _VALUES_TO_NAMES = {
    0: "Other",
    1: "Repeater",
    2: "Bridge",
    3: "WlanAccessPoint",
    4: "Router",
    5: "Telephone",
    6: "DocsisCableDevice",
    7: "StationOnly",
  }

  _NAMES_TO_VALUES = {
    "Other": 0,
    "Repeater": 1,
    "Bridge": 2,
    "WlanAccessPoint": 3,
    "Router": 4,
    "Telephone": 5,
    "DocsisCableDevice": 6,
    "StationOnly": 7,
  }


class ArpTable(object):
  """
  stores ARP information collected from physical router

  Attributes:
   - localIfIndex
   - mac
   - ip
  """

  thrift_spec = (
    None, # 0
    (1, TType.I32, 'localIfIndex', None, None, ), # 1
    (2, TType.STRING, 'mac', None, None, ), # 2
    (3, TType.STRING, 'ip', None, None, ), # 3
  )

  def __init__(self, localIfIndex=None, mac=None, ip=None,):
    self.localIfIndex = localIfIndex
    self.mac = mac
    self.ip = ip

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.I32:
          (length, self.localIfIndex) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.mac) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.ip) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.localIfIndex is not None:
      annotations = {}
      if oprot.writeFieldBegin('localIfIndex', TType.I32, 1, annotations) < 0: return -1
      if oprot.writeI32(self.localIfIndex) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.mac is not None:
      annotations = {}
      if oprot.writeFieldBegin('mac', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.mac) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ip is not None:
      annotations = {}
      if oprot.writeFieldBegin('ip', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.ip) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.localIfIndex is not None:
      log_str.write('localIfIndex = ')
      log_str.write(str(self.localIfIndex))
      log_str.write('  ')
    if self.mac is not None:
      log_str.write('mac = ')
      log_str.write(self.mac)
      log_str.write('  ')
    if self.ip is not None:
      log_str.write('ip = ')
      log_str.write(self.ip)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.localIfIndex is not None:
      size += getsizeof(self.localIfIndex)
    if self.mac is not None:
      size += getsizeof(self.mac)
    if self.ip is not None:
      size += getsizeof(self.ip)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class IfStats(object):
  """
  stores interface statistics information

  Attributes:
   - ifInPkts
   - ifOutPkts
   - ifInOctets
   - ifOutOctets
   - ifInDiscards
   - ifInErrors
   - ifOutDiscards
   - ifOutErrors
   - ifIndex
   - ifName
  """

  thrift_spec = (
    None, # 0
    (1, TType.U64, 'ifInPkts', None, None, ), # 1
    (2, TType.U64, 'ifOutPkts', None, None, ), # 2
    (3, TType.U64, 'ifInOctets', None, None, ), # 3
    (4, TType.U64, 'ifOutOctets', None, None, ), # 4
    (5, TType.U64, 'ifInDiscards', None, None, ), # 5
    (6, TType.U64, 'ifInErrors', None, None, ), # 6
    (7, TType.U64, 'ifOutDiscards', None, None, ), # 7
    (8, TType.U64, 'ifOutErrors', None, None, ), # 8
    (9, TType.U64, 'ifIndex', None, None, ), # 9
    (10, TType.STRING, 'ifName', None, None, ), # 10
  )

  def __init__(self, ifInPkts=None, ifOutPkts=None, ifInOctets=None, ifOutOctets=None, ifInDiscards=None, ifInErrors=None, ifOutDiscards=None, ifOutErrors=None, ifIndex=None, ifName=None,):
    self.ifInPkts = ifInPkts
    self.ifOutPkts = ifOutPkts
    self.ifInOctets = ifInOctets
    self.ifOutOctets = ifOutOctets
    self.ifInDiscards = ifInDiscards
    self.ifInErrors = ifInErrors
    self.ifOutDiscards = ifOutDiscards
    self.ifOutErrors = ifOutErrors
    self.ifIndex = ifIndex
    self.ifName = ifName

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.U64:
          (length, self.ifInPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.U64:
          (length, self.ifOutPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.U64:
          (length, self.ifInOctets) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.U64:
          (length, self.ifOutOctets) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.U64:
          (length, self.ifInDiscards) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.U64:
          (length, self.ifInErrors) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 7:
        if ftype == TType.U64:
          (length, self.ifOutDiscards) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 8:
        if ftype == TType.U64:
          (length, self.ifOutErrors) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 9:
        if ftype == TType.U64:
          (length, self.ifIndex) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 10:
        if ftype == TType.STRING:
          (length, self.ifName) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.ifInPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifInPkts', TType.U64, 1, annotations) < 0: return -1
      if oprot.writeU64(self.ifInPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifOutPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifOutPkts', TType.U64, 2, annotations) < 0: return -1
      if oprot.writeU64(self.ifOutPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifInOctets is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifInOctets', TType.U64, 3, annotations) < 0: return -1
      if oprot.writeU64(self.ifInOctets) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifOutOctets is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifOutOctets', TType.U64, 4, annotations) < 0: return -1
      if oprot.writeU64(self.ifOutOctets) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifInDiscards is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifInDiscards', TType.U64, 5, annotations) < 0: return -1
      if oprot.writeU64(self.ifInDiscards) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifInErrors is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifInErrors', TType.U64, 6, annotations) < 0: return -1
      if oprot.writeU64(self.ifInErrors) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifOutDiscards is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifOutDiscards', TType.U64, 7, annotations) < 0: return -1
      if oprot.writeU64(self.ifOutDiscards) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifOutErrors is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifOutErrors', TType.U64, 8, annotations) < 0: return -1
      if oprot.writeU64(self.ifOutErrors) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifIndex is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifIndex', TType.U64, 9, annotations) < 0: return -1
      if oprot.writeU64(self.ifIndex) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifName is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifName', TType.STRING, 10, annotations) < 0: return -1
      if oprot.writeString(self.ifName) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.ifInPkts is not None:
      log_str.write('ifInPkts = ')
      log_str.write(str(self.ifInPkts))
      log_str.write('  ')
    if self.ifOutPkts is not None:
      log_str.write('ifOutPkts = ')
      log_str.write(str(self.ifOutPkts))
      log_str.write('  ')
    if self.ifInOctets is not None:
      log_str.write('ifInOctets = ')
      log_str.write(str(self.ifInOctets))
      log_str.write('  ')
    if self.ifOutOctets is not None:
      log_str.write('ifOutOctets = ')
      log_str.write(str(self.ifOutOctets))
      log_str.write('  ')
    if self.ifInDiscards is not None:
      log_str.write('ifInDiscards = ')
      log_str.write(str(self.ifInDiscards))
      log_str.write('  ')
    if self.ifInErrors is not None:
      log_str.write('ifInErrors = ')
      log_str.write(str(self.ifInErrors))
      log_str.write('  ')
    if self.ifOutDiscards is not None:
      log_str.write('ifOutDiscards = ')
      log_str.write(str(self.ifOutDiscards))
      log_str.write('  ')
    if self.ifOutErrors is not None:
      log_str.write('ifOutErrors = ')
      log_str.write(str(self.ifOutErrors))
      log_str.write('  ')
    if self.ifIndex is not None:
      log_str.write('ifIndex = ')
      log_str.write(str(self.ifIndex))
      log_str.write('  ')
    if self.ifName is not None:
      log_str.write('ifName = ')
      log_str.write(self.ifName)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.ifInPkts is not None:
      size += getsizeof(self.ifInPkts)
    if self.ifOutPkts is not None:
      size += getsizeof(self.ifOutPkts)
    if self.ifInOctets is not None:
      size += getsizeof(self.ifInOctets)
    if self.ifOutOctets is not None:
      size += getsizeof(self.ifOutOctets)
    if self.ifInDiscards is not None:
      size += getsizeof(self.ifInDiscards)
    if self.ifInErrors is not None:
      size += getsizeof(self.ifInErrors)
    if self.ifOutDiscards is not None:
      size += getsizeof(self.ifOutDiscards)
    if self.ifOutErrors is not None:
      size += getsizeof(self.ifOutErrors)
    if self.ifIndex is not None:
      size += getsizeof(self.ifIndex)
    if self.ifName is not None:
      size += getsizeof(self.ifName)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class IfXTable(object):
  """
  stores interface statistics information collected from physical router

  Attributes:
   - ifAlias
   - ifConnectorPresent
   - ifCounterDiscontinuityTime
   - ifHCInBroadcastPkts
   - ifHCInMulticastPkts
   - ifHCInOctets
   - ifHCInUcastPkts
   - ifHCOutBroadcastPkts
   - ifHCOutMulticastPkts
   - ifHCOutOctets
   - ifHCOutUcastPkts
   - ifHighSpeed
   - ifInBroadcastPkts
   - ifInMulticastPkts
   - ifLinkUpDownTrapEnable
   - ifName
   - ifOutBroadcastPkts
   - ifOutMulticastPkts
   - ifPromiscuousMode
   - ifIndex
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'ifAlias', None, None, ), # 1
    (2, TType.I32, 'ifConnectorPresent', None, None, ), # 2
    (3, TType.I32, 'ifCounterDiscontinuityTime', None, None, ), # 3
    (4, TType.U64, 'ifHCInBroadcastPkts', None, None, ), # 4
    (5, TType.U64, 'ifHCInMulticastPkts', None, None, ), # 5
    (6, TType.U64, 'ifHCInOctets', None, None, ), # 6
    (7, TType.U64, 'ifHCInUcastPkts', None, None, ), # 7
    (8, TType.U64, 'ifHCOutBroadcastPkts', None, None, ), # 8
    (9, TType.U64, 'ifHCOutMulticastPkts', None, None, ), # 9
    (10, TType.U64, 'ifHCOutOctets', None, None, ), # 10
    (11, TType.U64, 'ifHCOutUcastPkts', None, None, ), # 11
    (12, TType.I32, 'ifHighSpeed', None, None, ), # 12
    (13, TType.U64, 'ifInBroadcastPkts', None, None, ), # 13
    (14, TType.U64, 'ifInMulticastPkts', None, None, ), # 14
    (15, TType.I32, 'ifLinkUpDownTrapEnable', None, None, ), # 15
    (16, TType.STRING, 'ifName', None, None, ), # 16
    (17, TType.U64, 'ifOutBroadcastPkts', None, None, ), # 17
    (18, TType.U64, 'ifOutMulticastPkts', None, None, ), # 18
    (19, TType.I32, 'ifPromiscuousMode', None, None, ), # 19
    (20, TType.I32, 'ifIndex', None, None, ), # 20
  )

  def __init__(self, ifAlias=None, ifConnectorPresent=None, ifCounterDiscontinuityTime=None, ifHCInBroadcastPkts=None, ifHCInMulticastPkts=None, ifHCInOctets=None, ifHCInUcastPkts=None, ifHCOutBroadcastPkts=None, ifHCOutMulticastPkts=None, ifHCOutOctets=None, ifHCOutUcastPkts=None, ifHighSpeed=None, ifInBroadcastPkts=None, ifInMulticastPkts=None, ifLinkUpDownTrapEnable=None, ifName=None, ifOutBroadcastPkts=None, ifOutMulticastPkts=None, ifPromiscuousMode=None, ifIndex=None,):
    self.ifAlias = ifAlias
    self.ifConnectorPresent = ifConnectorPresent
    self.ifCounterDiscontinuityTime = ifCounterDiscontinuityTime
    self.ifHCInBroadcastPkts = ifHCInBroadcastPkts
    self.ifHCInMulticastPkts = ifHCInMulticastPkts
    self.ifHCInOctets = ifHCInOctets
    self.ifHCInUcastPkts = ifHCInUcastPkts
    self.ifHCOutBroadcastPkts = ifHCOutBroadcastPkts
    self.ifHCOutMulticastPkts = ifHCOutMulticastPkts
    self.ifHCOutOctets = ifHCOutOctets
    self.ifHCOutUcastPkts = ifHCOutUcastPkts
    self.ifHighSpeed = ifHighSpeed
    self.ifInBroadcastPkts = ifInBroadcastPkts
    self.ifInMulticastPkts = ifInMulticastPkts
    self.ifLinkUpDownTrapEnable = ifLinkUpDownTrapEnable
    self.ifName = ifName
    self.ifOutBroadcastPkts = ifOutBroadcastPkts
    self.ifOutMulticastPkts = ifOutMulticastPkts
    self.ifPromiscuousMode = ifPromiscuousMode
    self.ifIndex = ifIndex

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.ifAlias) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.I32:
          (length, self.ifConnectorPresent) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.I32:
          (length, self.ifCounterDiscontinuityTime) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.U64:
          (length, self.ifHCInBroadcastPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.U64:
          (length, self.ifHCInMulticastPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.U64:
          (length, self.ifHCInOctets) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 7:
        if ftype == TType.U64:
          (length, self.ifHCInUcastPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 8:
        if ftype == TType.U64:
          (length, self.ifHCOutBroadcastPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 9:
        if ftype == TType.U64:
          (length, self.ifHCOutMulticastPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 10:
        if ftype == TType.U64:
          (length, self.ifHCOutOctets) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 11:
        if ftype == TType.U64:
          (length, self.ifHCOutUcastPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 12:
        if ftype == TType.I32:
          (length, self.ifHighSpeed) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 13:
        if ftype == TType.U64:
          (length, self.ifInBroadcastPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 14:
        if ftype == TType.U64:
          (length, self.ifInMulticastPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 15:
        if ftype == TType.I32:
          (length, self.ifLinkUpDownTrapEnable) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 16:
        if ftype == TType.STRING:
          (length, self.ifName) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 17:
        if ftype == TType.U64:
          (length, self.ifOutBroadcastPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 18:
        if ftype == TType.U64:
          (length, self.ifOutMulticastPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 19:
        if ftype == TType.I32:
          (length, self.ifPromiscuousMode) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 20:
        if ftype == TType.I32:
          (length, self.ifIndex) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.ifAlias is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifAlias', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.ifAlias) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifConnectorPresent is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifConnectorPresent', TType.I32, 2, annotations) < 0: return -1
      if oprot.writeI32(self.ifConnectorPresent) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifCounterDiscontinuityTime is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifCounterDiscontinuityTime', TType.I32, 3, annotations) < 0: return -1
      if oprot.writeI32(self.ifCounterDiscontinuityTime) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifHCInBroadcastPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifHCInBroadcastPkts', TType.U64, 4, annotations) < 0: return -1
      if oprot.writeU64(self.ifHCInBroadcastPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifHCInMulticastPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifHCInMulticastPkts', TType.U64, 5, annotations) < 0: return -1
      if oprot.writeU64(self.ifHCInMulticastPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifHCInOctets is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifHCInOctets', TType.U64, 6, annotations) < 0: return -1
      if oprot.writeU64(self.ifHCInOctets) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifHCInUcastPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifHCInUcastPkts', TType.U64, 7, annotations) < 0: return -1
      if oprot.writeU64(self.ifHCInUcastPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifHCOutBroadcastPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifHCOutBroadcastPkts', TType.U64, 8, annotations) < 0: return -1
      if oprot.writeU64(self.ifHCOutBroadcastPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifHCOutMulticastPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifHCOutMulticastPkts', TType.U64, 9, annotations) < 0: return -1
      if oprot.writeU64(self.ifHCOutMulticastPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifHCOutOctets is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifHCOutOctets', TType.U64, 10, annotations) < 0: return -1
      if oprot.writeU64(self.ifHCOutOctets) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifHCOutUcastPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifHCOutUcastPkts', TType.U64, 11, annotations) < 0: return -1
      if oprot.writeU64(self.ifHCOutUcastPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifHighSpeed is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifHighSpeed', TType.I32, 12, annotations) < 0: return -1
      if oprot.writeI32(self.ifHighSpeed) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifInBroadcastPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifInBroadcastPkts', TType.U64, 13, annotations) < 0: return -1
      if oprot.writeU64(self.ifInBroadcastPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifInMulticastPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifInMulticastPkts', TType.U64, 14, annotations) < 0: return -1
      if oprot.writeU64(self.ifInMulticastPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifLinkUpDownTrapEnable is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifLinkUpDownTrapEnable', TType.I32, 15, annotations) < 0: return -1
      if oprot.writeI32(self.ifLinkUpDownTrapEnable) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifName is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifName', TType.STRING, 16, annotations) < 0: return -1
      if oprot.writeString(self.ifName) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifOutBroadcastPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifOutBroadcastPkts', TType.U64, 17, annotations) < 0: return -1
      if oprot.writeU64(self.ifOutBroadcastPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifOutMulticastPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifOutMulticastPkts', TType.U64, 18, annotations) < 0: return -1
      if oprot.writeU64(self.ifOutMulticastPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifPromiscuousMode is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifPromiscuousMode', TType.I32, 19, annotations) < 0: return -1
      if oprot.writeI32(self.ifPromiscuousMode) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifIndex is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifIndex', TType.I32, 20, annotations) < 0: return -1
      if oprot.writeI32(self.ifIndex) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.ifAlias is not None:
      log_str.write('ifAlias = ')
      log_str.write(self.ifAlias)
      log_str.write('  ')
    if self.ifConnectorPresent is not None:
      log_str.write('ifConnectorPresent = ')
      log_str.write(str(self.ifConnectorPresent))
      log_str.write('  ')
    if self.ifCounterDiscontinuityTime is not None:
      log_str.write('ifCounterDiscontinuityTime = ')
      log_str.write(str(self.ifCounterDiscontinuityTime))
      log_str.write('  ')
    if self.ifHCInBroadcastPkts is not None:
      log_str.write('ifHCInBroadcastPkts = ')
      log_str.write(str(self.ifHCInBroadcastPkts))
      log_str.write('  ')
    if self.ifHCInMulticastPkts is not None:
      log_str.write('ifHCInMulticastPkts = ')
      log_str.write(str(self.ifHCInMulticastPkts))
      log_str.write('  ')
    if self.ifHCInOctets is not None:
      log_str.write('ifHCInOctets = ')
      log_str.write(str(self.ifHCInOctets))
      log_str.write('  ')
    if self.ifHCInUcastPkts is not None:
      log_str.write('ifHCInUcastPkts = ')
      log_str.write(str(self.ifHCInUcastPkts))
      log_str.write('  ')
    if self.ifHCOutBroadcastPkts is not None:
      log_str.write('ifHCOutBroadcastPkts = ')
      log_str.write(str(self.ifHCOutBroadcastPkts))
      log_str.write('  ')
    if self.ifHCOutMulticastPkts is not None:
      log_str.write('ifHCOutMulticastPkts = ')
      log_str.write(str(self.ifHCOutMulticastPkts))
      log_str.write('  ')
    if self.ifHCOutOctets is not None:
      log_str.write('ifHCOutOctets = ')
      log_str.write(str(self.ifHCOutOctets))
      log_str.write('  ')
    if self.ifHCOutUcastPkts is not None:
      log_str.write('ifHCOutUcastPkts = ')
      log_str.write(str(self.ifHCOutUcastPkts))
      log_str.write('  ')
    if self.ifHighSpeed is not None:
      log_str.write('ifHighSpeed = ')
      log_str.write(str(self.ifHighSpeed))
      log_str.write('  ')
    if self.ifInBroadcastPkts is not None:
      log_str.write('ifInBroadcastPkts = ')
      log_str.write(str(self.ifInBroadcastPkts))
      log_str.write('  ')
    if self.ifInMulticastPkts is not None:
      log_str.write('ifInMulticastPkts = ')
      log_str.write(str(self.ifInMulticastPkts))
      log_str.write('  ')
    if self.ifLinkUpDownTrapEnable is not None:
      log_str.write('ifLinkUpDownTrapEnable = ')
      log_str.write(str(self.ifLinkUpDownTrapEnable))
      log_str.write('  ')
    if self.ifName is not None:
      log_str.write('ifName = ')
      log_str.write(self.ifName)
      log_str.write('  ')
    if self.ifOutBroadcastPkts is not None:
      log_str.write('ifOutBroadcastPkts = ')
      log_str.write(str(self.ifOutBroadcastPkts))
      log_str.write('  ')
    if self.ifOutMulticastPkts is not None:
      log_str.write('ifOutMulticastPkts = ')
      log_str.write(str(self.ifOutMulticastPkts))
      log_str.write('  ')
    if self.ifPromiscuousMode is not None:
      log_str.write('ifPromiscuousMode = ')
      log_str.write(str(self.ifPromiscuousMode))
      log_str.write('  ')
    if self.ifIndex is not None:
      log_str.write('ifIndex = ')
      log_str.write(str(self.ifIndex))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.ifAlias is not None:
      size += getsizeof(self.ifAlias)
    if self.ifConnectorPresent is not None:
      size += getsizeof(self.ifConnectorPresent)
    if self.ifCounterDiscontinuityTime is not None:
      size += getsizeof(self.ifCounterDiscontinuityTime)
    if self.ifHCInBroadcastPkts is not None:
      size += getsizeof(self.ifHCInBroadcastPkts)
    if self.ifHCInMulticastPkts is not None:
      size += getsizeof(self.ifHCInMulticastPkts)
    if self.ifHCInOctets is not None:
      size += getsizeof(self.ifHCInOctets)
    if self.ifHCInUcastPkts is not None:
      size += getsizeof(self.ifHCInUcastPkts)
    if self.ifHCOutBroadcastPkts is not None:
      size += getsizeof(self.ifHCOutBroadcastPkts)
    if self.ifHCOutMulticastPkts is not None:
      size += getsizeof(self.ifHCOutMulticastPkts)
    if self.ifHCOutOctets is not None:
      size += getsizeof(self.ifHCOutOctets)
    if self.ifHCOutUcastPkts is not None:
      size += getsizeof(self.ifHCOutUcastPkts)
    if self.ifHighSpeed is not None:
      size += getsizeof(self.ifHighSpeed)
    if self.ifInBroadcastPkts is not None:
      size += getsizeof(self.ifInBroadcastPkts)
    if self.ifInMulticastPkts is not None:
      size += getsizeof(self.ifInMulticastPkts)
    if self.ifLinkUpDownTrapEnable is not None:
      size += getsizeof(self.ifLinkUpDownTrapEnable)
    if self.ifName is not None:
      size += getsizeof(self.ifName)
    if self.ifOutBroadcastPkts is not None:
      size += getsizeof(self.ifOutBroadcastPkts)
    if self.ifOutMulticastPkts is not None:
      size += getsizeof(self.ifOutMulticastPkts)
    if self.ifPromiscuousMode is not None:
      size += getsizeof(self.ifPromiscuousMode)
    if self.ifIndex is not None:
      size += getsizeof(self.ifIndex)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class IfTable(object):
  """
  stores interface statistics information collected from physical router

  Attributes:
   - ifAdminStatus
   - ifDescr
   - ifInDiscards
   - ifInErrors
   - ifInNUcastPkts
   - ifInOctets
   - ifInUcastPkts
   - ifInUnknownProtos
   - ifIndex
   - ifLastChange
   - ifMtu
   - ifOperStatus
   - ifOutDiscards
   - ifOutErrors
   - ifOutNUcastPkts
   - ifOutOctets
   - ifOutQLen
   - ifOutUcastPkts
   - ifPhysAddress
   - ifSpecific
   - ifSpeed
   - ifType
  """

  thrift_spec = (
    None, # 0
    (1, TType.I32, 'ifAdminStatus', None, None, ), # 1
    (2, TType.STRING, 'ifDescr', None, None, ), # 2
    (3, TType.U64, 'ifInDiscards', None, None, ), # 3
    (4, TType.U64, 'ifInErrors', None, None, ), # 4
    (5, TType.U64, 'ifInNUcastPkts', None, None, ), # 5
    (6, TType.U64, 'ifInOctets', None, None, ), # 6
    (7, TType.U64, 'ifInUcastPkts', None, None, ), # 7
    (8, TType.U64, 'ifInUnknownProtos', None, None, ), # 8
    (9, TType.U32, 'ifIndex', None, None, ), # 9
    (10, TType.I32, 'ifLastChange', None, None, ), # 10
    (11, TType.U32, 'ifMtu', None, None, ), # 11
    (12, TType.I32, 'ifOperStatus', None, None, ), # 12
    (13, TType.U64, 'ifOutDiscards', None, None, ), # 13
    (14, TType.U64, 'ifOutErrors', None, None, ), # 14
    (15, TType.U64, 'ifOutNUcastPkts', None, None, ), # 15
    (16, TType.U64, 'ifOutOctets', None, None, ), # 16
    (17, TType.U64, 'ifOutQLen', None, None, ), # 17
    (18, TType.U64, 'ifOutUcastPkts', None, None, ), # 18
    (19, TType.STRING, 'ifPhysAddress', None, None, ), # 19
    (20, TType.STRING, 'ifSpecific', None, None, ), # 20
    (21, TType.I32, 'ifSpeed', None, None, ), # 21
    (22, TType.I32, 'ifType', None, None, ), # 22
  )

  def __init__(self, ifAdminStatus=None, ifDescr=None, ifInDiscards=None, ifInErrors=None, ifInNUcastPkts=None, ifInOctets=None, ifInUcastPkts=None, ifInUnknownProtos=None, ifIndex=None, ifLastChange=None, ifMtu=None, ifOperStatus=None, ifOutDiscards=None, ifOutErrors=None, ifOutNUcastPkts=None, ifOutOctets=None, ifOutQLen=None, ifOutUcastPkts=None, ifPhysAddress=None, ifSpecific=None, ifSpeed=None, ifType=None,):
    self.ifAdminStatus = ifAdminStatus
    self.ifDescr = ifDescr
    self.ifInDiscards = ifInDiscards
    self.ifInErrors = ifInErrors
    self.ifInNUcastPkts = ifInNUcastPkts
    self.ifInOctets = ifInOctets
    self.ifInUcastPkts = ifInUcastPkts
    self.ifInUnknownProtos = ifInUnknownProtos
    self.ifIndex = ifIndex
    self.ifLastChange = ifLastChange
    self.ifMtu = ifMtu
    self.ifOperStatus = ifOperStatus
    self.ifOutDiscards = ifOutDiscards
    self.ifOutErrors = ifOutErrors
    self.ifOutNUcastPkts = ifOutNUcastPkts
    self.ifOutOctets = ifOutOctets
    self.ifOutQLen = ifOutQLen
    self.ifOutUcastPkts = ifOutUcastPkts
    self.ifPhysAddress = ifPhysAddress
    self.ifSpecific = ifSpecific
    self.ifSpeed = ifSpeed
    self.ifType = ifType

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.I32:
          (length, self.ifAdminStatus) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.ifDescr) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.U64:
          (length, self.ifInDiscards) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.U64:
          (length, self.ifInErrors) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.U64:
          (length, self.ifInNUcastPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.U64:
          (length, self.ifInOctets) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 7:
        if ftype == TType.U64:
          (length, self.ifInUcastPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 8:
        if ftype == TType.U64:
          (length, self.ifInUnknownProtos) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 9:
        if ftype == TType.U32:
          (length, self.ifIndex) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 10:
        if ftype == TType.I32:
          (length, self.ifLastChange) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 11:
        if ftype == TType.U32:
          (length, self.ifMtu) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 12:
        if ftype == TType.I32:
          (length, self.ifOperStatus) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 13:
        if ftype == TType.U64:
          (length, self.ifOutDiscards) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 14:
        if ftype == TType.U64:
          (length, self.ifOutErrors) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 15:
        if ftype == TType.U64:
          (length, self.ifOutNUcastPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 16:
        if ftype == TType.U64:
          (length, self.ifOutOctets) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 17:
        if ftype == TType.U64:
          (length, self.ifOutQLen) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 18:
        if ftype == TType.U64:
          (length, self.ifOutUcastPkts) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 19:
        if ftype == TType.STRING:
          (length, self.ifPhysAddress) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 20:
        if ftype == TType.STRING:
          (length, self.ifSpecific) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 21:
        if ftype == TType.I32:
          (length, self.ifSpeed) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 22:
        if ftype == TType.I32:
          (length, self.ifType) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.ifAdminStatus is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifAdminStatus', TType.I32, 1, annotations) < 0: return -1
      if oprot.writeI32(self.ifAdminStatus) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifDescr is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifDescr', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.ifDescr) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifInDiscards is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifInDiscards', TType.U64, 3, annotations) < 0: return -1
      if oprot.writeU64(self.ifInDiscards) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifInErrors is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifInErrors', TType.U64, 4, annotations) < 0: return -1
      if oprot.writeU64(self.ifInErrors) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifInNUcastPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifInNUcastPkts', TType.U64, 5, annotations) < 0: return -1
      if oprot.writeU64(self.ifInNUcastPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifInOctets is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifInOctets', TType.U64, 6, annotations) < 0: return -1
      if oprot.writeU64(self.ifInOctets) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifInUcastPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifInUcastPkts', TType.U64, 7, annotations) < 0: return -1
      if oprot.writeU64(self.ifInUcastPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifInUnknownProtos is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifInUnknownProtos', TType.U64, 8, annotations) < 0: return -1
      if oprot.writeU64(self.ifInUnknownProtos) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifIndex is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifIndex', TType.U32, 9, annotations) < 0: return -1
      if oprot.writeU32(self.ifIndex) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifLastChange is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifLastChange', TType.I32, 10, annotations) < 0: return -1
      if oprot.writeI32(self.ifLastChange) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifMtu is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifMtu', TType.U32, 11, annotations) < 0: return -1
      if oprot.writeU32(self.ifMtu) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifOperStatus is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifOperStatus', TType.I32, 12, annotations) < 0: return -1
      if oprot.writeI32(self.ifOperStatus) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifOutDiscards is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifOutDiscards', TType.U64, 13, annotations) < 0: return -1
      if oprot.writeU64(self.ifOutDiscards) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifOutErrors is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifOutErrors', TType.U64, 14, annotations) < 0: return -1
      if oprot.writeU64(self.ifOutErrors) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifOutNUcastPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifOutNUcastPkts', TType.U64, 15, annotations) < 0: return -1
      if oprot.writeU64(self.ifOutNUcastPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifOutOctets is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifOutOctets', TType.U64, 16, annotations) < 0: return -1
      if oprot.writeU64(self.ifOutOctets) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifOutQLen is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifOutQLen', TType.U64, 17, annotations) < 0: return -1
      if oprot.writeU64(self.ifOutQLen) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifOutUcastPkts is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifOutUcastPkts', TType.U64, 18, annotations) < 0: return -1
      if oprot.writeU64(self.ifOutUcastPkts) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifPhysAddress is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifPhysAddress', TType.STRING, 19, annotations) < 0: return -1
      if oprot.writeString(self.ifPhysAddress) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifSpecific is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifSpecific', TType.STRING, 20, annotations) < 0: return -1
      if oprot.writeString(self.ifSpecific) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifSpeed is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifSpeed', TType.I32, 21, annotations) < 0: return -1
      if oprot.writeI32(self.ifSpeed) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifType is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifType', TType.I32, 22, annotations) < 0: return -1
      if oprot.writeI32(self.ifType) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.ifAdminStatus is not None:
      log_str.write('ifAdminStatus = ')
      log_str.write(str(self.ifAdminStatus))
      log_str.write('  ')
    if self.ifDescr is not None:
      log_str.write('ifDescr = ')
      log_str.write(self.ifDescr)
      log_str.write('  ')
    if self.ifInDiscards is not None:
      log_str.write('ifInDiscards = ')
      log_str.write(str(self.ifInDiscards))
      log_str.write('  ')
    if self.ifInErrors is not None:
      log_str.write('ifInErrors = ')
      log_str.write(str(self.ifInErrors))
      log_str.write('  ')
    if self.ifInNUcastPkts is not None:
      log_str.write('ifInNUcastPkts = ')
      log_str.write(str(self.ifInNUcastPkts))
      log_str.write('  ')
    if self.ifInOctets is not None:
      log_str.write('ifInOctets = ')
      log_str.write(str(self.ifInOctets))
      log_str.write('  ')
    if self.ifInUcastPkts is not None:
      log_str.write('ifInUcastPkts = ')
      log_str.write(str(self.ifInUcastPkts))
      log_str.write('  ')
    if self.ifInUnknownProtos is not None:
      log_str.write('ifInUnknownProtos = ')
      log_str.write(str(self.ifInUnknownProtos))
      log_str.write('  ')
    if self.ifIndex is not None:
      log_str.write('ifIndex = ')
      log_str.write(str(self.ifIndex))
      log_str.write('  ')
    if self.ifLastChange is not None:
      log_str.write('ifLastChange = ')
      log_str.write(str(self.ifLastChange))
      log_str.write('  ')
    if self.ifMtu is not None:
      log_str.write('ifMtu = ')
      log_str.write(str(self.ifMtu))
      log_str.write('  ')
    if self.ifOperStatus is not None:
      log_str.write('ifOperStatus = ')
      log_str.write(str(self.ifOperStatus))
      log_str.write('  ')
    if self.ifOutDiscards is not None:
      log_str.write('ifOutDiscards = ')
      log_str.write(str(self.ifOutDiscards))
      log_str.write('  ')
    if self.ifOutErrors is not None:
      log_str.write('ifOutErrors = ')
      log_str.write(str(self.ifOutErrors))
      log_str.write('  ')
    if self.ifOutNUcastPkts is not None:
      log_str.write('ifOutNUcastPkts = ')
      log_str.write(str(self.ifOutNUcastPkts))
      log_str.write('  ')
    if self.ifOutOctets is not None:
      log_str.write('ifOutOctets = ')
      log_str.write(str(self.ifOutOctets))
      log_str.write('  ')
    if self.ifOutQLen is not None:
      log_str.write('ifOutQLen = ')
      log_str.write(str(self.ifOutQLen))
      log_str.write('  ')
    if self.ifOutUcastPkts is not None:
      log_str.write('ifOutUcastPkts = ')
      log_str.write(str(self.ifOutUcastPkts))
      log_str.write('  ')
    if self.ifPhysAddress is not None:
      log_str.write('ifPhysAddress = ')
      log_str.write(self.ifPhysAddress)
      log_str.write('  ')
    if self.ifSpecific is not None:
      log_str.write('ifSpecific = ')
      log_str.write(self.ifSpecific)
      log_str.write('  ')
    if self.ifSpeed is not None:
      log_str.write('ifSpeed = ')
      log_str.write(str(self.ifSpeed))
      log_str.write('  ')
    if self.ifType is not None:
      log_str.write('ifType = ')
      log_str.write(str(self.ifType))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.ifAdminStatus is not None:
      size += getsizeof(self.ifAdminStatus)
    if self.ifDescr is not None:
      size += getsizeof(self.ifDescr)
    if self.ifInDiscards is not None:
      size += getsizeof(self.ifInDiscards)
    if self.ifInErrors is not None:
      size += getsizeof(self.ifInErrors)
    if self.ifInNUcastPkts is not None:
      size += getsizeof(self.ifInNUcastPkts)
    if self.ifInOctets is not None:
      size += getsizeof(self.ifInOctets)
    if self.ifInUcastPkts is not None:
      size += getsizeof(self.ifInUcastPkts)
    if self.ifInUnknownProtos is not None:
      size += getsizeof(self.ifInUnknownProtos)
    if self.ifIndex is not None:
      size += getsizeof(self.ifIndex)
    if self.ifLastChange is not None:
      size += getsizeof(self.ifLastChange)
    if self.ifMtu is not None:
      size += getsizeof(self.ifMtu)
    if self.ifOperStatus is not None:
      size += getsizeof(self.ifOperStatus)
    if self.ifOutDiscards is not None:
      size += getsizeof(self.ifOutDiscards)
    if self.ifOutErrors is not None:
      size += getsizeof(self.ifOutErrors)
    if self.ifOutNUcastPkts is not None:
      size += getsizeof(self.ifOutNUcastPkts)
    if self.ifOutOctets is not None:
      size += getsizeof(self.ifOutOctets)
    if self.ifOutQLen is not None:
      size += getsizeof(self.ifOutQLen)
    if self.ifOutUcastPkts is not None:
      size += getsizeof(self.ifOutUcastPkts)
    if self.ifPhysAddress is not None:
      size += getsizeof(self.ifPhysAddress)
    if self.ifSpecific is not None:
      size += getsizeof(self.ifSpecific)
    if self.ifSpeed is not None:
      size += getsizeof(self.ifSpeed)
    if self.ifType is not None:
      size += getsizeof(self.ifType)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class IpMib(object):
  """
  Attributes:
   - ifIndex
   - ipAdEntIfIndex
  """

  thrift_spec = (
    None, # 0
    (1, TType.U32, 'ifIndex', None, None, ), # 1
    (2, TType.STRING, 'ipAdEntIfIndex', None, None, ), # 2
  )

  def __init__(self, ifIndex=None, ipAdEntIfIndex=None,):
    self.ifIndex = ifIndex
    self.ipAdEntIfIndex = ipAdEntIfIndex

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.U32:
          (length, self.ifIndex) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.ipAdEntIfIndex) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.ifIndex is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifIndex', TType.U32, 1, annotations) < 0: return -1
      if oprot.writeU32(self.ifIndex) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ipAdEntIfIndex is not None:
      annotations = {}
      if oprot.writeFieldBegin('ipAdEntIfIndex', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.ipAdEntIfIndex) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.ifIndex is not None:
      log_str.write('ifIndex = ')
      log_str.write(str(self.ifIndex))
      log_str.write('  ')
    if self.ipAdEntIfIndex is not None:
      log_str.write('ipAdEntIfIndex = ')
      log_str.write(self.ipAdEntIfIndex)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.ifIndex is not None:
      size += getsizeof(self.ifIndex)
    if self.ipAdEntIfIndex is not None:
      size += getsizeof(self.ipAdEntIfIndex)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class LldpLocManAddrEntry(object):
  """
  Attributes:
   - lldpLocManAddr
   - lldpLocManAddrOID
   - lldpLocManAddrSubtype
   - lldpLocManAddrOIDLen
   - lldpLocManAddrIfId
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'lldpLocManAddr', None, None, ), # 1
    (2, TType.STRING, 'lldpLocManAddrOID', None, None, ), # 2
    (3, TType.I32, 'lldpLocManAddrSubtype', None, None, ), # 3
    (4, TType.I32, 'lldpLocManAddrOIDLen', None, None, ), # 4
    (5, TType.I32, 'lldpLocManAddrIfId', None, None, ), # 5
  )

  def __init__(self, lldpLocManAddr=None, lldpLocManAddrOID=None, lldpLocManAddrSubtype=None, lldpLocManAddrOIDLen=None, lldpLocManAddrIfId=None,):
    self.lldpLocManAddr = lldpLocManAddr
    self.lldpLocManAddrOID = lldpLocManAddrOID
    self.lldpLocManAddrSubtype = lldpLocManAddrSubtype
    self.lldpLocManAddrOIDLen = lldpLocManAddrOIDLen
    self.lldpLocManAddrIfId = lldpLocManAddrIfId

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.lldpLocManAddr) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.lldpLocManAddrOID) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.I32:
          (length, self.lldpLocManAddrSubtype) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.I32:
          (length, self.lldpLocManAddrOIDLen) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.I32:
          (length, self.lldpLocManAddrIfId) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.lldpLocManAddr is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocManAddr', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.lldpLocManAddr) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpLocManAddrOID is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocManAddrOID', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.lldpLocManAddrOID) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpLocManAddrSubtype is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocManAddrSubtype', TType.I32, 3, annotations) < 0: return -1
      if oprot.writeI32(self.lldpLocManAddrSubtype) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpLocManAddrOIDLen is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocManAddrOIDLen', TType.I32, 4, annotations) < 0: return -1
      if oprot.writeI32(self.lldpLocManAddrOIDLen) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpLocManAddrIfId is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocManAddrIfId', TType.I32, 5, annotations) < 0: return -1
      if oprot.writeI32(self.lldpLocManAddrIfId) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.lldpLocManAddr is not None:
      log_str.write('lldpLocManAddr = ')
      log_str.write(self.lldpLocManAddr)
      log_str.write('  ')
    if self.lldpLocManAddrOID is not None:
      log_str.write('lldpLocManAddrOID = ')
      log_str.write(self.lldpLocManAddrOID)
      log_str.write('  ')
    if self.lldpLocManAddrSubtype is not None:
      log_str.write('lldpLocManAddrSubtype = ')
      log_str.write(str(self.lldpLocManAddrSubtype))
      log_str.write('  ')
    if self.lldpLocManAddrOIDLen is not None:
      log_str.write('lldpLocManAddrOIDLen = ')
      log_str.write(str(self.lldpLocManAddrOIDLen))
      log_str.write('  ')
    if self.lldpLocManAddrIfId is not None:
      log_str.write('lldpLocManAddrIfId = ')
      log_str.write(str(self.lldpLocManAddrIfId))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.lldpLocManAddr is not None:
      size += getsizeof(self.lldpLocManAddr)
    if self.lldpLocManAddrOID is not None:
      size += getsizeof(self.lldpLocManAddrOID)
    if self.lldpLocManAddrSubtype is not None:
      size += getsizeof(self.lldpLocManAddrSubtype)
    if self.lldpLocManAddrOIDLen is not None:
      size += getsizeof(self.lldpLocManAddrOIDLen)
    if self.lldpLocManAddrIfId is not None:
      size += getsizeof(self.lldpLocManAddrIfId)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class LldpLocPortEntry(object):
  """
  Attributes:
   - lldpLocPortNum
   - lldpLocPortIdSubtype
   - lldpLocPortId
   - lldpLocPortDesc
  """

  thrift_spec = (
    None, # 0
    (1, TType.I32, 'lldpLocPortNum', None, None, ), # 1
    (2, TType.I32, 'lldpLocPortIdSubtype', None, None, ), # 2
    (3, TType.STRING, 'lldpLocPortId', None, None, ), # 3
    (4, TType.STRING, 'lldpLocPortDesc', None, None, ), # 4
  )

  def __init__(self, lldpLocPortNum=None, lldpLocPortIdSubtype=None, lldpLocPortId=None, lldpLocPortDesc=None,):
    self.lldpLocPortNum = lldpLocPortNum
    self.lldpLocPortIdSubtype = lldpLocPortIdSubtype
    self.lldpLocPortId = lldpLocPortId
    self.lldpLocPortDesc = lldpLocPortDesc

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.I32:
          (length, self.lldpLocPortNum) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.I32:
          (length, self.lldpLocPortIdSubtype) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.lldpLocPortId) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.STRING:
          (length, self.lldpLocPortDesc) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.lldpLocPortNum is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocPortNum', TType.I32, 1, annotations) < 0: return -1
      if oprot.writeI32(self.lldpLocPortNum) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpLocPortIdSubtype is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocPortIdSubtype', TType.I32, 2, annotations) < 0: return -1
      if oprot.writeI32(self.lldpLocPortIdSubtype) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpLocPortId is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocPortId', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.lldpLocPortId) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpLocPortDesc is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocPortDesc', TType.STRING, 4, annotations) < 0: return -1
      if oprot.writeString(self.lldpLocPortDesc) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.lldpLocPortNum is not None:
      log_str.write('lldpLocPortNum = ')
      log_str.write(str(self.lldpLocPortNum))
      log_str.write('  ')
    if self.lldpLocPortIdSubtype is not None:
      log_str.write('lldpLocPortIdSubtype = ')
      log_str.write(str(self.lldpLocPortIdSubtype))
      log_str.write('  ')
    if self.lldpLocPortId is not None:
      log_str.write('lldpLocPortId = ')
      log_str.write(self.lldpLocPortId)
      log_str.write('  ')
    if self.lldpLocPortDesc is not None:
      log_str.write('lldpLocPortDesc = ')
      log_str.write(self.lldpLocPortDesc)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.lldpLocPortNum is not None:
      size += getsizeof(self.lldpLocPortNum)
    if self.lldpLocPortIdSubtype is not None:
      size += getsizeof(self.lldpLocPortIdSubtype)
    if self.lldpLocPortId is not None:
      size += getsizeof(self.lldpLocPortId)
    if self.lldpLocPortDesc is not None:
      size += getsizeof(self.lldpLocPortDesc)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class LldpLocalSystemData(object):
  """
  Attributes:
   - lldpLocChassisId
   - lldpLocChassisIdSubtype
   - lldpLocSysName
   - lldpLocSysDesc
   - lldpLocSysCapEnabled
   - lldpLocSysCapSupported
   - lldpLocManAddrEntry
   - lldpLocPortTable
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'lldpLocChassisId', None, None, ), # 1
    (2, TType.I32, 'lldpLocChassisIdSubtype', None, None, ), # 2
    (3, TType.STRING, 'lldpLocSysName', None, None, ), # 3
    (4, TType.STRING, 'lldpLocSysDesc', None, None, ), # 4
    (5, TType.LIST, 'lldpLocSysCapEnabled', (TType.I32,None), None, ), # 5
    (6, TType.LIST, 'lldpLocSysCapSupported', (TType.I32,None), None, ), # 6
    (7, TType.STRUCT, 'lldpLocManAddrEntry', (LldpLocManAddrEntry, LldpLocManAddrEntry.thrift_spec), None, ), # 7
    (8, TType.LIST, 'lldpLocPortTable', (TType.STRUCT,(LldpLocPortEntry, LldpLocPortEntry.thrift_spec)), None, ), # 8
  )

  def __init__(self, lldpLocChassisId=None, lldpLocChassisIdSubtype=None, lldpLocSysName=None, lldpLocSysDesc=None, lldpLocSysCapEnabled=None, lldpLocSysCapSupported=None, lldpLocManAddrEntry=None, lldpLocPortTable=None,):
    self.lldpLocChassisId = lldpLocChassisId
    self.lldpLocChassisIdSubtype = lldpLocChassisIdSubtype
    self.lldpLocSysName = lldpLocSysName
    self.lldpLocSysDesc = lldpLocSysDesc
    self.lldpLocSysCapEnabled = lldpLocSysCapEnabled
    self.lldpLocSysCapSupported = lldpLocSysCapSupported
    self.lldpLocManAddrEntry = lldpLocManAddrEntry
    self.lldpLocPortTable = lldpLocPortTable

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.lldpLocChassisId) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.I32:
          (length, self.lldpLocChassisIdSubtype) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.lldpLocSysName) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.STRING:
          (length, self.lldpLocSysDesc) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.LIST:
          self.lldpLocSysCapEnabled = []
          (length, _etype3, _size0) = iprot.readListBegin()
          read_cnt += length
          for _i4 in xrange(_size0):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem5) = iprot.readI32();
            if length < 0: return -1
            read_cnt += length
            self.lldpLocSysCapEnabled.append(_elem5)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.LIST:
          self.lldpLocSysCapSupported = []
          (length, _etype9, _size6) = iprot.readListBegin()
          read_cnt += length
          for _i10 in xrange(_size6):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem11) = iprot.readI32();
            if length < 0: return -1
            read_cnt += length
            self.lldpLocSysCapSupported.append(_elem11)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 7:
        if ftype == TType.STRUCT:
          self.lldpLocManAddrEntry = LldpLocManAddrEntry()
          read_cnt += self.lldpLocManAddrEntry.read(iprot)
        else:
          iprot.skip(ftype)
      elif fid == 8:
        if ftype == TType.LIST:
          self.lldpLocPortTable = []
          (length, _etype15, _size12) = iprot.readListBegin()
          read_cnt += length
          for _i16 in xrange(_size12):
            _elem17 = LldpLocPortEntry()
            read_cnt += _elem17.read(iprot)
            self.lldpLocPortTable.append(_elem17)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.lldpLocChassisId is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocChassisId', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.lldpLocChassisId) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpLocChassisIdSubtype is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocChassisIdSubtype', TType.I32, 2, annotations) < 0: return -1
      if oprot.writeI32(self.lldpLocChassisIdSubtype) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpLocSysName is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocSysName', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.lldpLocSysName) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpLocSysDesc is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocSysDesc', TType.STRING, 4, annotations) < 0: return -1
      if oprot.writeString(self.lldpLocSysDesc) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpLocSysCapEnabled is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocSysCapEnabled', TType.LIST, 5, annotations) < 0: return -1
      if oprot.writeListBegin(TType.I32, len(self.lldpLocSysCapEnabled)) < 0: return -1
      for iter18 in self.lldpLocSysCapEnabled:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeI32(iter18) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpLocSysCapSupported is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocSysCapSupported', TType.LIST, 6, annotations) < 0: return -1
      if oprot.writeListBegin(TType.I32, len(self.lldpLocSysCapSupported)) < 0: return -1
      for iter19 in self.lldpLocSysCapSupported:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeI32(iter19) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpLocManAddrEntry is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocManAddrEntry', TType.STRUCT, 7, annotations) < 0: return -1
      if self.lldpLocManAddrEntry.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpLocPortTable is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocPortTable', TType.LIST, 8, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.lldpLocPortTable)) < 0: return -1
      for iter20 in self.lldpLocPortTable:
        if iter20.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.lldpLocChassisId is not None:
      log_str.write('lldpLocChassisId = ')
      log_str.write(self.lldpLocChassisId)
      log_str.write('  ')
    if self.lldpLocChassisIdSubtype is not None:
      log_str.write('lldpLocChassisIdSubtype = ')
      log_str.write(str(self.lldpLocChassisIdSubtype))
      log_str.write('  ')
    if self.lldpLocSysName is not None:
      log_str.write('lldpLocSysName = ')
      log_str.write(self.lldpLocSysName)
      log_str.write('  ')
    if self.lldpLocSysDesc is not None:
      log_str.write('lldpLocSysDesc = ')
      log_str.write(self.lldpLocSysDesc)
      log_str.write('  ')
    if self.lldpLocSysCapEnabled is not None:
      log_str.write('lldpLocSysCapEnabled = ')
      log_str.write('[ ')
      for iter21 in self.lldpLocSysCapEnabled:
        log_str.write(str(iter21))
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.lldpLocSysCapSupported is not None:
      log_str.write('lldpLocSysCapSupported = ')
      log_str.write('[ ')
      for iter22 in self.lldpLocSysCapSupported:
        log_str.write(str(iter22))
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.lldpLocManAddrEntry is not None:
      log_str.write('lldpLocManAddrEntry = ')
      log_str.write('<<  ')
      log_str.write(self.lldpLocManAddrEntry.log())
      log_str.write('>>')
      log_str.write('  ')
    if self.lldpLocPortTable is not None:
      log_str.write('lldpLocPortTable = ')
      log_str.write('[ ')
      for iter23 in self.lldpLocPortTable:
        log_str.write('<<  ')
        log_str.write(iter23.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.lldpLocChassisId is not None:
      size += getsizeof(self.lldpLocChassisId)
    if self.lldpLocChassisIdSubtype is not None:
      size += getsizeof(self.lldpLocChassisIdSubtype)
    if self.lldpLocSysName is not None:
      size += getsizeof(self.lldpLocSysName)
    if self.lldpLocSysDesc is not None:
      size += getsizeof(self.lldpLocSysDesc)
    if self.lldpLocSysCapEnabled is not None:
      size += getsizeof(self.lldpLocSysCapEnabled)
      size += sum(map(getsizeof, self.lldpLocSysCapEnabled))
    if self.lldpLocSysCapSupported is not None:
      size += getsizeof(self.lldpLocSysCapSupported)
      size += sum(map(getsizeof, self.lldpLocSysCapSupported))
    if self.lldpLocManAddrEntry is not None:
      size += getsizeof(self.lldpLocManAddrEntry)
    if self.lldpLocPortTable is not None:
      size += getsizeof(self.lldpLocPortTable)
      size += sum(map(getsizeof, self.lldpLocPortTable))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class LldpRemOrgDefInfoTable(object):
  """
  Attributes:
   - lldpRemOrgDefInfo
   - lldpRemOrgDefInfoIndex
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'lldpRemOrgDefInfo', None, None, ), # 1
    (2, TType.I32, 'lldpRemOrgDefInfoIndex', None, None, ), # 2
  )

  def __init__(self, lldpRemOrgDefInfo=None, lldpRemOrgDefInfoIndex=None,):
    self.lldpRemOrgDefInfo = lldpRemOrgDefInfo
    self.lldpRemOrgDefInfoIndex = lldpRemOrgDefInfoIndex

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.lldpRemOrgDefInfo) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.I32:
          (length, self.lldpRemOrgDefInfoIndex) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.lldpRemOrgDefInfo is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemOrgDefInfo', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.lldpRemOrgDefInfo) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemOrgDefInfoIndex is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemOrgDefInfoIndex', TType.I32, 2, annotations) < 0: return -1
      if oprot.writeI32(self.lldpRemOrgDefInfoIndex) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.lldpRemOrgDefInfo is not None:
      log_str.write('lldpRemOrgDefInfo = ')
      log_str.write(self.lldpRemOrgDefInfo)
      log_str.write('  ')
    if self.lldpRemOrgDefInfoIndex is not None:
      log_str.write('lldpRemOrgDefInfoIndex = ')
      log_str.write(str(self.lldpRemOrgDefInfoIndex))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.lldpRemOrgDefInfo is not None:
      size += getsizeof(self.lldpRemOrgDefInfo)
    if self.lldpRemOrgDefInfoIndex is not None:
      size += getsizeof(self.lldpRemOrgDefInfoIndex)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class LldpRemOrgDefInfoEntry(object):
  """
  Attributes:
   - lldpRemOrgDefInfoOUI
   - lldpRemOrgDefInfoSubtype
   - lldpRemOrgDefInfoTable
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'lldpRemOrgDefInfoOUI', None, None, ), # 1
    (2, TType.I32, 'lldpRemOrgDefInfoSubtype', None, None, ), # 2
    (3, TType.LIST, 'lldpRemOrgDefInfoTable', (TType.STRUCT,(LldpRemOrgDefInfoTable, LldpRemOrgDefInfoTable.thrift_spec)), None, ), # 3
  )

  def __init__(self, lldpRemOrgDefInfoOUI=None, lldpRemOrgDefInfoSubtype=None, lldpRemOrgDefInfoTable=None,):
    self.lldpRemOrgDefInfoOUI = lldpRemOrgDefInfoOUI
    self.lldpRemOrgDefInfoSubtype = lldpRemOrgDefInfoSubtype
    self.lldpRemOrgDefInfoTable = lldpRemOrgDefInfoTable

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.lldpRemOrgDefInfoOUI) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.I32:
          (length, self.lldpRemOrgDefInfoSubtype) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.LIST:
          self.lldpRemOrgDefInfoTable = []
          (length, _etype27, _size24) = iprot.readListBegin()
          read_cnt += length
          for _i28 in xrange(_size24):
            _elem29 = LldpRemOrgDefInfoTable()
            read_cnt += _elem29.read(iprot)
            self.lldpRemOrgDefInfoTable.append(_elem29)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.lldpRemOrgDefInfoOUI is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemOrgDefInfoOUI', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.lldpRemOrgDefInfoOUI) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemOrgDefInfoSubtype is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemOrgDefInfoSubtype', TType.I32, 2, annotations) < 0: return -1
      if oprot.writeI32(self.lldpRemOrgDefInfoSubtype) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemOrgDefInfoTable is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemOrgDefInfoTable', TType.LIST, 3, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.lldpRemOrgDefInfoTable)) < 0: return -1
      for iter30 in self.lldpRemOrgDefInfoTable:
        if iter30.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.lldpRemOrgDefInfoOUI is not None:
      log_str.write('lldpRemOrgDefInfoOUI = ')
      log_str.write(self.lldpRemOrgDefInfoOUI)
      log_str.write('  ')
    if self.lldpRemOrgDefInfoSubtype is not None:
      log_str.write('lldpRemOrgDefInfoSubtype = ')
      log_str.write(str(self.lldpRemOrgDefInfoSubtype))
      log_str.write('  ')
    if self.lldpRemOrgDefInfoTable is not None:
      log_str.write('lldpRemOrgDefInfoTable = ')
      log_str.write('[ ')
      for iter31 in self.lldpRemOrgDefInfoTable:
        log_str.write('<<  ')
        log_str.write(iter31.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.lldpRemOrgDefInfoOUI is not None:
      size += getsizeof(self.lldpRemOrgDefInfoOUI)
    if self.lldpRemOrgDefInfoSubtype is not None:
      size += getsizeof(self.lldpRemOrgDefInfoSubtype)
    if self.lldpRemOrgDefInfoTable is not None:
      size += getsizeof(self.lldpRemOrgDefInfoTable)
      size += sum(map(getsizeof, self.lldpRemOrgDefInfoTable))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class LldpRemManAddrEntry(object):
  """
  Attributes:
   - lldpRemManAddr
   - lldpRemManAddrOID
   - lldpRemManAddrIfId
   - lldpRemManAddrIfSubtype
   - lldpRemManAddrOIDLen
   - lldpRemManAddrSubtype
   - lldpRemTimeMark
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'lldpRemManAddr', None, None, ), # 1
    (2, TType.STRING, 'lldpRemManAddrOID', None, None, ), # 2
    (3, TType.I32, 'lldpRemManAddrIfId', None, None, ), # 3
    (4, TType.I32, 'lldpRemManAddrIfSubtype', None, None, ), # 4
    (5, TType.I32, 'lldpRemManAddrOIDLen', None, None, ), # 5
    (6, TType.I32, 'lldpRemManAddrSubtype', None, None, ), # 6
    (7, TType.I32, 'lldpRemTimeMark', None, None, ), # 7
  )

  def __init__(self, lldpRemManAddr=None, lldpRemManAddrOID=None, lldpRemManAddrIfId=None, lldpRemManAddrIfSubtype=None, lldpRemManAddrOIDLen=None, lldpRemManAddrSubtype=None, lldpRemTimeMark=None,):
    self.lldpRemManAddr = lldpRemManAddr
    self.lldpRemManAddrOID = lldpRemManAddrOID
    self.lldpRemManAddrIfId = lldpRemManAddrIfId
    self.lldpRemManAddrIfSubtype = lldpRemManAddrIfSubtype
    self.lldpRemManAddrOIDLen = lldpRemManAddrOIDLen
    self.lldpRemManAddrSubtype = lldpRemManAddrSubtype
    self.lldpRemTimeMark = lldpRemTimeMark

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.lldpRemManAddr) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.lldpRemManAddrOID) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.I32:
          (length, self.lldpRemManAddrIfId) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.I32:
          (length, self.lldpRemManAddrIfSubtype) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.I32:
          (length, self.lldpRemManAddrOIDLen) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.I32:
          (length, self.lldpRemManAddrSubtype) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 7:
        if ftype == TType.I32:
          (length, self.lldpRemTimeMark) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.lldpRemManAddr is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemManAddr', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.lldpRemManAddr) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemManAddrOID is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemManAddrOID', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.lldpRemManAddrOID) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemManAddrIfId is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemManAddrIfId', TType.I32, 3, annotations) < 0: return -1
      if oprot.writeI32(self.lldpRemManAddrIfId) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemManAddrIfSubtype is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemManAddrIfSubtype', TType.I32, 4, annotations) < 0: return -1
      if oprot.writeI32(self.lldpRemManAddrIfSubtype) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemManAddrOIDLen is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemManAddrOIDLen', TType.I32, 5, annotations) < 0: return -1
      if oprot.writeI32(self.lldpRemManAddrOIDLen) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemManAddrSubtype is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemManAddrSubtype', TType.I32, 6, annotations) < 0: return -1
      if oprot.writeI32(self.lldpRemManAddrSubtype) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemTimeMark is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemTimeMark', TType.I32, 7, annotations) < 0: return -1
      if oprot.writeI32(self.lldpRemTimeMark) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.lldpRemManAddr is not None:
      log_str.write('lldpRemManAddr = ')
      log_str.write(self.lldpRemManAddr)
      log_str.write('  ')
    if self.lldpRemManAddrOID is not None:
      log_str.write('lldpRemManAddrOID = ')
      log_str.write(self.lldpRemManAddrOID)
      log_str.write('  ')
    if self.lldpRemManAddrIfId is not None:
      log_str.write('lldpRemManAddrIfId = ')
      log_str.write(str(self.lldpRemManAddrIfId))
      log_str.write('  ')
    if self.lldpRemManAddrIfSubtype is not None:
      log_str.write('lldpRemManAddrIfSubtype = ')
      log_str.write(str(self.lldpRemManAddrIfSubtype))
      log_str.write('  ')
    if self.lldpRemManAddrOIDLen is not None:
      log_str.write('lldpRemManAddrOIDLen = ')
      log_str.write(str(self.lldpRemManAddrOIDLen))
      log_str.write('  ')
    if self.lldpRemManAddrSubtype is not None:
      log_str.write('lldpRemManAddrSubtype = ')
      log_str.write(str(self.lldpRemManAddrSubtype))
      log_str.write('  ')
    if self.lldpRemTimeMark is not None:
      log_str.write('lldpRemTimeMark = ')
      log_str.write(str(self.lldpRemTimeMark))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.lldpRemManAddr is not None:
      size += getsizeof(self.lldpRemManAddr)
    if self.lldpRemManAddrOID is not None:
      size += getsizeof(self.lldpRemManAddrOID)
    if self.lldpRemManAddrIfId is not None:
      size += getsizeof(self.lldpRemManAddrIfId)
    if self.lldpRemManAddrIfSubtype is not None:
      size += getsizeof(self.lldpRemManAddrIfSubtype)
    if self.lldpRemManAddrOIDLen is not None:
      size += getsizeof(self.lldpRemManAddrOIDLen)
    if self.lldpRemManAddrSubtype is not None:
      size += getsizeof(self.lldpRemManAddrSubtype)
    if self.lldpRemTimeMark is not None:
      size += getsizeof(self.lldpRemTimeMark)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class LldpRemoteSystemsData(object):
  """
  Attributes:
   - lldpRemChassisId
   - lldpRemChassisIdSubtype
   - lldpRemIndex
   - lldpRemLocalPortNum
   - lldpRemPortDesc
   - lldpRemPortId
   - lldpRemPortIdSubtype
   - lldpRemSysCapEnabled
   - lldpRemSysCapSupported
   - lldpRemSysName
   - lldpRemSysDesc
   - lldpRemTimeMark
   - lldpRemOrgDefInfoEntry
   - lldpRemManAddrEntry
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'lldpRemChassisId', None, None, ), # 1
    (2, TType.I32, 'lldpRemChassisIdSubtype', None, None, ), # 2
    (3, TType.I32, 'lldpRemIndex', None, None, ), # 3
    (4, TType.I32, 'lldpRemLocalPortNum', None, None, ), # 4
    (5, TType.STRING, 'lldpRemPortDesc', None, None, ), # 5
    (6, TType.STRING, 'lldpRemPortId', None, None, ), # 6
    (7, TType.I32, 'lldpRemPortIdSubtype', None, None, ), # 7
    (8, TType.LIST, 'lldpRemSysCapEnabled', (TType.I32,None), None, ), # 8
    (9, TType.LIST, 'lldpRemSysCapSupported', (TType.I32,None), None, ), # 9
    (10, TType.STRING, 'lldpRemSysName', None, None, ), # 10
    (11, TType.STRING, 'lldpRemSysDesc', None, None, ), # 11
    (12, TType.I32, 'lldpRemTimeMark', None, None, ), # 12
    (13, TType.STRUCT, 'lldpRemOrgDefInfoEntry', (LldpRemOrgDefInfoEntry, LldpRemOrgDefInfoEntry.thrift_spec), None, ), # 13
    (14, TType.STRUCT, 'lldpRemManAddrEntry', (LldpRemManAddrEntry, LldpRemManAddrEntry.thrift_spec), None, ), # 14
  )

  def __init__(self, lldpRemChassisId=None, lldpRemChassisIdSubtype=None, lldpRemIndex=None, lldpRemLocalPortNum=None, lldpRemPortDesc=None, lldpRemPortId=None, lldpRemPortIdSubtype=None, lldpRemSysCapEnabled=None, lldpRemSysCapSupported=None, lldpRemSysName=None, lldpRemSysDesc=None, lldpRemTimeMark=None, lldpRemOrgDefInfoEntry=None, lldpRemManAddrEntry=None,):
    self.lldpRemChassisId = lldpRemChassisId
    self.lldpRemChassisIdSubtype = lldpRemChassisIdSubtype
    self.lldpRemIndex = lldpRemIndex
    self.lldpRemLocalPortNum = lldpRemLocalPortNum
    self.lldpRemPortDesc = lldpRemPortDesc
    self.lldpRemPortId = lldpRemPortId
    self.lldpRemPortIdSubtype = lldpRemPortIdSubtype
    self.lldpRemSysCapEnabled = lldpRemSysCapEnabled
    self.lldpRemSysCapSupported = lldpRemSysCapSupported
    self.lldpRemSysName = lldpRemSysName
    self.lldpRemSysDesc = lldpRemSysDesc
    self.lldpRemTimeMark = lldpRemTimeMark
    self.lldpRemOrgDefInfoEntry = lldpRemOrgDefInfoEntry
    self.lldpRemManAddrEntry = lldpRemManAddrEntry

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.lldpRemChassisId) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.I32:
          (length, self.lldpRemChassisIdSubtype) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.I32:
          (length, self.lldpRemIndex) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.I32:
          (length, self.lldpRemLocalPortNum) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.STRING:
          (length, self.lldpRemPortDesc) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.STRING:
          (length, self.lldpRemPortId) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 7:
        if ftype == TType.I32:
          (length, self.lldpRemPortIdSubtype) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 8:
        if ftype == TType.LIST:
          self.lldpRemSysCapEnabled = []
          (length, _etype35, _size32) = iprot.readListBegin()
          read_cnt += length
          for _i36 in xrange(_size32):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem37) = iprot.readI32();
            if length < 0: return -1
            read_cnt += length
            self.lldpRemSysCapEnabled.append(_elem37)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 9:
        if ftype == TType.LIST:
          self.lldpRemSysCapSupported = []
          (length, _etype41, _size38) = iprot.readListBegin()
          read_cnt += length
          for _i42 in xrange(_size38):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem43) = iprot.readI32();
            if length < 0: return -1
            read_cnt += length
            self.lldpRemSysCapSupported.append(_elem43)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 10:
        if ftype == TType.STRING:
          (length, self.lldpRemSysName) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 11:
        if ftype == TType.STRING:
          (length, self.lldpRemSysDesc) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 12:
        if ftype == TType.I32:
          (length, self.lldpRemTimeMark) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 13:
        if ftype == TType.STRUCT:
          self.lldpRemOrgDefInfoEntry = LldpRemOrgDefInfoEntry()
          read_cnt += self.lldpRemOrgDefInfoEntry.read(iprot)
        else:
          iprot.skip(ftype)
      elif fid == 14:
        if ftype == TType.STRUCT:
          self.lldpRemManAddrEntry = LldpRemManAddrEntry()
          read_cnt += self.lldpRemManAddrEntry.read(iprot)
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.lldpRemChassisId is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemChassisId', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.lldpRemChassisId) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemChassisIdSubtype is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemChassisIdSubtype', TType.I32, 2, annotations) < 0: return -1
      if oprot.writeI32(self.lldpRemChassisIdSubtype) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemIndex is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemIndex', TType.I32, 3, annotations) < 0: return -1
      if oprot.writeI32(self.lldpRemIndex) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemLocalPortNum is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemLocalPortNum', TType.I32, 4, annotations) < 0: return -1
      if oprot.writeI32(self.lldpRemLocalPortNum) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemPortDesc is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemPortDesc', TType.STRING, 5, annotations) < 0: return -1
      if oprot.writeString(self.lldpRemPortDesc) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemPortId is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemPortId', TType.STRING, 6, annotations) < 0: return -1
      if oprot.writeString(self.lldpRemPortId) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemPortIdSubtype is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemPortIdSubtype', TType.I32, 7, annotations) < 0: return -1
      if oprot.writeI32(self.lldpRemPortIdSubtype) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemSysCapEnabled is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemSysCapEnabled', TType.LIST, 8, annotations) < 0: return -1
      if oprot.writeListBegin(TType.I32, len(self.lldpRemSysCapEnabled)) < 0: return -1
      for iter44 in self.lldpRemSysCapEnabled:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeI32(iter44) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemSysCapSupported is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemSysCapSupported', TType.LIST, 9, annotations) < 0: return -1
      if oprot.writeListBegin(TType.I32, len(self.lldpRemSysCapSupported)) < 0: return -1
      for iter45 in self.lldpRemSysCapSupported:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeI32(iter45) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemSysName is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemSysName', TType.STRING, 10, annotations) < 0: return -1
      if oprot.writeString(self.lldpRemSysName) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemSysDesc is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemSysDesc', TType.STRING, 11, annotations) < 0: return -1
      if oprot.writeString(self.lldpRemSysDesc) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemTimeMark is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemTimeMark', TType.I32, 12, annotations) < 0: return -1
      if oprot.writeI32(self.lldpRemTimeMark) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemOrgDefInfoEntry is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemOrgDefInfoEntry', TType.STRUCT, 13, annotations) < 0: return -1
      if self.lldpRemOrgDefInfoEntry.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemManAddrEntry is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemManAddrEntry', TType.STRUCT, 14, annotations) < 0: return -1
      if self.lldpRemManAddrEntry.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.lldpRemChassisId is not None:
      log_str.write('lldpRemChassisId = ')
      log_str.write(self.lldpRemChassisId)
      log_str.write('  ')
    if self.lldpRemChassisIdSubtype is not None:
      log_str.write('lldpRemChassisIdSubtype = ')
      log_str.write(str(self.lldpRemChassisIdSubtype))
      log_str.write('  ')
    if self.lldpRemIndex is not None:
      log_str.write('lldpRemIndex = ')
      log_str.write(str(self.lldpRemIndex))
      log_str.write('  ')
    if self.lldpRemLocalPortNum is not None:
      log_str.write('lldpRemLocalPortNum = ')
      log_str.write(str(self.lldpRemLocalPortNum))
      log_str.write('  ')
    if self.lldpRemPortDesc is not None:
      log_str.write('lldpRemPortDesc = ')
      log_str.write(self.lldpRemPortDesc)
      log_str.write('  ')
    if self.lldpRemPortId is not None:
      log_str.write('lldpRemPortId = ')
      log_str.write(self.lldpRemPortId)
      log_str.write('  ')
    if self.lldpRemPortIdSubtype is not None:
      log_str.write('lldpRemPortIdSubtype = ')
      log_str.write(str(self.lldpRemPortIdSubtype))
      log_str.write('  ')
    if self.lldpRemSysCapEnabled is not None:
      log_str.write('lldpRemSysCapEnabled = ')
      log_str.write('[ ')
      for iter46 in self.lldpRemSysCapEnabled:
        log_str.write(str(iter46))
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.lldpRemSysCapSupported is not None:
      log_str.write('lldpRemSysCapSupported = ')
      log_str.write('[ ')
      for iter47 in self.lldpRemSysCapSupported:
        log_str.write(str(iter47))
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.lldpRemSysName is not None:
      log_str.write('lldpRemSysName = ')
      log_str.write(self.lldpRemSysName)
      log_str.write('  ')
    if self.lldpRemSysDesc is not None:
      log_str.write('lldpRemSysDesc = ')
      log_str.write(self.lldpRemSysDesc)
      log_str.write('  ')
    if self.lldpRemTimeMark is not None:
      log_str.write('lldpRemTimeMark = ')
      log_str.write(str(self.lldpRemTimeMark))
      log_str.write('  ')
    if self.lldpRemOrgDefInfoEntry is not None:
      log_str.write('lldpRemOrgDefInfoEntry = ')
      log_str.write('<<  ')
      log_str.write(self.lldpRemOrgDefInfoEntry.log())
      log_str.write('>>')
      log_str.write('  ')
    if self.lldpRemManAddrEntry is not None:
      log_str.write('lldpRemManAddrEntry = ')
      log_str.write('<<  ')
      log_str.write(self.lldpRemManAddrEntry.log())
      log_str.write('>>')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.lldpRemChassisId is not None:
      size += getsizeof(self.lldpRemChassisId)
    if self.lldpRemChassisIdSubtype is not None:
      size += getsizeof(self.lldpRemChassisIdSubtype)
    if self.lldpRemIndex is not None:
      size += getsizeof(self.lldpRemIndex)
    if self.lldpRemLocalPortNum is not None:
      size += getsizeof(self.lldpRemLocalPortNum)
    if self.lldpRemPortDesc is not None:
      size += getsizeof(self.lldpRemPortDesc)
    if self.lldpRemPortId is not None:
      size += getsizeof(self.lldpRemPortId)
    if self.lldpRemPortIdSubtype is not None:
      size += getsizeof(self.lldpRemPortIdSubtype)
    if self.lldpRemSysCapEnabled is not None:
      size += getsizeof(self.lldpRemSysCapEnabled)
      size += sum(map(getsizeof, self.lldpRemSysCapEnabled))
    if self.lldpRemSysCapSupported is not None:
      size += getsizeof(self.lldpRemSysCapSupported)
      size += sum(map(getsizeof, self.lldpRemSysCapSupported))
    if self.lldpRemSysName is not None:
      size += getsizeof(self.lldpRemSysName)
    if self.lldpRemSysDesc is not None:
      size += getsizeof(self.lldpRemSysDesc)
    if self.lldpRemTimeMark is not None:
      size += getsizeof(self.lldpRemTimeMark)
    if self.lldpRemOrgDefInfoEntry is not None:
      size += getsizeof(self.lldpRemOrgDefInfoEntry)
    if self.lldpRemManAddrEntry is not None:
      size += getsizeof(self.lldpRemManAddrEntry)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class LldpTable(object):
  """
  stores LLDP information collected from physical router

  Attributes:
   - lldpLocalSystemData
   - lldpRemoteSystemsData
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRUCT, 'lldpLocalSystemData', (LldpLocalSystemData, LldpLocalSystemData.thrift_spec), None, ), # 1
    (2, TType.LIST, 'lldpRemoteSystemsData', (TType.STRUCT,(LldpRemoteSystemsData, LldpRemoteSystemsData.thrift_spec)), None, ), # 2
  )

  def __init__(self, lldpLocalSystemData=None, lldpRemoteSystemsData=None,):
    self.lldpLocalSystemData = lldpLocalSystemData
    self.lldpRemoteSystemsData = lldpRemoteSystemsData

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRUCT:
          self.lldpLocalSystemData = LldpLocalSystemData()
          read_cnt += self.lldpLocalSystemData.read(iprot)
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.LIST:
          self.lldpRemoteSystemsData = []
          (length, _etype51, _size48) = iprot.readListBegin()
          read_cnt += length
          for _i52 in xrange(_size48):
            _elem53 = LldpRemoteSystemsData()
            read_cnt += _elem53.read(iprot)
            self.lldpRemoteSystemsData.append(_elem53)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.lldpLocalSystemData is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpLocalSystemData', TType.STRUCT, 1, annotations) < 0: return -1
      if self.lldpLocalSystemData.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpRemoteSystemsData is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpRemoteSystemsData', TType.LIST, 2, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.lldpRemoteSystemsData)) < 0: return -1
      for iter54 in self.lldpRemoteSystemsData:
        if iter54.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.lldpLocalSystemData is not None:
      log_str.write('lldpLocalSystemData = ')
      log_str.write('<<  ')
      log_str.write(self.lldpLocalSystemData.log())
      log_str.write('>>')
      log_str.write('  ')
    if self.lldpRemoteSystemsData is not None:
      log_str.write('lldpRemoteSystemsData = ')
      log_str.write('[ ')
      for iter55 in self.lldpRemoteSystemsData:
        log_str.write('<<  ')
        log_str.write(iter55.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.lldpLocalSystemData is not None:
      size += getsizeof(self.lldpLocalSystemData)
    if self.lldpRemoteSystemsData is not None:
      size += getsizeof(self.lldpRemoteSystemsData)
      size += sum(map(getsizeof, self.lldpRemoteSystemsData))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class dot1qTpFdbPortTable(object):
  """
  Attributes:
   - mac
   - dot1dBasePortIfIndex
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'mac', None, None, ), # 1
    (2, TType.I32, 'dot1dBasePortIfIndex', None, None, ), # 2
  )

  def __init__(self, mac=None, dot1dBasePortIfIndex=None,):
    self.mac = mac
    self.dot1dBasePortIfIndex = dot1dBasePortIfIndex

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.mac) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.I32:
          (length, self.dot1dBasePortIfIndex) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.mac is not None:
      annotations = {}
      if oprot.writeFieldBegin('mac', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.mac) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.dot1dBasePortIfIndex is not None:
      annotations = {}
      if oprot.writeFieldBegin('dot1dBasePortIfIndex', TType.I32, 2, annotations) < 0: return -1
      if oprot.writeI32(self.dot1dBasePortIfIndex) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.mac is not None:
      log_str.write('mac = ')
      log_str.write(self.mac)
      log_str.write('  ')
    if self.dot1dBasePortIfIndex is not None:
      log_str.write('dot1dBasePortIfIndex = ')
      log_str.write(str(self.dot1dBasePortIfIndex))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.mac is not None:
      size += getsizeof(self.mac)
    if self.dot1dBasePortIfIndex is not None:
      size += getsizeof(self.dot1dBasePortIfIndex)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class dot1dBasePortIfIndexTable(object):
  """
  Attributes:
   - dot1dBasePortIfIndex
   - snmpIfIndex
  """

  thrift_spec = (
    None, # 0
    (1, TType.I32, 'dot1dBasePortIfIndex', None, None, ), # 1
    (2, TType.I32, 'snmpIfIndex', None, None, ), # 2
  )

  def __init__(self, dot1dBasePortIfIndex=None, snmpIfIndex=None,):
    self.dot1dBasePortIfIndex = dot1dBasePortIfIndex
    self.snmpIfIndex = snmpIfIndex

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.I32:
          (length, self.dot1dBasePortIfIndex) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.I32:
          (length, self.snmpIfIndex) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.dot1dBasePortIfIndex is not None:
      annotations = {}
      if oprot.writeFieldBegin('dot1dBasePortIfIndex', TType.I32, 1, annotations) < 0: return -1
      if oprot.writeI32(self.dot1dBasePortIfIndex) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.snmpIfIndex is not None:
      annotations = {}
      if oprot.writeFieldBegin('snmpIfIndex', TType.I32, 2, annotations) < 0: return -1
      if oprot.writeI32(self.snmpIfIndex) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.dot1dBasePortIfIndex is not None:
      log_str.write('dot1dBasePortIfIndex = ')
      log_str.write(str(self.dot1dBasePortIfIndex))
      log_str.write('  ')
    if self.snmpIfIndex is not None:
      log_str.write('snmpIfIndex = ')
      log_str.write(str(self.snmpIfIndex))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.dot1dBasePortIfIndex is not None:
      size += getsizeof(self.dot1dBasePortIfIndex)
    if self.snmpIfIndex is not None:
      size += getsizeof(self.snmpIfIndex)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class IfIndexOperStatusTable(object):
  """
  stores interface status information collected from physical router

  Attributes:
   - ifIndex
   - ifOperStatus
  """

  thrift_spec = (
    None, # 0
    (1, TType.U32, 'ifIndex', None, None, ), # 1
    (2, TType.U32, 'ifOperStatus', None, None, ), # 2
  )

  def __init__(self, ifIndex=None, ifOperStatus=None,):
    self.ifIndex = ifIndex
    self.ifOperStatus = ifOperStatus

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.U32:
          (length, self.ifIndex) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.U32:
          (length, self.ifOperStatus) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.ifIndex is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifIndex', TType.U32, 1, annotations) < 0: return -1
      if oprot.writeU32(self.ifIndex) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifOperStatus is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifOperStatus', TType.U32, 2, annotations) < 0: return -1
      if oprot.writeU32(self.ifOperStatus) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.ifIndex is not None:
      log_str.write('ifIndex = ')
      log_str.write(str(self.ifIndex))
      log_str.write('  ')
    if self.ifOperStatus is not None:
      log_str.write('ifOperStatus = ')
      log_str.write(str(self.ifOperStatus))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.ifIndex is not None:
      size += getsizeof(self.ifIndex)
    if self.ifOperStatus is not None:
      size += getsizeof(self.ifOperStatus)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PRouterEntry(object):
  """
  Physical Router UVE data provided by contrail-snmp-collector.
  This includes the raw SNMP tables polled from the physical router.

  Attributes:
   - name
   - deleted
   - lldpTable
   - arpTable
   - ifTable
   - ifXTable
   - ifStats
   - ipMib
   - fdbPortTable
   - fdbPortIfIndexTable
   - ifIndexOperStatusTable
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.BOOL, 'deleted', None, None, ), # 2
    (3, TType.STRUCT, 'lldpTable', (LldpTable, LldpTable.thrift_spec), None, ), # 3
    (4, TType.LIST, 'arpTable', (TType.STRUCT,(ArpTable, ArpTable.thrift_spec)), None, ), # 4
    (5, TType.LIST, 'ifTable', (TType.STRUCT,(IfTable, IfTable.thrift_spec)), None, ), # 5
    (6, TType.LIST, 'ifXTable', (TType.STRUCT,(IfXTable, IfXTable.thrift_spec)), None, ), # 6
    (7, TType.LIST, 'ifStats', (TType.STRUCT,(IfStats, IfStats.thrift_spec)), None, ), # 7
    (8, TType.LIST, 'ipMib', (TType.STRUCT,(IpMib, IpMib.thrift_spec)), None, ), # 8
    (9, TType.LIST, 'fdbPortTable', (TType.STRUCT,(dot1qTpFdbPortTable, dot1qTpFdbPortTable.thrift_spec)), None, ), # 9
    (10, TType.LIST, 'fdbPortIfIndexTable', (TType.STRUCT,(dot1dBasePortIfIndexTable, dot1dBasePortIfIndexTable.thrift_spec)), None, ), # 10
    (11, TType.LIST, 'ifIndexOperStatusTable', (TType.STRUCT,(IfIndexOperStatusTable, IfIndexOperStatusTable.thrift_spec)), None, ), # 11
  )

  def __init__(self, name=None, deleted=None, lldpTable=None, arpTable=None, ifTable=None, ifXTable=None, ifStats=None, ipMib=None, fdbPortTable=None, fdbPortIfIndexTable=None, ifIndexOperStatusTable=None,):
    self.name = name
    self.deleted = deleted
    self.lldpTable = lldpTable
    self.arpTable = arpTable
    self.ifTable = ifTable
    self.ifXTable = ifXTable
    self.ifStats = ifStats
    self.ipMib = ipMib
    self.fdbPortTable = fdbPortTable
    self.fdbPortIfIndexTable = fdbPortIfIndexTable
    self.ifIndexOperStatusTable = ifIndexOperStatusTable
    self._table = 'ObjectPRouter'

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.BOOL:
          (length, self.deleted) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRUCT:
          self.lldpTable = LldpTable()
          read_cnt += self.lldpTable.read(iprot)
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.LIST:
          self.arpTable = []
          (length, _etype59, _size56) = iprot.readListBegin()
          read_cnt += length
          for _i60 in xrange(_size56):
            _elem61 = ArpTable()
            read_cnt += _elem61.read(iprot)
            self.arpTable.append(_elem61)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.LIST:
          self.ifTable = []
          (length, _etype65, _size62) = iprot.readListBegin()
          read_cnt += length
          for _i66 in xrange(_size62):
            _elem67 = IfTable()
            read_cnt += _elem67.read(iprot)
            self.ifTable.append(_elem67)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.LIST:
          self.ifXTable = []
          (length, _etype71, _size68) = iprot.readListBegin()
          read_cnt += length
          for _i72 in xrange(_size68):
            _elem73 = IfXTable()
            read_cnt += _elem73.read(iprot)
            self.ifXTable.append(_elem73)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 7:
        if ftype == TType.LIST:
          self.ifStats = []
          (length, _etype77, _size74) = iprot.readListBegin()
          read_cnt += length
          for _i78 in xrange(_size74):
            _elem79 = IfStats()
            read_cnt += _elem79.read(iprot)
            self.ifStats.append(_elem79)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 8:
        if ftype == TType.LIST:
          self.ipMib = []
          (length, _etype83, _size80) = iprot.readListBegin()
          read_cnt += length
          for _i84 in xrange(_size80):
            _elem85 = IpMib()
            read_cnt += _elem85.read(iprot)
            self.ipMib.append(_elem85)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 9:
        if ftype == TType.LIST:
          self.fdbPortTable = []
          (length, _etype89, _size86) = iprot.readListBegin()
          read_cnt += length
          for _i90 in xrange(_size86):
            _elem91 = dot1qTpFdbPortTable()
            read_cnt += _elem91.read(iprot)
            self.fdbPortTable.append(_elem91)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 10:
        if ftype == TType.LIST:
          self.fdbPortIfIndexTable = []
          (length, _etype95, _size92) = iprot.readListBegin()
          read_cnt += length
          for _i96 in xrange(_size92):
            _elem97 = dot1dBasePortIfIndexTable()
            read_cnt += _elem97.read(iprot)
            self.fdbPortIfIndexTable.append(_elem97)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 11:
        if ftype == TType.LIST:
          self.ifIndexOperStatusTable = []
          (length, _etype101, _size98) = iprot.readListBegin()
          read_cnt += length
          for _i102 in xrange(_size98):
            _elem103 = IfIndexOperStatusTable()
            read_cnt += _elem103.read(iprot)
            self.ifIndexOperStatusTable.append(_elem103)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if self._table is None or self._table is '': return -1
      annotations['key'] = self._table
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.deleted is not None:
      annotations = {}
      if oprot.writeFieldBegin('deleted', TType.BOOL, 2, annotations) < 0: return -1
      if oprot.writeBool(self.deleted) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.lldpTable is not None:
      annotations = {}
      if oprot.writeFieldBegin('lldpTable', TType.STRUCT, 3, annotations) < 0: return -1
      if self.lldpTable.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.arpTable is not None:
      annotations = {}
      if oprot.writeFieldBegin('arpTable', TType.LIST, 4, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.arpTable)) < 0: return -1
      for iter104 in self.arpTable:
        if iter104.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifTable is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifTable', TType.LIST, 5, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.ifTable)) < 0: return -1
      for iter105 in self.ifTable:
        if iter105.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifXTable is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifXTable', TType.LIST, 6, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.ifXTable)) < 0: return -1
      for iter106 in self.ifXTable:
        if iter106.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifStats is not None:
      annotations = {}
      annotations['tags'] = 'name:.ifIndex,name:.ifName'
      if oprot.writeFieldBegin('ifStats', TType.LIST, 7, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.ifStats)) < 0: return -1
      for iter107 in self.ifStats:
        if iter107.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ipMib is not None:
      annotations = {}
      if oprot.writeFieldBegin('ipMib', TType.LIST, 8, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.ipMib)) < 0: return -1
      for iter108 in self.ipMib:
        if iter108.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.fdbPortTable is not None:
      annotations = {}
      if oprot.writeFieldBegin('fdbPortTable', TType.LIST, 9, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.fdbPortTable)) < 0: return -1
      for iter109 in self.fdbPortTable:
        if iter109.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.fdbPortIfIndexTable is not None:
      annotations = {}
      if oprot.writeFieldBegin('fdbPortIfIndexTable', TType.LIST, 10, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.fdbPortIfIndexTable)) < 0: return -1
      for iter110 in self.fdbPortIfIndexTable:
        if iter110.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ifIndexOperStatusTable is not None:
      annotations = {}
      if oprot.writeFieldBegin('ifIndexOperStatusTable', TType.LIST, 11, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.ifIndexOperStatusTable)) < 0: return -1
      for iter111 in self.ifIndexOperStatusTable:
        if iter111.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.deleted is not None:
      log_str.write('deleted = ')
      if self.deleted:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    if self.lldpTable is not None:
      log_str.write('lldpTable = ')
      log_str.write('<<  ')
      log_str.write(self.lldpTable.log())
      log_str.write('>>')
      log_str.write('  ')
    if self.arpTable is not None:
      log_str.write('arpTable = ')
      log_str.write('[ ')
      for iter112 in self.arpTable:
        log_str.write('<<  ')
        log_str.write(iter112.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.ifTable is not None:
      log_str.write('ifTable = ')
      log_str.write('[ ')
      for iter113 in self.ifTable:
        log_str.write('<<  ')
        log_str.write(iter113.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.ifXTable is not None:
      log_str.write('ifXTable = ')
      log_str.write('[ ')
      for iter114 in self.ifXTable:
        log_str.write('<<  ')
        log_str.write(iter114.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.ifStats is not None:
      log_str.write('ifStats = ')
      log_str.write('[ ')
      for iter115 in self.ifStats:
        log_str.write('<<  ')
        log_str.write(iter115.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.ipMib is not None:
      log_str.write('ipMib = ')
      log_str.write('[ ')
      for iter116 in self.ipMib:
        log_str.write('<<  ')
        log_str.write(iter116.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.fdbPortTable is not None:
      log_str.write('fdbPortTable = ')
      log_str.write('[ ')
      for iter117 in self.fdbPortTable:
        log_str.write('<<  ')
        log_str.write(iter117.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.fdbPortIfIndexTable is not None:
      log_str.write('fdbPortIfIndexTable = ')
      log_str.write('[ ')
      for iter118 in self.fdbPortIfIndexTable:
        log_str.write('<<  ')
        log_str.write(iter118.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.ifIndexOperStatusTable is not None:
      log_str.write('ifIndexOperStatusTable = ')
      log_str.write('[ ')
      for iter119 in self.ifIndexOperStatusTable:
        log_str.write('<<  ')
        log_str.write(iter119.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.deleted is not None:
      size += getsizeof(self.deleted)
    if self.lldpTable is not None:
      size += getsizeof(self.lldpTable)
    if self.arpTable is not None:
      size += getsizeof(self.arpTable)
      size += sum(map(getsizeof, self.arpTable))
    if self.ifTable is not None:
      size += getsizeof(self.ifTable)
      size += sum(map(getsizeof, self.ifTable))
    if self.ifXTable is not None:
      size += getsizeof(self.ifXTable)
      size += sum(map(getsizeof, self.ifXTable))
    if self.ifStats is not None:
      size += getsizeof(self.ifStats)
      size += sum(map(getsizeof, self.ifStats))
    if self.ipMib is not None:
      size += getsizeof(self.ipMib)
      size += sum(map(getsizeof, self.ipMib))
    if self.fdbPortTable is not None:
      size += getsizeof(self.fdbPortTable)
      size += sum(map(getsizeof, self.fdbPortTable))
    if self.fdbPortIfIndexTable is not None:
      size += getsizeof(self.fdbPortIfIndexTable)
      size += sum(map(getsizeof, self.fdbPortIfIndexTable))
    if self.ifIndexOperStatusTable is not None:
      size += getsizeof(self.ifIndexOperStatusTable)
      size += sum(map(getsizeof, self.ifIndexOperStatusTable))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PRouterFlowEntry(object):
  """
  Attributes:
   - name
   - deleted
   - flow_export_source_ip
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.BOOL, 'deleted', None, None, ), # 2
    (3, TType.STRING, 'flow_export_source_ip', None, None, ), # 3
  )

  def __init__(self, name=None, deleted=None, flow_export_source_ip=None,):
    self.name = name
    self.deleted = deleted
    self.flow_export_source_ip = flow_export_source_ip
    self._table = 'ObjectPRouter'

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.BOOL:
          (length, self.deleted) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.flow_export_source_ip) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if self._table is None or self._table is '': return -1
      annotations['key'] = self._table
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.deleted is not None:
      annotations = {}
      if oprot.writeFieldBegin('deleted', TType.BOOL, 2, annotations) < 0: return -1
      if oprot.writeBool(self.deleted) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.flow_export_source_ip is not None:
      annotations = {}
      if oprot.writeFieldBegin('flow_export_source_ip', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.flow_export_source_ip) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.deleted is not None:
      log_str.write('deleted = ')
      if self.deleted:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    if self.flow_export_source_ip is not None:
      log_str.write('flow_export_source_ip = ')
      log_str.write(self.flow_export_source_ip)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.deleted is not None:
      size += getsizeof(self.deleted)
    if self.flow_export_source_ip is not None:
      size += getsizeof(self.flow_export_source_ip)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PRouterUVE(sandesh_base.SandeshUVE):

  thrift_spec = (
    None, # 0
    (1, TType.STRUCT, 'data', (PRouterEntry, PRouterEntry.thrift_spec), None, ), # 1
  )

  def __init__(self, data=None, table=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshUVE.__init__(self)
    self.data = data
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1359191766
    self._hints = 0 | SANDESH_KEY_HINT
    if table is not None:
      self.data._table = table

  def update_uve(self, tdata):
    if self.data.name is not None:
      tdata.name = self.data.name
    if self.data.deleted is not None:
      tdata.deleted = self.data.deleted
    if self.data.lldpTable is not None:
      tdata.lldpTable = self.data.lldpTable
    if self.data.arpTable is not None:
      tdata.arpTable = self.data.arpTable
    if self.data.ifTable is not None:
      tdata.ifTable = self.data.ifTable
    if self.data.ifXTable is not None:
      tdata.ifXTable = self.data.ifXTable
    if self.data.ifStats is not None:
      tdata.ifStats = self.data.ifStats
    if self.data.ipMib is not None:
      tdata.ipMib = self.data.ipMib
    if self.data.fdbPortTable is not None:
      tdata.fdbPortTable = self.data.fdbPortTable
    if self.data.fdbPortIfIndexTable is not None:
      tdata.fdbPortIfIndexTable = self.data.fdbPortIfIndexTable
    if self.data.ifIndexOperStatusTable is not None:
      tdata.ifIndexOperStatusTable = self.data.ifIndexOperStatusTable
    return tdata

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.data is not None:
      log_str.write('data = ')
      log_str.write('<<  ')
      log_str.write(self.data.log())
      log_str.write('>>')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRUCT:
          self.data = PRouterEntry()
          read_cnt += self.data.read(iprot)
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.data is not None:
      annotations = {}
      if oprot.writeFieldBegin('data', TType.STRUCT, 1, annotations) < 0: return -1
      if self.data.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.data != other.data:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.data is not None:
      size += getsizeof(self.data)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PRouterFlowUVE(sandesh_base.SandeshUVE):

  thrift_spec = (
    None, # 0
    (1, TType.STRUCT, 'data', (PRouterFlowEntry, PRouterFlowEntry.thrift_spec), None, ), # 1
  )

  def __init__(self, data=None, table=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshUVE.__init__(self)
    self.data = data
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3583264249
    self._hints = 0 | SANDESH_KEY_HINT
    if table is not None:
      self.data._table = table

  def update_uve(self, tdata):
    if self.data.name is not None:
      tdata.name = self.data.name
    if self.data.deleted is not None:
      tdata.deleted = self.data.deleted
    if self.data.flow_export_source_ip is not None:
      tdata.flow_export_source_ip = self.data.flow_export_source_ip
    return tdata

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.data is not None:
      log_str.write('data = ')
      log_str.write('<<  ')
      log_str.write(self.data.log())
      log_str.write('>>')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRUCT:
          self.data = PRouterFlowEntry()
          read_cnt += self.data.read(iprot)
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.data is not None:
      annotations = {}
      if oprot.writeFieldBegin('data', TType.STRUCT, 1, annotations) < 0: return -1
      if self.data.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.data != other.data:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.data is not None:
      size += getsizeof(self.data)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)


_SANDESH_REQUEST_LIST = [
]


_SANDESH_UVE_LIST = [
(PRouterUVE, PRouterEntry),
(PRouterFlowUVE, PRouterFlowEntry),
]


_SANDESH_ALARM_LIST = [
]
