#
# Autogenerated by Sandesh Compiler (1.0)
#
# DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
#
#  options string: py:new_style
# Copyright (c) 2013 Juniper Networks, Inc. All rights reserved.
#

from pysandesh.Thrift import TType, TMessageType, TException

from pysandesh.transport import TTransport
from pysandesh.protocol import TBinaryProtocol, TProtocol
try:
  from pysandesh.protocol import fastbinary
except:
  fastbinary = None

import cStringIO
import uuid
import netaddr
from sys import getsizeof
from itertools import chain
import bottle
from pysandesh import sandesh_base
from pysandesh.sandesh_http import SandeshHttp
from pysandesh.sandesh_uve import SandeshUVETypeMaps
from pysandesh.util import UTCTimestampUsec, UTCTimestampUsecToString
from pysandesh import util
from pysandesh.gen_py.sandesh.constants import *


class RemoteType(object):
  VRouter = 0
  PRouter = 1
  BMS = 2

  _VALUES_TO_NAMES = {
    0: "VRouter",
    1: "PRouter",
    2: "BMS",
  }

  _NAMES_TO_VALUES = {
    "VRouter": 0,
    "PRouter": 1,
    "BMS": 2,
  }


class LinkEntry(object):
  """
  Structure to represent a link between two objects [physical
  router, physical server etc] in a physical topology

  Attributes:
   - remote_system_name
   - local_interface_name
   - remote_interface_name
   - type
   - local_interface_index
   - remote_interface_index
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'remote_system_name', None, None, ), # 1
    (2, TType.STRING, 'local_interface_name', None, None, ), # 2
    (3, TType.STRING, 'remote_interface_name', None, None, ), # 3
    (4, TType.I32, 'type', None, None, ), # 4
    (5, TType.I32, 'local_interface_index', None, None, ), # 5
    (6, TType.I32, 'remote_interface_index', None, None, ), # 6
  )

  def __init__(self, remote_system_name=None, local_interface_name=None, remote_interface_name=None, type=None, local_interface_index=None, remote_interface_index=None,):
    self.remote_system_name = remote_system_name
    self.local_interface_name = local_interface_name
    self.remote_interface_name = remote_interface_name
    self.type = type
    self.local_interface_index = local_interface_index
    self.remote_interface_index = remote_interface_index

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.remote_system_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.local_interface_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.remote_interface_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.I32:
          (length, self.type) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.I32:
          (length, self.local_interface_index) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.I32:
          (length, self.remote_interface_index) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.remote_system_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('remote_system_name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.remote_system_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.local_interface_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('local_interface_name', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.local_interface_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.remote_interface_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('remote_interface_name', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.remote_interface_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.type is not None:
      annotations = {}
      if oprot.writeFieldBegin('type', TType.I32, 4, annotations) < 0: return -1
      if oprot.writeI32(self.type) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.local_interface_index is not None:
      annotations = {}
      if oprot.writeFieldBegin('local_interface_index', TType.I32, 5, annotations) < 0: return -1
      if oprot.writeI32(self.local_interface_index) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.remote_interface_index is not None:
      annotations = {}
      if oprot.writeFieldBegin('remote_interface_index', TType.I32, 6, annotations) < 0: return -1
      if oprot.writeI32(self.remote_interface_index) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.remote_system_name is not None:
      log_str.write('remote_system_name = ')
      log_str.write(self.remote_system_name)
      log_str.write('  ')
    if self.local_interface_name is not None:
      log_str.write('local_interface_name = ')
      log_str.write(self.local_interface_name)
      log_str.write('  ')
    if self.remote_interface_name is not None:
      log_str.write('remote_interface_name = ')
      log_str.write(self.remote_interface_name)
      log_str.write('  ')
    if self.type is not None:
      log_str.write('type = ')
      log_str.write(str(self.type))
      log_str.write('  ')
    if self.local_interface_index is not None:
      log_str.write('local_interface_index = ')
      log_str.write(str(self.local_interface_index))
      log_str.write('  ')
    if self.remote_interface_index is not None:
      log_str.write('remote_interface_index = ')
      log_str.write(str(self.remote_interface_index))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.remote_system_name is not None:
      size += getsizeof(self.remote_system_name)
    if self.local_interface_name is not None:
      size += getsizeof(self.local_interface_name)
    if self.remote_interface_name is not None:
      size += getsizeof(self.remote_interface_name)
    if self.type is not None:
      size += getsizeof(self.type)
    if self.local_interface_index is not None:
      size += getsizeof(self.local_interface_index)
    if self.remote_interface_index is not None:
      size += getsizeof(self.remote_interface_index)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PRouterLinkEntry(object):
  """
  Physical Router UVE data provided by contrail-topology. This
  includes the neighbor links calculated using the SNMP data in the UVE.

  Attributes:
   - name
   - deleted
   - link_table
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.BOOL, 'deleted', None, None, ), # 2
    (3, TType.LIST, 'link_table', (TType.STRUCT,(LinkEntry, LinkEntry.thrift_spec)), None, ), # 3
  )

  def __init__(self, name=None, deleted=None, link_table=None,):
    self.name = name
    self.deleted = deleted
    self.link_table = link_table
    self._table = 'ObjectPRouter'

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.BOOL:
          (length, self.deleted) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.LIST:
          self.link_table = []
          (length, _etype3, _size0) = iprot.readListBegin()
          read_cnt += length
          for _i4 in xrange(_size0):
            _elem5 = LinkEntry()
            read_cnt += _elem5.read(iprot)
            self.link_table.append(_elem5)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if self._table is None or self._table is '': return -1
      annotations['key'] = self._table
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.deleted is not None:
      annotations = {}
      if oprot.writeFieldBegin('deleted', TType.BOOL, 2, annotations) < 0: return -1
      if oprot.writeBool(self.deleted) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.link_table is not None:
      annotations = {}
      if oprot.writeFieldBegin('link_table', TType.LIST, 3, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.link_table)) < 0: return -1
      for iter6 in self.link_table:
        if iter6.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.deleted is not None:
      log_str.write('deleted = ')
      if self.deleted:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    if self.link_table is not None:
      log_str.write('link_table = ')
      log_str.write('[ ')
      for iter7 in self.link_table:
        log_str.write('<<  ')
        log_str.write(iter7.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.deleted is not None:
      size += getsizeof(self.deleted)
    if self.link_table is not None:
      size += getsizeof(self.link_table)
      size += sum(map(getsizeof, self.link_table))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PRouterLinkUVE(sandesh_base.SandeshUVE):

  thrift_spec = (
    None, # 0
    (1, TType.STRUCT, 'data', (PRouterLinkEntry, PRouterLinkEntry.thrift_spec), None, ), # 1
  )

  def __init__(self, data=None, table=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshUVE.__init__(self)
    self.data = data
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3787065486
    self._hints = 0 | SANDESH_KEY_HINT
    if table is not None:
      self.data._table = table

  def update_uve(self, tdata):
    if self.data.name is not None:
      tdata.name = self.data.name
    if self.data.deleted is not None:
      tdata.deleted = self.data.deleted
    if self.data.link_table is not None:
      tdata.link_table = self.data.link_table
    return tdata

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.data is not None:
      log_str.write('data = ')
      log_str.write('<<  ')
      log_str.write(self.data.log())
      log_str.write('>>')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRUCT:
          self.data = PRouterLinkEntry()
          read_cnt += self.data.read(iprot)
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.data is not None:
      annotations = {}
      if oprot.writeFieldBegin('data', TType.STRUCT, 1, annotations) < 0: return -1
      if self.data.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.data != other.data:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.data is not None:
      size += getsizeof(self.data)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)


_SANDESH_REQUEST_LIST = [
]


_SANDESH_UVE_LIST = [
(PRouterLinkUVE, PRouterLinkEntry),
]


_SANDESH_ALARM_LIST = [
]
