#
# Autogenerated by Sandesh Compiler (1.0)
#
# DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
#
#  options string: py:new_style
# Copyright (c) 2013 Juniper Networks, Inc. All rights reserved.
#

from pysandesh.Thrift import TType, TMessageType, TException
import sandesh_alarm_base.ttypes


from pysandesh.transport import TTransport
from pysandesh.protocol import TBinaryProtocol, TProtocol
try:
  from pysandesh.protocol import fastbinary
except:
  fastbinary = None

import cStringIO
import uuid
import netaddr
from sys import getsizeof
from itertools import chain
import bottle
from pysandesh import sandesh_base
from pysandesh.sandesh_http import SandeshHttp
from pysandesh.sandesh_uve import SandeshUVETypeMaps
from pysandesh.util import UTCTimestampUsec, UTCTimestampUsecToString
from pysandesh import util
from pysandesh.gen_py.sandesh.constants import *


class UVEAlarmState(object):
  Idle = 0
  Soak_Active = 1
  Active = 2
  Soak_Idle = 3

  _VALUES_TO_NAMES = {
    0: "Idle",
    1: "Soak_Active",
    2: "Active",
    3: "Soak_Idle",
  }

  _NAMES_TO_VALUES = {
    "Idle": 0,
    "Soak_Active": 1,
    "Active": 2,
    "Soak_Idle": 3,
  }


class UVETypeCount(object):
  """
  Attributes:
   - type
   - count
   - agg_uuid
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'type', None, None, ), # 1
    (2, TType.U32, 'count', None, None, ), # 2
    (3, TType.STRING, 'agg_uuid', None, None, ), # 3
  )

  def __init__(self, type=None, count=None, agg_uuid=None,):
    self.type = type
    self.count = count
    self.agg_uuid = agg_uuid

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.type) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.U32:
          (length, self.count) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.agg_uuid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.type is not None:
      annotations = {}
      if oprot.writeFieldBegin('type', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.type) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.count is not None:
      annotations = {}
      if oprot.writeFieldBegin('count', TType.U32, 2, annotations) < 0: return -1
      if oprot.writeU32(self.count) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.agg_uuid is not None:
      annotations = {}
      if oprot.writeFieldBegin('agg_uuid', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.agg_uuid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.type is not None:
      log_str.write('type = ')
      log_str.write(self.type)
      log_str.write('  ')
    if self.count is not None:
      log_str.write('count = ')
      log_str.write(str(self.count))
      log_str.write('  ')
    if self.agg_uuid is not None:
      log_str.write('agg_uuid = ')
      log_str.write(self.agg_uuid)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.type is not None:
      size += getsizeof(self.type)
    if self.count is not None:
      size += getsizeof(self.count)
    if self.agg_uuid is not None:
      size += getsizeof(self.agg_uuid)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVEKeyInfo(object):
  """
  Attributes:
   - key
   - types
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'key', None, None, ), # 1
    (2, TType.LIST, 'types', (TType.STRUCT,(UVETypeCount, UVETypeCount.thrift_spec)), None, ), # 2
  )

  def __init__(self, key=None, types=None,):
    self.key = key
    self.types = types

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.key) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.LIST:
          self.types = []
          (length, _etype3, _size0) = iprot.readListBegin()
          read_cnt += length
          for _i4 in xrange(_size0):
            _elem5 = UVETypeCount()
            read_cnt += _elem5.read(iprot)
            self.types.append(_elem5)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.key is not None:
      annotations = {}
      if oprot.writeFieldBegin('key', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.key) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.types is not None:
      annotations = {}
      if oprot.writeFieldBegin('types', TType.LIST, 2, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.types)) < 0: return -1
      for iter6 in self.types:
        if iter6.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.key is not None:
      log_str.write('key = ')
      log_str.write(self.key)
      log_str.write('  ')
    if self.types is not None:
      log_str.write('types = ')
      log_str.write('[ ')
      for iter7 in self.types:
        log_str.write('<<  ')
        log_str.write(iter7.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.key is not None:
      size += getsizeof(self.key)
    if self.types is not None:
      size += getsizeof(self.types)
      size += sum(map(getsizeof, self.types))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVEGenInfo(object):
  """
  Attributes:
   - generator
   - uves
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'generator', None, None, ), # 1
    (2, TType.LIST, 'uves', (TType.STRUCT,(UVEKeyInfo, UVEKeyInfo.thrift_spec)), None, ), # 2
  )

  def __init__(self, generator=None, uves=None,):
    self.generator = generator
    self.uves = uves

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.generator) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.LIST:
          self.uves = []
          (length, _etype11, _size8) = iprot.readListBegin()
          read_cnt += length
          for _i12 in xrange(_size8):
            _elem13 = UVEKeyInfo()
            read_cnt += _elem13.read(iprot)
            self.uves.append(_elem13)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.generator is not None:
      annotations = {}
      if oprot.writeFieldBegin('generator', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.generator) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uves is not None:
      annotations = {}
      if oprot.writeFieldBegin('uves', TType.LIST, 2, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.uves)) < 0: return -1
      for iter14 in self.uves:
        if iter14.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.generator is not None:
      log_str.write('generator = ')
      log_str.write(self.generator)
      log_str.write('  ')
    if self.uves is not None:
      log_str.write('uves = ')
      log_str.write('[ ')
      for iter15 in self.uves:
        log_str.write('<<  ')
        log_str.write(iter15.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.generator is not None:
      size += getsizeof(self.generator)
    if self.uves is not None:
      size += getsizeof(self.uves)
      size += sum(map(getsizeof, self.uves))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVECollInfo(object):
  """
  Attributes:
   - collector
   - uves
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'collector', None, None, ), # 1
    (2, TType.LIST, 'uves', (TType.STRUCT,(UVEGenInfo, UVEGenInfo.thrift_spec)), None, ), # 2
  )

  def __init__(self, collector=None, uves=None,):
    self.collector = collector
    self.uves = uves

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.collector) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.LIST:
          self.uves = []
          (length, _etype19, _size16) = iprot.readListBegin()
          read_cnt += length
          for _i20 in xrange(_size16):
            _elem21 = UVEGenInfo()
            read_cnt += _elem21.read(iprot)
            self.uves.append(_elem21)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.collector is not None:
      annotations = {}
      if oprot.writeFieldBegin('collector', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.collector) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uves is not None:
      annotations = {}
      if oprot.writeFieldBegin('uves', TType.LIST, 2, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.uves)) < 0: return -1
      for iter22 in self.uves:
        if iter22.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.collector is not None:
      log_str.write('collector = ')
      log_str.write(self.collector)
      log_str.write('  ')
    if self.uves is not None:
      log_str.write('uves = ')
      log_str.write('[ ')
      for iter23 in self.uves:
        log_str.write('<<  ')
        log_str.write(iter23.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.collector is not None:
      size += getsizeof(self.collector)
    if self.uves is not None:
      size += getsizeof(self.uves)
      size += sum(map(getsizeof, self.uves))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVEStructInfo(object):
  """
  Attributes:
   - type
   - content
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'type', None, None, ), # 1
    (2, TType.STRING, 'content', None, None, ), # 2
  )

  def __init__(self, type=None, content=None,):
    self.type = type
    self.content = content

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.type) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.content) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.type is not None:
      annotations = {}
      if oprot.writeFieldBegin('type', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.type) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.content is not None:
      annotations = {}
      if oprot.writeFieldBegin('content', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.content) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.type is not None:
      log_str.write('type = ')
      log_str.write(self.type)
      log_str.write('  ')
    if self.content is not None:
      log_str.write('content = ')
      log_str.write(self.content)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.type is not None:
      size += getsizeof(self.type)
    if self.content is not None:
      size += getsizeof(self.content)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVEObjectInfo(object):
  """
  Attributes:
   - name
   - structs
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    None, # 2
    (3, TType.LIST, 'structs', (TType.STRUCT,(UVEStructInfo, UVEStructInfo.thrift_spec)), None, ), # 3
  )

  def __init__(self, name=None, structs=None,):
    self.name = name
    self.structs = structs

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.LIST:
          self.structs = []
          (length, _etype27, _size24) = iprot.readListBegin()
          read_cnt += length
          for _i28 in xrange(_size24):
            _elem29 = UVEStructInfo()
            read_cnt += _elem29.read(iprot)
            self.structs.append(_elem29)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.structs is not None:
      annotations = {}
      if oprot.writeFieldBegin('structs', TType.LIST, 3, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.structs)) < 0: return -1
      for iter30 in self.structs:
        if iter30.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.structs is not None:
      log_str.write('structs = ')
      log_str.write('[ ')
      for iter31 in self.structs:
        log_str.write('<<  ')
        log_str.write(iter31.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.structs is not None:
      size += getsizeof(self.structs)
      size += sum(map(getsizeof, self.structs))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVETableInfo(object):
  """
  Attributes:
   - table
   - uves
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'table', None, None, ), # 1
    None, # 2
    None, # 3
    None, # 4
    None, # 5
    None, # 6
    (7, TType.LIST, 'uves', (TType.STRUCT,(UVEObjectInfo, UVEObjectInfo.thrift_spec)), None, ), # 7
  )

  def __init__(self, table=None, uves=None,):
    self.table = table
    self.uves = uves

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.table) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 7:
        if ftype == TType.LIST:
          self.uves = []
          (length, _etype35, _size32) = iprot.readListBegin()
          read_cnt += length
          for _i36 in xrange(_size32):
            _elem37 = UVEObjectInfo()
            read_cnt += _elem37.read(iprot)
            self.uves.append(_elem37)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.table is not None:
      annotations = {}
      if oprot.writeFieldBegin('table', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.table) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uves is not None:
      annotations = {}
      if oprot.writeFieldBegin('uves', TType.LIST, 7, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.uves)) < 0: return -1
      for iter38 in self.uves:
        if iter38.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.table is not None:
      log_str.write('table = ')
      log_str.write(self.table)
      log_str.write('  ')
    if self.uves is not None:
      log_str.write('uves = ')
      log_str.write('[ ')
      for iter39 in self.uves:
        log_str.write('<<  ')
        log_str.write(iter39.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.table is not None:
      size += getsizeof(self.table)
    if self.uves is not None:
      size += getsizeof(self.uves)
      size += sum(map(getsizeof, self.uves))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVEAlarmOperState(object):
  """
  Attributes:
   - state
   - delete_timestamp
   - alarm_timestamp
   - head_timestamp
  """

  thrift_spec = (
    None, # 0
    (1, TType.I32, 'state', None, None, ), # 1
    (2, TType.U64, 'delete_timestamp', None, None, ), # 2
    (3, TType.LIST, 'alarm_timestamp', (TType.U64,None), None, ), # 3
    (4, TType.U32, 'head_timestamp', None, None, ), # 4
  )

  def __init__(self, state=None, delete_timestamp=None, alarm_timestamp=None, head_timestamp=None,):
    self.state = state
    self.delete_timestamp = delete_timestamp
    self.alarm_timestamp = alarm_timestamp
    self.head_timestamp = head_timestamp

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.I32:
          (length, self.state) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.U64:
          (length, self.delete_timestamp) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.LIST:
          self.alarm_timestamp = []
          (length, _etype43, _size40) = iprot.readListBegin()
          read_cnt += length
          for _i44 in xrange(_size40):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem45) = iprot.readU64();
            if length < 0: return -1
            read_cnt += length
            self.alarm_timestamp.append(_elem45)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.U32:
          (length, self.head_timestamp) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.state is not None:
      annotations = {}
      if oprot.writeFieldBegin('state', TType.I32, 1, annotations) < 0: return -1
      if oprot.writeI32(self.state) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.delete_timestamp is not None:
      annotations = {}
      if oprot.writeFieldBegin('delete_timestamp', TType.U64, 2, annotations) < 0: return -1
      if oprot.writeU64(self.delete_timestamp) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.alarm_timestamp is not None:
      annotations = {}
      if oprot.writeFieldBegin('alarm_timestamp', TType.LIST, 3, annotations) < 0: return -1
      if oprot.writeListBegin(TType.U64, len(self.alarm_timestamp)) < 0: return -1
      for iter46 in self.alarm_timestamp:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeU64(iter46) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.head_timestamp is not None:
      annotations = {}
      if oprot.writeFieldBegin('head_timestamp', TType.U32, 4, annotations) < 0: return -1
      if oprot.writeU32(self.head_timestamp) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.state is not None:
      log_str.write('state = ')
      log_str.write(str(self.state))
      log_str.write('  ')
    if self.delete_timestamp is not None:
      log_str.write('delete_timestamp = ')
      log_str.write(str(self.delete_timestamp))
      log_str.write('  ')
    if self.alarm_timestamp is not None:
      log_str.write('alarm_timestamp = ')
      log_str.write('[ ')
      for iter47 in self.alarm_timestamp:
        log_str.write(str(iter47))
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.head_timestamp is not None:
      log_str.write('head_timestamp = ')
      log_str.write(str(self.head_timestamp))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.state is not None:
      size += getsizeof(self.state)
    if self.delete_timestamp is not None:
      size += getsizeof(self.delete_timestamp)
    if self.alarm_timestamp is not None:
      size += getsizeof(self.alarm_timestamp)
      size += sum(map(getsizeof, self.alarm_timestamp))
    if self.head_timestamp is not None:
      size += getsizeof(self.head_timestamp)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVEAlarmStateMachineInfo(object):
  """
  Attributes:
   - uai
   - uac
   - uas
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRUCT, 'uai', (sandesh_alarm_base.ttypes.UVEAlarmInfo, sandesh_alarm_base.ttypes.UVEAlarmInfo.thrift_spec), None, ), # 1
    (2, TType.STRUCT, 'uac', (sandesh_alarm_base.ttypes.UVEAlarmConfig, sandesh_alarm_base.ttypes.UVEAlarmConfig.thrift_spec), None, ), # 2
    (3, TType.STRUCT, 'uas', (UVEAlarmOperState, UVEAlarmOperState.thrift_spec), None, ), # 3
  )

  def __init__(self, uai=None, uac=None, uas=None,):
    self.uai = uai
    self.uac = uac
    self.uas = uas

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRUCT:
          self.uai = sandesh_alarm_base.ttypes.UVEAlarmInfo()
          read_cnt += self.uai.read(iprot)
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRUCT:
          self.uac = sandesh_alarm_base.ttypes.UVEAlarmConfig()
          read_cnt += self.uac.read(iprot)
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRUCT:
          self.uas = UVEAlarmOperState()
          read_cnt += self.uas.read(iprot)
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.uai is not None:
      annotations = {}
      if oprot.writeFieldBegin('uai', TType.STRUCT, 1, annotations) < 0: return -1
      if self.uai.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uac is not None:
      annotations = {}
      if oprot.writeFieldBegin('uac', TType.STRUCT, 2, annotations) < 0: return -1
      if self.uac.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uas is not None:
      annotations = {}
      if oprot.writeFieldBegin('uas', TType.STRUCT, 3, annotations) < 0: return -1
      if self.uas.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.uai is not None:
      log_str.write('uai = ')
      log_str.write('<<  ')
      log_str.write(self.uai.log())
      log_str.write('>>')
      log_str.write('  ')
    if self.uac is not None:
      log_str.write('uac = ')
      log_str.write('<<  ')
      log_str.write(self.uac.log())
      log_str.write('>>')
      log_str.write('  ')
    if self.uas is not None:
      log_str.write('uas = ')
      log_str.write('<<  ')
      log_str.write(self.uas.log())
      log_str.write('>>')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.uai is not None:
      size += getsizeof(self.uai)
    if self.uac is not None:
      size += getsizeof(self.uac)
    if self.uas is not None:
      size += getsizeof(self.uas)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVETypeInfo(object):
  """
  Attributes:
   - collector
   - generator
   - type
   - count
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'collector', None, None, ), # 1
    (2, TType.STRING, 'generator', None, None, ), # 2
    (3, TType.STRING, 'type', None, None, ), # 3
    (4, TType.U32, 'count', None, None, ), # 4
  )

  def __init__(self, collector=None, generator=None, type=None, count=None,):
    self.collector = collector
    self.generator = generator
    self.type = type
    self.count = count

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.collector) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.generator) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.type) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.U32:
          (length, self.count) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.collector is not None:
      annotations = {}
      if oprot.writeFieldBegin('collector', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.collector) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.generator is not None:
      annotations = {}
      if oprot.writeFieldBegin('generator', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.generator) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.type is not None:
      annotations = {}
      if oprot.writeFieldBegin('type', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.type) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.count is not None:
      annotations = {}
      if oprot.writeFieldBegin('count', TType.U32, 4, annotations) < 0: return -1
      if oprot.writeU32(self.count) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.collector is not None:
      log_str.write('collector = ')
      log_str.write(self.collector)
      log_str.write('  ')
    if self.generator is not None:
      log_str.write('generator = ')
      log_str.write(self.generator)
      log_str.write('  ')
    if self.type is not None:
      log_str.write('type = ')
      log_str.write(self.type)
      log_str.write('  ')
    if self.count is not None:
      log_str.write('count = ')
      log_str.write(str(self.count))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.collector is not None:
      size += getsizeof(self.collector)
    if self.generator is not None:
      size += getsizeof(self.generator)
    if self.type is not None:
      size += getsizeof(self.type)
    if self.count is not None:
      size += getsizeof(self.count)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVETableCount(object):
  """
  Attributes:
   - keys
   - count
  """

  thrift_spec = (
    None, # 0
    (1, TType.U32, 'keys', None, None, ), # 1
    (2, TType.U32, 'count', None, None, ), # 2
  )

  def __init__(self, keys=None, count=None,):
    self.keys = keys
    self.count = count

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.U32:
          (length, self.keys) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.U32:
          (length, self.count) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.keys is not None:
      annotations = {}
      if oprot.writeFieldBegin('keys', TType.U32, 1, annotations) < 0: return -1
      if oprot.writeU32(self.keys) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.count is not None:
      annotations = {}
      if oprot.writeFieldBegin('count', TType.U32, 2, annotations) < 0: return -1
      if oprot.writeU32(self.count) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.keys is not None:
      log_str.write('keys = ')
      log_str.write(str(self.keys))
      log_str.write('  ')
    if self.count is not None:
      log_str.write('count = ')
      log_str.write(str(self.count))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.keys is not None:
      size += getsizeof(self.keys)
    if self.count is not None:
      size += getsizeof(self.count)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class AlarmgenStats(object):
  """
  Attributes:
   - instance
   - partitions
   - keys
   - updates
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'instance', None, None, ), # 1
    (2, TType.U32, 'partitions', None, None, ), # 2
    (3, TType.U32, 'keys', None, None, ), # 3
    (4, TType.U64, 'updates', None, None, ), # 4
  )

  def __init__(self, instance=None, partitions=None, keys=None, updates=None,):
    self.instance = instance
    self.partitions = partitions
    self.keys = keys
    self.updates = updates

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.instance) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.U32:
          (length, self.partitions) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.U32:
          (length, self.keys) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.U64:
          (length, self.updates) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.instance is not None:
      annotations = {}
      if oprot.writeFieldBegin('instance', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.instance) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.partitions is not None:
      annotations = {}
      if oprot.writeFieldBegin('partitions', TType.U32, 2, annotations) < 0: return -1
      if oprot.writeU32(self.partitions) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.keys is not None:
      annotations = {}
      if oprot.writeFieldBegin('keys', TType.U32, 3, annotations) < 0: return -1
      if oprot.writeU32(self.keys) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.updates is not None:
      annotations = {}
      if oprot.writeFieldBegin('updates', TType.U64, 4, annotations) < 0: return -1
      if oprot.writeU64(self.updates) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.instance is not None:
      log_str.write('instance = ')
      log_str.write(self.instance)
      log_str.write('  ')
    if self.partitions is not None:
      log_str.write('partitions = ')
      log_str.write(str(self.partitions))
      log_str.write('  ')
    if self.keys is not None:
      log_str.write('keys = ')
      log_str.write(str(self.keys))
      log_str.write('  ')
    if self.updates is not None:
      log_str.write('updates = ')
      log_str.write(str(self.updates))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.instance is not None:
      size += getsizeof(self.instance)
    if self.partitions is not None:
      size += getsizeof(self.partitions)
    if self.keys is not None:
      size += getsizeof(self.keys)
    if self.updates is not None:
      size += getsizeof(self.updates)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class AlarmgenStatus(object):
  """
  structure to carry alarmgen status data

  Attributes:
   - name
   - counters
   - alarmgens
   - deleted
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.LIST, 'counters', (TType.STRUCT,(AlarmgenStats, AlarmgenStats.thrift_spec)), None, ), # 2
    (3, TType.BOOL, 'deleted', None, None, ), # 3
    (4, TType.LIST, 'alarmgens', (TType.STRING,None), None, ), # 4
  )

  def __init__(self, name=None, counters=None, alarmgens=None, deleted=None,):
    self.name = name
    self.counters = counters
    self.alarmgens = alarmgens
    self.deleted = deleted
    self._table = 'ObjectCollectorInfo'

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.LIST:
          self.counters = []
          (length, _etype51, _size48) = iprot.readListBegin()
          read_cnt += length
          for _i52 in xrange(_size48):
            _elem53 = AlarmgenStats()
            read_cnt += _elem53.read(iprot)
            self.counters.append(_elem53)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.LIST:
          self.alarmgens = []
          (length, _etype57, _size54) = iprot.readListBegin()
          read_cnt += length
          for _i58 in xrange(_size54):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem59) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.alarmgens.append(_elem59)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.BOOL:
          (length, self.deleted) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if self._table is None or self._table is '': return -1
      annotations['key'] = self._table
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.counters is not None:
      annotations = {}
      annotations['aggtype'] = 'union'
      annotations['tags'] = 'name:.instance'
      if oprot.writeFieldBegin('counters', TType.LIST, 2, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.counters)) < 0: return -1
      for iter60 in self.counters:
        if iter60.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.deleted is not None:
      annotations = {}
      if oprot.writeFieldBegin('deleted', TType.BOOL, 3, annotations) < 0: return -1
      if oprot.writeBool(self.deleted) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.alarmgens is not None:
      annotations = {}
      annotations['aggtype'] = 'union'
      annotations['ulink'] = 'ObjectGeneratorInfo:ModuleClientState'
      if oprot.writeFieldBegin('alarmgens', TType.LIST, 4, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.alarmgens)) < 0: return -1
      for iter61 in self.alarmgens:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter61) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.counters is not None:
      log_str.write('counters = ')
      log_str.write('[ ')
      for iter62 in self.counters:
        log_str.write('<<  ')
        log_str.write(iter62.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.alarmgens is not None:
      log_str.write('alarmgens = ')
      log_str.write('[ ')
      for iter63 in self.alarmgens:
        log_str.write(iter63)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.deleted is not None:
      log_str.write('deleted = ')
      if self.deleted:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.counters is not None:
      size += getsizeof(self.counters)
      size += sum(map(getsizeof, self.counters))
    if self.alarmgens is not None:
      size += getsizeof(self.alarmgens)
      size += sum(map(getsizeof, self.alarmgens))
    if self.deleted is not None:
      size += getsizeof(self.deleted)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class AlarmgenPartionInfo(object):
  """
  Attributes:
   - instance
   - partitions
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'instance', None, None, ), # 1
    (2, TType.LIST, 'partitions', (TType.U16,None), None, ), # 2
  )

  def __init__(self, instance=None, partitions=None,):
    self.instance = instance
    self.partitions = partitions

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.instance) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.LIST:
          self.partitions = []
          (length, _etype67, _size64) = iprot.readListBegin()
          read_cnt += length
          for _i68 in xrange(_size64):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem69) = iprot.readU16();
            if length < 0: return -1
            read_cnt += length
            self.partitions.append(_elem69)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.instance is not None:
      annotations = {}
      if oprot.writeFieldBegin('instance', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.instance) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.partitions is not None:
      annotations = {}
      if oprot.writeFieldBegin('partitions', TType.LIST, 2, annotations) < 0: return -1
      if oprot.writeListBegin(TType.U16, len(self.partitions)) < 0: return -1
      for iter70 in self.partitions:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeU16(iter70) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.instance is not None:
      log_str.write('instance = ')
      log_str.write(self.instance)
      log_str.write('  ')
    if self.partitions is not None:
      log_str.write('partitions = ')
      log_str.write('[ ')
      for iter71 in self.partitions:
        log_str.write(str(iter71))
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.instance is not None:
      size += getsizeof(self.instance)
    if self.partitions is not None:
      size += getsizeof(self.partitions)
      size += sum(map(getsizeof, self.partitions))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class AlarmgenPartition(object):
  """
  structure to carry alarmgen partition data

  Attributes:
   - name
   - inst_parts
   - deleted
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.LIST, 'inst_parts', (TType.STRUCT,(AlarmgenPartionInfo, AlarmgenPartionInfo.thrift_spec)), None, ), # 2
    (3, TType.BOOL, 'deleted', None, None, ), # 3
  )

  def __init__(self, name=None, inst_parts=None, deleted=None,):
    self.name = name
    self.inst_parts = inst_parts
    self.deleted = deleted
    self._table = 'ObjectCollectorInfo'

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.LIST:
          self.inst_parts = []
          (length, _etype75, _size72) = iprot.readListBegin()
          read_cnt += length
          for _i76 in xrange(_size72):
            _elem77 = AlarmgenPartionInfo()
            read_cnt += _elem77.read(iprot)
            self.inst_parts.append(_elem77)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.BOOL:
          (length, self.deleted) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if self._table is None or self._table is '': return -1
      annotations['key'] = self._table
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.inst_parts is not None:
      annotations = {}
      annotations['aggtype'] = 'union'
      if oprot.writeFieldBegin('inst_parts', TType.LIST, 2, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.inst_parts)) < 0: return -1
      for iter78 in self.inst_parts:
        if iter78.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.deleted is not None:
      annotations = {}
      if oprot.writeFieldBegin('deleted', TType.BOOL, 3, annotations) < 0: return -1
      if oprot.writeBool(self.deleted) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.inst_parts is not None:
      log_str.write('inst_parts = ')
      log_str.write('[ ')
      for iter79 in self.inst_parts:
        log_str.write('<<  ')
        log_str.write(iter79.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.deleted is not None:
      log_str.write('deleted = ')
      if self.deleted:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.inst_parts is not None:
      size += getsizeof(self.inst_parts)
      size += sum(map(getsizeof, self.inst_parts))
    if self.deleted is not None:
      size += getsizeof(self.deleted)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PartitionOwnershipReq(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.U32, 'partition', None, None, ), # 1
    (2, TType.BOOL, 'ownership', None, None, ), # 2
  )

  def __init__(self, partition=None, ownership=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.partition = partition
    self.ownership = ownership
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 978567693
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = PartitionOwnershipReq()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "PartitionOwnershipReq" not implemented')
    if bottle.request.query.x:
      try:
        sandesh_req.partition = int(bottle.request.query.x)
      except ValueError:
        return SandeshHttp.http_error('Invalid data provided in Sandesh Request')
    if bottle.request.query.partition:
      try:
        sandesh_req.partition = int(bottle.request.query.partition)
      except ValueError:
        return SandeshHttp.http_error('Invalid data provided in Sandesh Request')
    if bottle.request.query.ownership:
      try:
        sandesh_req.ownership = int(bottle.request.query.ownership)
      except ValueError:
        return SandeshHttp.http_error('Invalid data provided in Sandesh Request')
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "PartitionOwnershipReq" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "PartitionOwnershipReq"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.partition is not None:
      log_str.write('partition = ')
      log_str.write(str(self.partition))
      log_str.write('  ')
    if self.ownership is not None:
      log_str.write('ownership = ')
      if self.ownership:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.U32:
          (length, self.partition) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.BOOL:
          (length, self.ownership) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.partition is not None:
      annotations = {}
      if oprot.writeFieldBegin('partition', TType.U32, 1, annotations) < 0: return -1
      if oprot.writeU32(self.partition) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.ownership is not None:
      annotations = {}
      if oprot.writeFieldBegin('ownership', TType.BOOL, 2, annotations) < 0: return -1
      if oprot.writeBool(self.ownership) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.partition != other.partition:
      return False
    if self.ownership != other.ownership:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.partition is not None:
      size += getsizeof(self.partition)
    if self.ownership is not None:
      size += getsizeof(self.ownership)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PartitionOwnershipResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.BOOL, 'status', None, None, ), # 1
  )

  def __init__(self, status=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.status = status
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 4224038448
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.status is not None:
      log_str.write('status = ')
      if self.status:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.BOOL:
          (length, self.status) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.status is not None:
      annotations = {}
      if oprot.writeFieldBegin('status', TType.BOOL, 1, annotations) < 0: return -1
      if oprot.writeBool(self.status) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.status != other.status:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.status is not None:
      size += getsizeof(self.status)
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PartitionStatusReq(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.I32, 'partition', None, None, ), # 1
  )

  def __init__(self, partition=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.partition = partition
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3953945832
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = PartitionStatusReq()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "PartitionStatusReq" not implemented')
    if bottle.request.query.x:
      try:
        sandesh_req.partition = int(bottle.request.query.x)
      except ValueError:
        return SandeshHttp.http_error('Invalid data provided in Sandesh Request')
    if bottle.request.query.partition:
      try:
        sandesh_req.partition = int(bottle.request.query.partition)
      except ValueError:
        return SandeshHttp.http_error('Invalid data provided in Sandesh Request')
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "PartitionStatusReq" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "PartitionStatusReq"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.partition is not None:
      log_str.write('partition = ')
      log_str.write(str(self.partition))
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.I32:
          (length, self.partition) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.partition is not None:
      annotations = {}
      if oprot.writeFieldBegin('partition', TType.I32, 1, annotations) < 0: return -1
      if oprot.writeI32(self.partition) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.partition != other.partition:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.partition is not None:
      size += getsizeof(self.partition)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class PartitionStatusResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.BOOL, 'enabled', None, None, ), # 1
    (2, TType.U32, 'partition', None, None, ), # 2
    (3, TType.U64, 'offset', None, None, ), # 3
    (4, TType.LIST, 'uves', (TType.STRUCT,(UVECollInfo, UVECollInfo.thrift_spec)), None, ), # 4
  )

  def __init__(self, enabled=None, partition=None, offset=None, uves=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.enabled = enabled
    self.partition = partition
    self.offset = offset
    self.uves = uves
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3933981372
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.enabled is not None:
      log_str.write('enabled = ')
      if self.enabled:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    if self.partition is not None:
      log_str.write('partition = ')
      log_str.write(str(self.partition))
      log_str.write('  ')
    if self.offset is not None:
      log_str.write('offset = ')
      log_str.write(str(self.offset))
      log_str.write('  ')
    if self.uves is not None:
      log_str.write('uves = ')
      log_str.write('[ ')
      for iter80 in self.uves:
        log_str.write('<<  ')
        log_str.write(iter80.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.BOOL:
          (length, self.enabled) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.U32:
          (length, self.partition) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.U64:
          (length, self.offset) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.LIST:
          self.uves = []
          (length, _etype84, _size81) = iprot.readListBegin()
          read_cnt += length
          for _i85 in xrange(_size81):
            _elem86 = UVECollInfo()
            read_cnt += _elem86.read(iprot)
            self.uves.append(_elem86)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.enabled is not None:
      annotations = {}
      if oprot.writeFieldBegin('enabled', TType.BOOL, 1, annotations) < 0: return -1
      if oprot.writeBool(self.enabled) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.partition is not None:
      annotations = {}
      if oprot.writeFieldBegin('partition', TType.U32, 2, annotations) < 0: return -1
      if oprot.writeU32(self.partition) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.offset is not None:
      annotations = {}
      if oprot.writeFieldBegin('offset', TType.U64, 3, annotations) < 0: return -1
      if oprot.writeU64(self.offset) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uves is not None:
      annotations = {}
      if oprot.writeFieldBegin('uves', TType.LIST, 4, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.uves)) < 0: return -1
      for iter87 in self.uves:
        if iter87.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.enabled != other.enabled:
      return False
    if self.partition != other.partition:
      return False
    if self.offset != other.offset:
      return False
    if self.uves != other.uves:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.enabled is not None:
      size += getsizeof(self.enabled)
    if self.partition is not None:
      size += getsizeof(self.partition)
    if self.offset is not None:
      size += getsizeof(self.offset)
    if self.uves is not None:
      size += getsizeof(self.uves)
      size += sum(map(getsizeof, self.uves))
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVETableInfoReq(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.U32, 'partition', None, None, ), # 1
  )

  def __init__(self, partition=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.partition = partition
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 627509256
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = UVETableInfoReq()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "UVETableInfoReq" not implemented')
    if bottle.request.query.x:
      try:
        sandesh_req.partition = int(bottle.request.query.x)
      except ValueError:
        return SandeshHttp.http_error('Invalid data provided in Sandesh Request')
    if bottle.request.query.partition:
      try:
        sandesh_req.partition = int(bottle.request.query.partition)
      except ValueError:
        return SandeshHttp.http_error('Invalid data provided in Sandesh Request')
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "UVETableInfoReq" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "UVETableInfoReq"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.partition is not None:
      log_str.write('partition = ')
      log_str.write(str(self.partition))
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.U32:
          (length, self.partition) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.partition is not None:
      annotations = {}
      if oprot.writeFieldBegin('partition', TType.U32, 1, annotations) < 0: return -1
      if oprot.writeU32(self.partition) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.partition != other.partition:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.partition is not None:
      size += getsizeof(self.partition)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVETableInfoResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    None, # 1
    (2, TType.U32, 'partition', None, None, ), # 2
    None, # 3
    None, # 4
    None, # 5
    None, # 6
    (7, TType.LIST, 'tables', (TType.STRUCT,(UVETableInfo, UVETableInfo.thrift_spec)), None, ), # 7
  )

  def __init__(self, partition=None, tables=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.partition = partition
    self.tables = tables
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 4086296322
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.partition is not None:
      log_str.write('partition = ')
      log_str.write(str(self.partition))
      log_str.write('  ')
    if self.tables is not None:
      log_str.write('tables = ')
      log_str.write('[ ')
      for iter88 in self.tables:
        log_str.write('<<  ')
        log_str.write(iter88.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 2:
        if ftype == TType.U32:
          (length, self.partition) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 7:
        if ftype == TType.LIST:
          self.tables = []
          (length, _etype92, _size89) = iprot.readListBegin()
          read_cnt += length
          for _i93 in xrange(_size89):
            _elem94 = UVETableInfo()
            read_cnt += _elem94.read(iprot)
            self.tables.append(_elem94)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.partition is not None:
      annotations = {}
      if oprot.writeFieldBegin('partition', TType.U32, 2, annotations) < 0: return -1
      if oprot.writeU32(self.partition) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.tables is not None:
      annotations = {}
      if oprot.writeFieldBegin('tables', TType.LIST, 7, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.tables)) < 0: return -1
      for iter95 in self.tables:
        if iter95.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.partition != other.partition:
      return False
    if self.tables != other.tables:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.partition is not None:
      size += getsizeof(self.partition)
    if self.tables is not None:
      size += getsizeof(self.tables)
      size += sum(map(getsizeof, self.tables))
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVETablePerfReq(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'table', None, None, ), # 1
  )

  def __init__(self, table=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.table = table
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1495906799
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = UVETablePerfReq()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "UVETablePerfReq" not implemented')
    if bottle.request.query.x:
      sandesh_req.table = str(bottle.request.query.x)
    if bottle.request.query.table:
      sandesh_req.table = str(bottle.request.query.table)
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "UVETablePerfReq" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "UVETablePerfReq"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.table is not None:
      log_str.write('table = ')
      log_str.write(self.table)
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.table) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.table is not None:
      annotations = {}
      if oprot.writeFieldBegin('table', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.table) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.table != other.table:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.table is not None:
      size += getsizeof(self.table)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVETablePerfResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.STRING, 'table', None, None, ), # 1
    None, # 2
    (3, TType.U64, 'updates', None, None, ), # 3
    (4, TType.U64, 'get_time', None, None, ), # 4
    (5, TType.U64, 'pub_time', None, None, ), # 5
    (6, TType.U64, 'call_time', None, None, ), # 6
  )

  def __init__(self, table=None, updates=None, get_time=None, pub_time=None, call_time=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.table = table
    self.updates = updates
    self.get_time = get_time
    self.pub_time = pub_time
    self.call_time = call_time
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3628430278
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.table is not None:
      log_str.write('table = ')
      log_str.write(self.table)
      log_str.write('  ')
    if self.updates is not None:
      log_str.write('updates = ')
      log_str.write(str(self.updates))
      log_str.write('  ')
    if self.get_time is not None:
      log_str.write('get_time = ')
      log_str.write(str(self.get_time))
      log_str.write('  ')
    if self.pub_time is not None:
      log_str.write('pub_time = ')
      log_str.write(str(self.pub_time))
      log_str.write('  ')
    if self.call_time is not None:
      log_str.write('call_time = ')
      log_str.write(str(self.call_time))
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.table) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.U64:
          (length, self.updates) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.U64:
          (length, self.get_time) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.U64:
          (length, self.pub_time) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.U64:
          (length, self.call_time) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.table is not None:
      annotations = {}
      if oprot.writeFieldBegin('table', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.table) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.updates is not None:
      annotations = {}
      if oprot.writeFieldBegin('updates', TType.U64, 3, annotations) < 0: return -1
      if oprot.writeU64(self.updates) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.get_time is not None:
      annotations = {}
      if oprot.writeFieldBegin('get_time', TType.U64, 4, annotations) < 0: return -1
      if oprot.writeU64(self.get_time) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.pub_time is not None:
      annotations = {}
      if oprot.writeFieldBegin('pub_time', TType.U64, 5, annotations) < 0: return -1
      if oprot.writeU64(self.pub_time) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.call_time is not None:
      annotations = {}
      if oprot.writeFieldBegin('call_time', TType.U64, 6, annotations) < 0: return -1
      if oprot.writeU64(self.call_time) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.table != other.table:
      return False
    if self.updates != other.updates:
      return False
    if self.get_time != other.get_time:
      return False
    if self.pub_time != other.pub_time:
      return False
    if self.call_time != other.call_time:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.table is not None:
      size += getsizeof(self.table)
    if self.updates is not None:
      size += getsizeof(self.updates)
    if self.get_time is not None:
      size += getsizeof(self.get_time)
    if self.pub_time is not None:
      size += getsizeof(self.pub_time)
    if self.call_time is not None:
      size += getsizeof(self.call_time)
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class AlarmStateChangeTrace(sandesh_base.SandeshTrace):

  thrift_spec = None

  def __init__(self, table=None, uv=None, alarm_type=None, old_state=None, new_state=None, file=None, line=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshTrace.__init__(self, type=SandeshType.TRACE)
    self.str1 = "State change info for alarm:"
    self.table = table
    self.uv = uv
    self.alarm_type = alarm_type
    self.old_state = old_state
    self.new_state = new_state
    self.file = file
    self.line = line
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3947256118
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.str1 is not None:
      log_str.write(self.str1)
      log_str.write('  ')
    if self.table is not None:
      log_str.write(self.table)
      log_str.write('  ')
    if self.uv is not None:
      log_str.write(self.uv)
      log_str.write('  ')
    if self.alarm_type is not None:
      log_str.write(self.alarm_type)
      log_str.write('  ')
    if self.old_state is not None:
      log_str.write(str(self.old_state))
      log_str.write('  ')
    if self.new_state is not None:
      log_str.write(str(self.new_state))
      log_str.write('  ')
    if self.file is not None:
      log_str.write(self.file)
      log_str.write('  ')
    if self.line is not None:
      log_str.write(str(self.line))
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.str1) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.table) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.uv) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.STRING:
          (length, self.alarm_type) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.I32:
          (length, self.old_state) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.I32:
          (length, self.new_state) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == -32768:
        if ftype == TType.STRING:
          (length, self.file) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == -32767:
        if ftype == TType.I32:
          (length, self.line) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.file is not None:
      annotations = {}
      if oprot.writeFieldBegin('file', TType.STRING, -32768, annotations) < 0: return -1
      if oprot.writeString(self.file) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.line is not None:
      annotations = {}
      if oprot.writeFieldBegin('line', TType.I32, -32767, annotations) < 0: return -1
      if oprot.writeI32(self.line) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.str1 is not None:
      annotations = {}
      if oprot.writeFieldBegin('str1', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.str1) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.table is not None:
      annotations = {}
      if oprot.writeFieldBegin('table', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.table) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uv is not None:
      annotations = {}
      if oprot.writeFieldBegin('uv', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.uv) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.alarm_type is not None:
      annotations = {}
      if oprot.writeFieldBegin('alarm_type', TType.STRING, 4, annotations) < 0: return -1
      if oprot.writeString(self.alarm_type) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.old_state is not None:
      annotations = {}
      if oprot.writeFieldBegin('old_state', TType.I32, 5, annotations) < 0: return -1
      if oprot.writeI32(self.old_state) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.new_state is not None:
      annotations = {}
      if oprot.writeFieldBegin('new_state', TType.I32, 6, annotations) < 0: return -1
      if oprot.writeI32(self.new_state) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    if self.str1 is None:
      raise TProtocol.TProtocolException(message='Required field str1 is unset!')
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.file != other.file:
      return False
    if self.line != other.line:
      return False
    if self.str1 != other.str1:
      return False
    if self.table != other.table:
      return False
    if self.uv != other.uv:
      return False
    if self.alarm_type != other.alarm_type:
      return False
    if self.old_state != other.old_state:
      return False
    if self.new_state != other.new_state:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.str1 is not None:
      size += getsizeof(self.str1)
    if self.table is not None:
      size += getsizeof(self.table)
    if self.uv is not None:
      size += getsizeof(self.uv)
    if self.alarm_type is not None:
      size += getsizeof(self.alarm_type)
    if self.old_state is not None:
      size += getsizeof(self.old_state)
    if self.new_state is not None:
      size += getsizeof(self.new_state)
    if self.file is not None:
      size += getsizeof(self.file)
    if self.line is not None:
      size += getsizeof(self.line)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVETableAlarmReq(sandesh_base.SandeshRequest):

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'table', None, None, ), # 1
  )

  def __init__(self, table=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self.table = table
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1495906799
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = UVETableAlarmReq()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "UVETableAlarmReq" not implemented')
    if bottle.request.query.x:
      sandesh_req.table = str(bottle.request.query.x)
    if bottle.request.query.table:
      sandesh_req.table = str(bottle.request.query.table)
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "UVETableAlarmReq" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "UVETableAlarmReq"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.table is not None:
      log_str.write('table = ')
      log_str.write(self.table)
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.table) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.table is not None:
      annotations = {}
      if oprot.writeFieldBegin('table', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.table) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.table != other.table:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.table is not None:
      size += getsizeof(self.table)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVETableAlarmResp(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.STRING, 'table', None, None, ), # 1
    (2, TType.LIST, 'uves', (TType.STRUCT,(UVEAlarmStateMachineInfo, UVEAlarmStateMachineInfo.thrift_spec)), None, ), # 2
  )

  def __init__(self, table=None, uves=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.table = table
    self.uves = uves
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 2188124574
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.table is not None:
      log_str.write('table = ')
      log_str.write(self.table)
      log_str.write('  ')
    if self.uves is not None:
      log_str.write('uves = ')
      log_str.write('[ ')
      for iter96 in self.uves:
        log_str.write('<<  ')
        log_str.write(iter96.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.table) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.LIST:
          self.uves = []
          (length, _etype100, _size97) = iprot.readListBegin()
          read_cnt += length
          for _i101 in xrange(_size97):
            _elem102 = UVEAlarmStateMachineInfo()
            read_cnt += _elem102.read(iprot)
            self.uves.append(_elem102)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.table is not None:
      annotations = {}
      if oprot.writeFieldBegin('table', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.table) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uves is not None:
      annotations = {}
      if oprot.writeFieldBegin('uves', TType.LIST, 2, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.uves)) < 0: return -1
      for iter103 in self.uves:
        if iter103.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.table != other.table:
      return False
    if self.uves != other.uves:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.table is not None:
      size += getsizeof(self.table)
    if self.uves is not None:
      size += getsizeof(self.uves)
      size += sum(map(getsizeof, self.uves))
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class AlarmgenUpdate(sandesh_base.SandeshObject):

  thrift_spec = None

  def __init__(self, name=None, partition=None, table=None, o=None, i=None, file=None, line=None, category='__default__', level=SandeshLevel.SYS_INFO, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshObject.__init__(self)
    self.name = name
    self.partition = partition
    self.table = table
    self.o = o
    self.i = i
    self.file = file
    self.line = line
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3387539007
    self._hints = 0 | SANDESH_KEY_HINT
    self._category = category
    self._level = level

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    if self._category is not None:
      log_str.write(self._category)
    log_str.write(' [')
    log_str.write(SandeshLevel._VALUES_TO_NAMES[self._level])
    log_str.write(']: ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.partition is not None:
      log_str.write('partition = ')
      log_str.write(str(self.partition))
      log_str.write('  ')
    if self.table is not None:
      log_str.write('table = ')
      log_str.write(self.table)
      log_str.write('  ')
    if self.o is not None:
      log_str.write('o = ')
      log_str.write('<<  ')
      log_str.write(self.o.log())
      log_str.write('>>')
      log_str.write('  ')
    if self.i is not None:
      log_str.write('i = ')
      log_str.write('[ ')
      for iter104 in self.i:
        log_str.write('<<  ')
        log_str.write(iter104.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.file is not None:
      log_str.write('file = ')
      log_str.write(self.file)
      log_str.write('  ')
    if self.line is not None:
      log_str.write('line = ')
      log_str.write(str(self.line))
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.U32:
          (length, self.partition) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.STRING:
          (length, self.table) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.STRUCT:
          self.o = UVETableCount()
          read_cnt += self.o.read(iprot)
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.LIST:
          self.i = []
          (length, _etype108, _size105) = iprot.readListBegin()
          read_cnt += length
          for _i109 in xrange(_size105):
            _elem110 = UVETypeInfo()
            read_cnt += _elem110.read(iprot)
            self.i.append(_elem110)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == -32768:
        if ftype == TType.STRING:
          (length, self.file) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == -32767:
        if ftype == TType.I32:
          (length, self.line) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.file is not None:
      annotations = {}
      if oprot.writeFieldBegin('file', TType.STRING, -32768, annotations) < 0: return -1
      if oprot.writeString(self.file) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.line is not None:
      annotations = {}
      if oprot.writeFieldBegin('line', TType.I32, -32767, annotations) < 0: return -1
      if oprot.writeI32(self.line) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.name is not None:
      annotations = {}
      annotations['key'] = 'ObjectGeneratorInfo'
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.partition is not None:
      annotations = {}
      if oprot.writeFieldBegin('partition', TType.U32, 3, annotations) < 0: return -1
      if oprot.writeU32(self.partition) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.table is not None:
      annotations = {}
      if oprot.writeFieldBegin('table', TType.STRING, 4, annotations) < 0: return -1
      if oprot.writeString(self.table) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.o is not None:
      annotations = {}
      annotations['tags'] = 'partition,table'
      if oprot.writeFieldBegin('o', TType.STRUCT, 5, annotations) < 0: return -1
      if self.o.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.i is not None:
      annotations = {}
      annotations['tags'] = 'partition,table,.collector,.generator,.type'
      if oprot.writeFieldBegin('i', TType.LIST, 6, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.i)) < 0: return -1
      for iter111 in self.i:
        if iter111.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.file != other.file:
      return False
    if self.line != other.line:
      return False
    if self.name != other.name:
      return False
    if self.partition != other.partition:
      return False
    if self.table != other.table:
      return False
    if self.o != other.o:
      return False
    if self.i != other.i:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.partition is not None:
      size += getsizeof(self.partition)
    if self.table is not None:
      size += getsizeof(self.table)
    if self.o is not None:
      size += getsizeof(self.o)
    if self.i is not None:
      size += getsizeof(self.i)
      size += sum(map(getsizeof, self.i))
    if self.file is not None:
      size += getsizeof(self.file)
    if self.line is not None:
      size += getsizeof(self.line)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class AlarmgenPartitionTrace(sandesh_base.SandeshUVE):

  thrift_spec = (
    None, # 0
    (1, TType.STRUCT, 'data', (AlarmgenPartition, AlarmgenPartition.thrift_spec), None, ), # 1
  )

  def __init__(self, data=None, table=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshUVE.__init__(self)
    self.data = data
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3075263413
    self._hints = 0 | SANDESH_KEY_HINT
    if table is not None:
      self.data._table = table

  def update_uve(self, tdata):
    if self.data.name is not None:
      tdata.name = self.data.name
    if self.data.inst_parts is not None:
      tdata.inst_parts = self.data.inst_parts
    if self.data.deleted is not None:
      tdata.deleted = self.data.deleted
    return tdata

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.data is not None:
      log_str.write('data = ')
      log_str.write('<<  ')
      log_str.write(self.data.log())
      log_str.write('>>')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRUCT:
          self.data = AlarmgenPartition()
          read_cnt += self.data.read(iprot)
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.data is not None:
      annotations = {}
      if oprot.writeFieldBegin('data', TType.STRUCT, 1, annotations) < 0: return -1
      if self.data.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.data != other.data:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.data is not None:
      size += getsizeof(self.data)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class AlarmgenStatusTrace(sandesh_base.SandeshUVE):

  thrift_spec = (
    None, # 0
    (1, TType.STRUCT, 'data', (AlarmgenStatus, AlarmgenStatus.thrift_spec), None, ), # 1
  )

  def __init__(self, data=None, table=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshUVE.__init__(self)
    self.data = data
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3482224299
    self._hints = 0 | SANDESH_KEY_HINT
    if table is not None:
      self.data._table = table

  def update_uve(self, tdata):
    if self.data.name is not None:
      tdata.name = self.data.name
    if self.data.counters is not None:
      tdata.counters = self.data.counters
    if self.data.alarmgens is not None:
      tdata.alarmgens = self.data.alarmgens
    if self.data.deleted is not None:
      tdata.deleted = self.data.deleted
    return tdata

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.data is not None:
      log_str.write('data = ')
      log_str.write('<<  ')
      log_str.write(self.data.log())
      log_str.write('>>')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRUCT:
          self.data = AlarmgenStatus()
          read_cnt += self.data.read(iprot)
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.data is not None:
      annotations = {}
      if oprot.writeFieldBegin('data', TType.STRUCT, 1, annotations) < 0: return -1
      if self.data.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.data != other.data:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.data is not None:
      size += getsizeof(self.data)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class AlarmgenTrace(sandesh_base.SandeshTrace):

  thrift_spec = None

  def __init__(self, publishers=None, file=None, line=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshTrace.__init__(self, type=SandeshType.TRACE)
    self.str1 = "Alarmgen list from Discovery:"
    self.publishers = publishers
    self.file = file
    self.line = line
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 2703268367
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.str1 is not None:
      log_str.write(self.str1)
      log_str.write('  ')
    if self.publishers is not None:
      log_str.write('[ ')
      for iter112 in self.publishers:
        log_str.write(iter112)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.file is not None:
      log_str.write(self.file)
      log_str.write('  ')
    if self.line is not None:
      log_str.write(str(self.line))
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.str1) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.LIST:
          self.publishers = []
          (length, _etype116, _size113) = iprot.readListBegin()
          read_cnt += length
          for _i117 in xrange(_size113):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem118) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.publishers.append(_elem118)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == -32768:
        if ftype == TType.STRING:
          (length, self.file) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == -32767:
        if ftype == TType.I32:
          (length, self.line) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.file is not None:
      annotations = {}
      if oprot.writeFieldBegin('file', TType.STRING, -32768, annotations) < 0: return -1
      if oprot.writeString(self.file) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.line is not None:
      annotations = {}
      if oprot.writeFieldBegin('line', TType.I32, -32767, annotations) < 0: return -1
      if oprot.writeI32(self.line) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.str1 is not None:
      annotations = {}
      if oprot.writeFieldBegin('str1', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.str1) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.publishers is not None:
      annotations = {}
      if oprot.writeFieldBegin('publishers', TType.LIST, 2, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.publishers)) < 0: return -1
      for iter119 in self.publishers:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter119) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    if self.str1 is None:
      raise TProtocol.TProtocolException(message='Required field str1 is unset!')
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.file != other.file:
      return False
    if self.line != other.line:
      return False
    if self.str1 != other.str1:
      return False
    if self.publishers != other.publishers:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.str1 is not None:
      size += getsizeof(self.str1)
    if self.publishers is not None:
      size += getsizeof(self.publishers)
      size += sum(map(getsizeof, self.publishers))
    if self.file is not None:
      size += getsizeof(self.file)
    if self.line is not None:
      size += getsizeof(self.line)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UVEQTrace(sandesh_base.SandeshTrace):

  thrift_spec = None

  def __init__(self, oper=None, part=None, uves=None, file=None, line=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshTrace.__init__(self, type=SandeshType.TRACE)
    self.oper = oper
    self.part = part
    self.uves = uves
    self.file = file
    self.line = line
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1737706722
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.oper is not None:
      log_str.write(self.oper)
      log_str.write('  ')
    if self.part is not None:
      log_str.write(str(self.part))
      log_str.write('  ')
    if self.uves is not None:
      log_str.write('[ ')
      for iter120 in self.uves:
        log_str.write(iter120)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.file is not None:
      log_str.write(self.file)
      log_str.write('  ')
    if self.line is not None:
      log_str.write(str(self.line))
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.oper) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.U16:
          (length, self.part) = iprot.readU16();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.LIST:
          self.uves = []
          (length, _etype124, _size121) = iprot.readListBegin()
          read_cnt += length
          for _i125 in xrange(_size121):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem126) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.uves.append(_elem126)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == -32768:
        if ftype == TType.STRING:
          (length, self.file) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == -32767:
        if ftype == TType.I32:
          (length, self.line) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.file is not None:
      annotations = {}
      if oprot.writeFieldBegin('file', TType.STRING, -32768, annotations) < 0: return -1
      if oprot.writeString(self.file) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.line is not None:
      annotations = {}
      if oprot.writeFieldBegin('line', TType.I32, -32767, annotations) < 0: return -1
      if oprot.writeI32(self.line) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.oper is not None:
      annotations = {}
      if oprot.writeFieldBegin('oper', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.oper) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.part is not None:
      annotations = {}
      if oprot.writeFieldBegin('part', TType.U16, 2, annotations) < 0: return -1
      if oprot.writeU16(self.part) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.uves is not None:
      annotations = {}
      if oprot.writeFieldBegin('uves', TType.LIST, 3, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.uves)) < 0: return -1
      for iter127 in self.uves:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter127) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.file != other.file:
      return False
    if self.line != other.line:
      return False
    if self.oper != other.oper:
      return False
    if self.part != other.part:
      return False
    if self.uves != other.uves:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.oper is not None:
      size += getsizeof(self.oper)
    if self.part is not None:
      size += getsizeof(self.part)
    if self.uves is not None:
      size += getsizeof(self.uves)
      size += sum(map(getsizeof, self.uves))
    if self.file is not None:
      size += getsizeof(self.file)
    if self.line is not None:
      size += getsizeof(self.line)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)


_SANDESH_REQUEST_LIST = [
PartitionOwnershipReq,
PartitionStatusReq,
UVETableInfoReq,
UVETablePerfReq,
UVETableAlarmReq,
]


_SANDESH_UVE_LIST = [
(AlarmgenPartitionTrace, AlarmgenPartition),
(AlarmgenStatusTrace, AlarmgenStatus),
]


_SANDESH_ALARM_LIST = [
]
