#
# Autogenerated by Sandesh Compiler (1.0)
#
# DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
#
#  options string: py:new_style
# Copyright (c) 2013 Juniper Networks, Inc. All rights reserved.
#

from pysandesh.Thrift import TType, TMessageType, TException
import cpuinfo.ttypes
import process_info.ttypes
import derived_stats_results.ttypes


from pysandesh.transport import TTransport
from pysandesh.protocol import TBinaryProtocol, TProtocol
try:
  from pysandesh.protocol import fastbinary
except:
  fastbinary = None

import cStringIO
import uuid
import netaddr
from sys import getsizeof
from itertools import chain
import bottle
from pysandesh import sandesh_base
from pysandesh.sandesh_http import SandeshHttp
from pysandesh.sandesh_uve import SandeshUVETypeMaps
from pysandesh.util import UTCTimestampUsec, UTCTimestampUsecToString
from pysandesh import util
from pysandesh.gen_py.sandesh.constants import *



class ModuleCpuInfo(object):
  """
  This structure carries process's memory and cpu information on
  a per module per instance basis

  Attributes:
   - module_id
   - instance_id
   - cpu_info
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'module_id', None, None, ), # 1
    (2, TType.STRING, 'instance_id', None, None, ), # 2
    None, # 3
    (4, TType.STRUCT, 'cpu_info', (cpuinfo.ttypes.CpuLoadInfo, cpuinfo.ttypes.CpuLoadInfo.thrift_spec), None, ), # 4
  )

  def __init__(self, module_id=None, instance_id=None, cpu_info=None,):
    self.module_id = module_id
    self.instance_id = instance_id
    self.cpu_info = cpu_info

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.module_id) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.instance_id) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.STRUCT:
          self.cpu_info = cpuinfo.ttypes.CpuLoadInfo()
          read_cnt += self.cpu_info.read(iprot)
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.module_id is not None:
      annotations = {}
      if oprot.writeFieldBegin('module_id', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.module_id) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.instance_id is not None:
      annotations = {}
      if oprot.writeFieldBegin('instance_id', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.instance_id) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.cpu_info is not None:
      annotations = {}
      if oprot.writeFieldBegin('cpu_info', TType.STRUCT, 4, annotations) < 0: return -1
      if self.cpu_info.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.module_id is not None:
      log_str.write('module_id = ')
      log_str.write(self.module_id)
      log_str.write('  ')
    if self.instance_id is not None:
      log_str.write('instance_id = ')
      log_str.write(self.instance_id)
      log_str.write('  ')
    if self.cpu_info is not None:
      log_str.write('cpu_info = ')
      log_str.write('<<  ')
      log_str.write(self.cpu_info.log())
      log_str.write('>>')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.module_id is not None:
      size += getsizeof(self.module_id)
    if self.instance_id is not None:
      size += getsizeof(self.instance_id)
    if self.cpu_info is not None:
      size += getsizeof(self.cpu_info)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class ModuleCpuState(object):
  """
  This structure carries memory and cpu information for a list
  of processes

  Attributes:
   - name
   - deleted
   - module_cpu_info
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.BOOL, 'deleted', None, None, ), # 2
    None, # 3
    (4, TType.LIST, 'module_cpu_info', (TType.STRUCT,(ModuleCpuInfo, ModuleCpuInfo.thrift_spec)), None, ), # 4
  )

  def __init__(self, name=None, deleted=None, module_cpu_info=None,):
    self.name = name
    self.deleted = deleted
    self.module_cpu_info = module_cpu_info
    self._table = 'ObjectCollectorInfo'

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.BOOL:
          (length, self.deleted) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.LIST:
          self.module_cpu_info = []
          (length, _etype3, _size0) = iprot.readListBegin()
          read_cnt += length
          for _i4 in xrange(_size0):
            _elem5 = ModuleCpuInfo()
            read_cnt += _elem5.read(iprot)
            self.module_cpu_info.append(_elem5)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if self._table is None or self._table is '': return -1
      annotations['key'] = self._table
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.deleted is not None:
      annotations = {}
      if oprot.writeFieldBegin('deleted', TType.BOOL, 2, annotations) < 0: return -1
      if oprot.writeBool(self.deleted) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.module_cpu_info is not None:
      annotations = {}
      annotations['aggtype'] = 'union'
      if oprot.writeFieldBegin('module_cpu_info', TType.LIST, 4, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.module_cpu_info)) < 0: return -1
      for iter6 in self.module_cpu_info:
        if iter6.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.deleted is not None:
      log_str.write('deleted = ')
      if self.deleted:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    if self.module_cpu_info is not None:
      log_str.write('module_cpu_info = ')
      log_str.write('[ ')
      for iter7 in self.module_cpu_info:
        log_str.write('<<  ')
        log_str.write(iter7.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.deleted is not None:
      size += getsizeof(self.deleted)
    if self.module_cpu_info is not None:
      size += getsizeof(self.module_cpu_info)
      size += sum(map(getsizeof, self.module_cpu_info))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class AnalyticsCpuState(object):
  """
  This structure carries process's memory and cpu information,
  these are used as stats fields in the Analytics Node UVE. As with any other
  stats, these can be used for any slice/dice queries

  Attributes:
   - name
   - deleted
   - cpu_info
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.BOOL, 'deleted', None, None, ), # 2
    (3, TType.LIST, 'cpu_info', (TType.STRUCT,(cpuinfo.ttypes.ProcessCpuInfo, cpuinfo.ttypes.ProcessCpuInfo.thrift_spec)), None, ), # 3
  )

  def __init__(self, name=None, deleted=None, cpu_info=None,):
    self.name = name
    self.deleted = deleted
    self.cpu_info = cpu_info
    self._table = 'ObjectCollectorInfo'

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.BOOL:
          (length, self.deleted) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.LIST:
          self.cpu_info = []
          (length, _etype11, _size8) = iprot.readListBegin()
          read_cnt += length
          for _i12 in xrange(_size8):
            _elem13 = cpuinfo.ttypes.ProcessCpuInfo()
            read_cnt += _elem13.read(iprot)
            self.cpu_info.append(_elem13)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if self._table is None or self._table is '': return -1
      annotations['key'] = self._table
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.deleted is not None:
      annotations = {}
      if oprot.writeFieldBegin('deleted', TType.BOOL, 2, annotations) < 0: return -1
      if oprot.writeBool(self.deleted) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.cpu_info is not None:
      annotations = {}
      annotations['aggtype'] = 'union'
      annotations['tags'] = '.module_id,.mem_virt,.cpu_share,.mem_res'
      if oprot.writeFieldBegin('cpu_info', TType.LIST, 3, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.cpu_info)) < 0: return -1
      for iter14 in self.cpu_info:
        if iter14.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.deleted is not None:
      log_str.write('deleted = ')
      if self.deleted:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    if self.cpu_info is not None:
      log_str.write('cpu_info = ')
      log_str.write('[ ')
      for iter15 in self.cpu_info:
        log_str.write('<<  ')
        log_str.write(iter15.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.deleted is not None:
      size += getsizeof(self.deleted)
    if self.cpu_info is not None:
      size += getsizeof(self.cpu_info)
      size += sum(map(getsizeof, self.cpu_info))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class NodeStatus(object):
  """
  This structure used to send NodeStatus data for Analytics Node
  - process_status carries process's status [functional/non-functional]
  - process_info carries process's state [up/down]
  Each of the processes on Analytics Node will send this information and aggregation
  will happen on UVE queries.

  Attributes:
   - name
   - deleted
   - status
   - process_status
   - process_info
   - disk_usage_info
   - description
   - all_core_file_list
   - process_mem_cpu_usage
   - system_mem_cpu_usage
   - system_cpu_info
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.BOOL, 'deleted', None, None, ), # 2
    (3, TType.STRING, 'status', None, None, ), # 3
    (4, TType.LIST, 'process_status', (TType.STRUCT,(process_info.ttypes.ProcessStatus, process_info.ttypes.ProcessStatus.thrift_spec)), None, ), # 4
    (5, TType.LIST, 'process_info', (TType.STRUCT,(process_info.ttypes.ProcessInfo, process_info.ttypes.ProcessInfo.thrift_spec)), None, ), # 5
    (6, TType.LIST, 'disk_usage_info', (TType.STRUCT,(process_info.ttypes.DiskPartitionUsageStats, process_info.ttypes.DiskPartitionUsageStats.thrift_spec)), None, ), # 6
    (7, TType.STRING, 'description', None, None, ), # 7
    (8, TType.LIST, 'all_core_file_list', (TType.STRING,None), None, ), # 8
    None, # 9
    (10, TType.LIST, 'process_mem_cpu_usage', (TType.STRUCT,(cpuinfo.ttypes.ProcessCpuInfo, cpuinfo.ttypes.ProcessCpuInfo.thrift_spec)), None, ), # 10
    (11, TType.STRUCT, 'system_mem_cpu_usage', (cpuinfo.ttypes.SystemMemCpuUsage, cpuinfo.ttypes.SystemMemCpuUsage.thrift_spec), None, ), # 11
    (12, TType.STRUCT, 'system_cpu_info', (cpuinfo.ttypes.SystemCpuInfo, cpuinfo.ttypes.SystemCpuInfo.thrift_spec), None, ), # 12
  )

  def __init__(self, name=None, deleted=None, status=None, process_status=None, process_info=None, disk_usage_info=None, description=None, all_core_file_list=None, process_mem_cpu_usage=None, system_mem_cpu_usage=None, system_cpu_info=None,):
    self.name = name
    self.deleted = deleted
    self.status = status
    self.process_status = process_status
    self.process_info = process_info
    self.disk_usage_info = disk_usage_info
    self.description = description
    self.all_core_file_list = all_core_file_list
    self.process_mem_cpu_usage = process_mem_cpu_usage
    self.system_mem_cpu_usage = system_mem_cpu_usage
    self.system_cpu_info = system_cpu_info
    self._table = 'ObjectCollectorInfo'

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.BOOL:
          (length, self.deleted) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.status) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.LIST:
          self.process_status = []
          (length, _etype19, _size16) = iprot.readListBegin()
          read_cnt += length
          for _i20 in xrange(_size16):
            _elem21 = process_info.ttypes.ProcessStatus()
            read_cnt += _elem21.read(iprot)
            self.process_status.append(_elem21)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.LIST:
          self.process_info = []
          (length, _etype25, _size22) = iprot.readListBegin()
          read_cnt += length
          for _i26 in xrange(_size22):
            _elem27 = process_info.ttypes.ProcessInfo()
            read_cnt += _elem27.read(iprot)
            self.process_info.append(_elem27)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.LIST:
          self.disk_usage_info = []
          (length, _etype31, _size28) = iprot.readListBegin()
          read_cnt += length
          for _i32 in xrange(_size28):
            _elem33 = process_info.ttypes.DiskPartitionUsageStats()
            read_cnt += _elem33.read(iprot)
            self.disk_usage_info.append(_elem33)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 7:
        if ftype == TType.STRING:
          (length, self.description) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 8:
        if ftype == TType.LIST:
          self.all_core_file_list = []
          (length, _etype37, _size34) = iprot.readListBegin()
          read_cnt += length
          for _i38 in xrange(_size34):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem39) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.all_core_file_list.append(_elem39)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 10:
        if ftype == TType.LIST:
          self.process_mem_cpu_usage = []
          (length, _etype43, _size40) = iprot.readListBegin()
          read_cnt += length
          for _i44 in xrange(_size40):
            _elem45 = cpuinfo.ttypes.ProcessCpuInfo()
            read_cnt += _elem45.read(iprot)
            self.process_mem_cpu_usage.append(_elem45)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 11:
        if ftype == TType.STRUCT:
          self.system_mem_cpu_usage = cpuinfo.ttypes.SystemMemCpuUsage()
          read_cnt += self.system_mem_cpu_usage.read(iprot)
        else:
          iprot.skip(ftype)
      elif fid == 12:
        if ftype == TType.STRUCT:
          self.system_cpu_info = cpuinfo.ttypes.SystemCpuInfo()
          read_cnt += self.system_cpu_info.read(iprot)
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if self._table is None or self._table is '': return -1
      annotations['key'] = self._table
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.deleted is not None:
      annotations = {}
      if oprot.writeFieldBegin('deleted', TType.BOOL, 2, annotations) < 0: return -1
      if oprot.writeBool(self.deleted) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.status is not None:
      annotations = {}
      if oprot.writeFieldBegin('status', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.status) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.process_status is not None:
      annotations = {}
      annotations['aggtype'] = 'union'
      if oprot.writeFieldBegin('process_status', TType.LIST, 4, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.process_status)) < 0: return -1
      for iter46 in self.process_status:
        if iter46.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.process_info is not None:
      annotations = {}
      annotations['aggtype'] = 'union'
      if oprot.writeFieldBegin('process_info', TType.LIST, 5, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.process_info)) < 0: return -1
      for iter47 in self.process_info:
        if iter47.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.disk_usage_info is not None:
      annotations = {}
      annotations['tags'] = ''
      if oprot.writeFieldBegin('disk_usage_info', TType.LIST, 6, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.disk_usage_info)) < 0: return -1
      for iter48 in self.disk_usage_info:
        if iter48.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.description is not None:
      annotations = {}
      if oprot.writeFieldBegin('description', TType.STRING, 7, annotations) < 0: return -1
      if oprot.writeString(self.description) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.all_core_file_list is not None:
      annotations = {}
      if oprot.writeFieldBegin('all_core_file_list', TType.LIST, 8, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.all_core_file_list)) < 0: return -1
      for iter49 in self.all_core_file_list:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter49) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.process_mem_cpu_usage is not None:
      annotations = {}
      annotations['aggtype'] = 'union'
      if oprot.writeFieldBegin('process_mem_cpu_usage', TType.LIST, 10, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.process_mem_cpu_usage)) < 0: return -1
      for iter50 in self.process_mem_cpu_usage:
        if iter50.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.system_mem_cpu_usage is not None:
      annotations = {}
      if oprot.writeFieldBegin('system_mem_cpu_usage', TType.STRUCT, 11, annotations) < 0: return -1
      if self.system_mem_cpu_usage.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.system_cpu_info is not None:
      annotations = {}
      if oprot.writeFieldBegin('system_cpu_info', TType.STRUCT, 12, annotations) < 0: return -1
      if self.system_cpu_info.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.deleted is not None:
      log_str.write('deleted = ')
      if self.deleted:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    if self.status is not None:
      log_str.write('status = ')
      log_str.write(self.status)
      log_str.write('  ')
    if self.process_status is not None:
      log_str.write('process_status = ')
      log_str.write('[ ')
      for iter51 in self.process_status:
        log_str.write('<<  ')
        log_str.write(iter51.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.process_info is not None:
      log_str.write('process_info = ')
      log_str.write('[ ')
      for iter52 in self.process_info:
        log_str.write('<<  ')
        log_str.write(iter52.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.disk_usage_info is not None:
      log_str.write('disk_usage_info = ')
      log_str.write('[ ')
      for iter53 in self.disk_usage_info:
        log_str.write('<<  ')
        log_str.write(iter53.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.description is not None:
      log_str.write('description = ')
      log_str.write(self.description)
      log_str.write('  ')
    if self.all_core_file_list is not None:
      log_str.write('all_core_file_list = ')
      log_str.write('[ ')
      for iter54 in self.all_core_file_list:
        log_str.write(iter54)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.process_mem_cpu_usage is not None:
      log_str.write('process_mem_cpu_usage = ')
      log_str.write('[ ')
      for iter55 in self.process_mem_cpu_usage:
        log_str.write('<<  ')
        log_str.write(iter55.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.system_mem_cpu_usage is not None:
      log_str.write('system_mem_cpu_usage = ')
      log_str.write('<<  ')
      log_str.write(self.system_mem_cpu_usage.log())
      log_str.write('>>')
      log_str.write('  ')
    if self.system_cpu_info is not None:
      log_str.write('system_cpu_info = ')
      log_str.write('<<  ')
      log_str.write(self.system_cpu_info.log())
      log_str.write('>>')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.deleted is not None:
      size += getsizeof(self.deleted)
    if self.status is not None:
      size += getsizeof(self.status)
    if self.process_status is not None:
      size += getsizeof(self.process_status)
      size += sum(map(getsizeof, self.process_status))
    if self.process_info is not None:
      size += getsizeof(self.process_info)
      size += sum(map(getsizeof, self.process_info))
    if self.disk_usage_info is not None:
      size += getsizeof(self.disk_usage_info)
      size += sum(map(getsizeof, self.disk_usage_info))
    if self.description is not None:
      size += getsizeof(self.description)
    if self.all_core_file_list is not None:
      size += getsizeof(self.all_core_file_list)
      size += sum(map(getsizeof, self.all_core_file_list))
    if self.process_mem_cpu_usage is not None:
      size += getsizeof(self.process_mem_cpu_usage)
      size += sum(map(getsizeof, self.process_mem_cpu_usage))
    if self.system_mem_cpu_usage is not None:
      size += getsizeof(self.system_mem_cpu_usage)
    if self.system_cpu_info is not None:
      size += getsizeof(self.system_cpu_info)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class QueryStats(object):
  """
  structure to carry contrail-query-engine query statistics

  Attributes:
   - qid
   - where
   - select
   - post
   - time_span
   - error
   - chunks
   - chunk_where_time
   - chunk_select_time
   - chunk_postproc_time
   - chunk_merge_time
   - final_merge_time
   - time
   - rows
   - enq_delay
  """

  thrift_spec = (
    None, # 0
    None, # 1
    (2, TType.STRING, 'qid', None, None, ), # 2
    (3, TType.U32, 'chunks', None, None, ), # 3
    (4, TType.STRING, 'chunk_where_time', None, None, ), # 4
    (5, TType.STRING, 'chunk_select_time', None, None, ), # 5
    (6, TType.STRING, 'chunk_postproc_time', None, None, ), # 6
    (7, TType.STRING, 'chunk_merge_time', None, None, ), # 7
    (8, TType.U32, 'final_merge_time', None, None, ), # 8
    (9, TType.U32, 'time', None, None, ), # 9
    (10, TType.U32, 'rows', None, None, ), # 10
    (11, TType.U32, 'enq_delay', None, None, ), # 11
    None, # 12
    None, # 13
    None, # 14
    None, # 15
    None, # 16
    None, # 17
    None, # 18
    None, # 19
    (20, TType.STRING, 'where', None, None, ), # 20
    (21, TType.STRING, 'select', None, None, ), # 21
    (22, TType.STRING, 'post', None, None, ), # 22
    (23, TType.U32, 'time_span', None, None, ), # 23
    (24, TType.STRING, 'error', None, None, ), # 24
  )

  def __init__(self, qid=None, where=None, select=None, post=None, time_span=None, error=None, chunks=None, chunk_where_time=None, chunk_select_time=None, chunk_postproc_time=None, chunk_merge_time=None, final_merge_time=None, time=None, rows=None, enq_delay=None,):
    self.qid = qid
    self.where = where
    self.select = select
    self.post = post
    self.time_span = time_span
    self.error = error
    self.chunks = chunks
    self.chunk_where_time = chunk_where_time
    self.chunk_select_time = chunk_select_time
    self.chunk_postproc_time = chunk_postproc_time
    self.chunk_merge_time = chunk_merge_time
    self.final_merge_time = final_merge_time
    self.time = time
    self.rows = rows
    self.enq_delay = enq_delay

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 2:
        if ftype == TType.STRING:
          (length, self.qid) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 20:
        if ftype == TType.STRING:
          (length, self.where) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 21:
        if ftype == TType.STRING:
          (length, self.select) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 22:
        if ftype == TType.STRING:
          (length, self.post) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 23:
        if ftype == TType.U32:
          (length, self.time_span) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 24:
        if ftype == TType.STRING:
          (length, self.error) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.U32:
          (length, self.chunks) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.STRING:
          (length, self.chunk_where_time) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.STRING:
          (length, self.chunk_select_time) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.STRING:
          (length, self.chunk_postproc_time) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 7:
        if ftype == TType.STRING:
          (length, self.chunk_merge_time) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 8:
        if ftype == TType.U32:
          (length, self.final_merge_time) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 9:
        if ftype == TType.U32:
          (length, self.time) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 10:
        if ftype == TType.U32:
          (length, self.rows) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 11:
        if ftype == TType.U32:
          (length, self.enq_delay) = iprot.readU32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.qid is not None:
      annotations = {}
      if oprot.writeFieldBegin('qid', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.qid) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.chunks is not None:
      annotations = {}
      if oprot.writeFieldBegin('chunks', TType.U32, 3, annotations) < 0: return -1
      if oprot.writeU32(self.chunks) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.chunk_where_time is not None:
      annotations = {}
      if oprot.writeFieldBegin('chunk_where_time', TType.STRING, 4, annotations) < 0: return -1
      if oprot.writeString(self.chunk_where_time) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.chunk_select_time is not None:
      annotations = {}
      if oprot.writeFieldBegin('chunk_select_time', TType.STRING, 5, annotations) < 0: return -1
      if oprot.writeString(self.chunk_select_time) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.chunk_postproc_time is not None:
      annotations = {}
      if oprot.writeFieldBegin('chunk_postproc_time', TType.STRING, 6, annotations) < 0: return -1
      if oprot.writeString(self.chunk_postproc_time) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.chunk_merge_time is not None:
      annotations = {}
      if oprot.writeFieldBegin('chunk_merge_time', TType.STRING, 7, annotations) < 0: return -1
      if oprot.writeString(self.chunk_merge_time) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.final_merge_time is not None:
      annotations = {}
      if oprot.writeFieldBegin('final_merge_time', TType.U32, 8, annotations) < 0: return -1
      if oprot.writeU32(self.final_merge_time) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.time is not None:
      annotations = {}
      if oprot.writeFieldBegin('time', TType.U32, 9, annotations) < 0: return -1
      if oprot.writeU32(self.time) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.rows is not None:
      annotations = {}
      if oprot.writeFieldBegin('rows', TType.U32, 10, annotations) < 0: return -1
      if oprot.writeU32(self.rows) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.enq_delay is not None:
      annotations = {}
      if oprot.writeFieldBegin('enq_delay', TType.U32, 11, annotations) < 0: return -1
      if oprot.writeU32(self.enq_delay) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.where is not None:
      annotations = {}
      if oprot.writeFieldBegin('where', TType.STRING, 20, annotations) < 0: return -1
      if oprot.writeString(self.where) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.select is not None:
      annotations = {}
      if oprot.writeFieldBegin('select', TType.STRING, 21, annotations) < 0: return -1
      if oprot.writeString(self.select) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.post is not None:
      annotations = {}
      if oprot.writeFieldBegin('post', TType.STRING, 22, annotations) < 0: return -1
      if oprot.writeString(self.post) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.time_span is not None:
      annotations = {}
      if oprot.writeFieldBegin('time_span', TType.U32, 23, annotations) < 0: return -1
      if oprot.writeU32(self.time_span) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.error is not None:
      annotations = {}
      if oprot.writeFieldBegin('error', TType.STRING, 24, annotations) < 0: return -1
      if oprot.writeString(self.error) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.qid is not None:
      log_str.write('qid = ')
      log_str.write(self.qid)
      log_str.write('  ')
    if self.where is not None:
      log_str.write('where = ')
      log_str.write(self.where)
      log_str.write('  ')
    if self.select is not None:
      log_str.write('select = ')
      log_str.write(self.select)
      log_str.write('  ')
    if self.post is not None:
      log_str.write('post = ')
      log_str.write(self.post)
      log_str.write('  ')
    if self.time_span is not None:
      log_str.write('time_span = ')
      log_str.write(str(self.time_span))
      log_str.write('  ')
    if self.error is not None:
      log_str.write('error = ')
      log_str.write(self.error)
      log_str.write('  ')
    if self.chunks is not None:
      log_str.write('chunks = ')
      log_str.write(str(self.chunks))
      log_str.write('  ')
    if self.chunk_where_time is not None:
      log_str.write('chunk_where_time = ')
      log_str.write(self.chunk_where_time)
      log_str.write('  ')
    if self.chunk_select_time is not None:
      log_str.write('chunk_select_time = ')
      log_str.write(self.chunk_select_time)
      log_str.write('  ')
    if self.chunk_postproc_time is not None:
      log_str.write('chunk_postproc_time = ')
      log_str.write(self.chunk_postproc_time)
      log_str.write('  ')
    if self.chunk_merge_time is not None:
      log_str.write('chunk_merge_time = ')
      log_str.write(self.chunk_merge_time)
      log_str.write('  ')
    if self.final_merge_time is not None:
      log_str.write('final_merge_time = ')
      log_str.write(str(self.final_merge_time))
      log_str.write('  ')
    if self.time is not None:
      log_str.write('time = ')
      log_str.write(str(self.time))
      log_str.write('  ')
    if self.rows is not None:
      log_str.write('rows = ')
      log_str.write(str(self.rows))
      log_str.write('  ')
    if self.enq_delay is not None:
      log_str.write('enq_delay = ')
      log_str.write(str(self.enq_delay))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.qid is not None:
      size += getsizeof(self.qid)
    if self.where is not None:
      size += getsizeof(self.where)
    if self.select is not None:
      size += getsizeof(self.select)
    if self.post is not None:
      size += getsizeof(self.post)
    if self.time_span is not None:
      size += getsizeof(self.time_span)
    if self.error is not None:
      size += getsizeof(self.error)
    if self.chunks is not None:
      size += getsizeof(self.chunks)
    if self.chunk_where_time is not None:
      size += getsizeof(self.chunk_where_time)
    if self.chunk_select_time is not None:
      size += getsizeof(self.chunk_select_time)
    if self.chunk_postproc_time is not None:
      size += getsizeof(self.chunk_postproc_time)
    if self.chunk_merge_time is not None:
      size += getsizeof(self.chunk_merge_time)
    if self.final_merge_time is not None:
      size += getsizeof(self.final_merge_time)
    if self.time is not None:
      size += getsizeof(self.time)
    if self.rows is not None:
      size += getsizeof(self.rows)
    if self.enq_delay is not None:
      size += getsizeof(self.enq_delay)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class AnalyticsApiSample(object):
  """
  structure to carry contrail-analytics-api query statistics

  Attributes:
   - operation_type
   - remote_ip
   - object_type
   - request_url
   - response_time_in_usec
   - response_size_objects
   - response_size_bytes
   - resp_code
   - useragent
   - node
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'operation_type', None, None, ), # 1
    None, # 2
    (3, TType.STRING, 'remote_ip', None, None, ), # 3
    None, # 4
    (5, TType.STRING, 'object_type', None, None, ), # 5
    (6, TType.STRING, 'request_url', None, None, ), # 6
    None, # 7
    (8, TType.U64, 'response_time_in_usec', None, None, ), # 8
    (9, TType.U64, 'response_size_objects', None, None, ), # 9
    (10, TType.STRING, 'node', None, None, ), # 10
    (11, TType.U64, 'response_size_bytes', None, None, ), # 11
    (12, TType.STRING, 'resp_code', None, None, ), # 12
    (13, TType.STRING, 'useragent', None, None, ), # 13
  )

  def __init__(self, operation_type=None, remote_ip=None, object_type=None, request_url=None, response_time_in_usec=None, response_size_objects=None, response_size_bytes=None, resp_code=None, useragent=None, node=None,):
    self.operation_type = operation_type
    self.remote_ip = remote_ip
    self.object_type = object_type
    self.request_url = request_url
    self.response_time_in_usec = response_time_in_usec
    self.response_size_objects = response_size_objects
    self.response_size_bytes = response_size_bytes
    self.resp_code = resp_code
    self.useragent = useragent
    self.node = node

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.operation_type) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.remote_ip) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.STRING:
          (length, self.object_type) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.STRING:
          (length, self.request_url) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 8:
        if ftype == TType.U64:
          (length, self.response_time_in_usec) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 9:
        if ftype == TType.U64:
          (length, self.response_size_objects) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 11:
        if ftype == TType.U64:
          (length, self.response_size_bytes) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 12:
        if ftype == TType.STRING:
          (length, self.resp_code) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 13:
        if ftype == TType.STRING:
          (length, self.useragent) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 10:
        if ftype == TType.STRING:
          (length, self.node) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.operation_type is not None:
      annotations = {}
      if oprot.writeFieldBegin('operation_type', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.operation_type) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.remote_ip is not None:
      annotations = {}
      if oprot.writeFieldBegin('remote_ip', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.remote_ip) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.object_type is not None:
      annotations = {}
      if oprot.writeFieldBegin('object_type', TType.STRING, 5, annotations) < 0: return -1
      if oprot.writeString(self.object_type) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.request_url is not None:
      annotations = {}
      if oprot.writeFieldBegin('request_url', TType.STRING, 6, annotations) < 0: return -1
      if oprot.writeString(self.request_url) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.response_time_in_usec is not None:
      annotations = {}
      if oprot.writeFieldBegin('response_time_in_usec', TType.U64, 8, annotations) < 0: return -1
      if oprot.writeU64(self.response_time_in_usec) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.response_size_objects is not None:
      annotations = {}
      if oprot.writeFieldBegin('response_size_objects', TType.U64, 9, annotations) < 0: return -1
      if oprot.writeU64(self.response_size_objects) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.node is not None:
      annotations = {}
      annotations['key'] = 'ObjectCollectorInfo'
      if oprot.writeFieldBegin('node', TType.STRING, 10, annotations) < 0: return -1
      if oprot.writeString(self.node) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.response_size_bytes is not None:
      annotations = {}
      if oprot.writeFieldBegin('response_size_bytes', TType.U64, 11, annotations) < 0: return -1
      if oprot.writeU64(self.response_size_bytes) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.resp_code is not None:
      annotations = {}
      if oprot.writeFieldBegin('resp_code', TType.STRING, 12, annotations) < 0: return -1
      if oprot.writeString(self.resp_code) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.useragent is not None:
      annotations = {}
      if oprot.writeFieldBegin('useragent', TType.STRING, 13, annotations) < 0: return -1
      if oprot.writeString(self.useragent) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.operation_type is not None:
      log_str.write('operation_type = ')
      log_str.write(self.operation_type)
      log_str.write('  ')
    if self.remote_ip is not None:
      log_str.write('remote_ip = ')
      log_str.write(self.remote_ip)
      log_str.write('  ')
    if self.object_type is not None:
      log_str.write('object_type = ')
      log_str.write(self.object_type)
      log_str.write('  ')
    if self.request_url is not None:
      log_str.write('request_url = ')
      log_str.write(self.request_url)
      log_str.write('  ')
    if self.response_time_in_usec is not None:
      log_str.write('response_time_in_usec = ')
      log_str.write(str(self.response_time_in_usec))
      log_str.write('  ')
    if self.response_size_objects is not None:
      log_str.write('response_size_objects = ')
      log_str.write(str(self.response_size_objects))
      log_str.write('  ')
    if self.response_size_bytes is not None:
      log_str.write('response_size_bytes = ')
      log_str.write(str(self.response_size_bytes))
      log_str.write('  ')
    if self.resp_code is not None:
      log_str.write('resp_code = ')
      log_str.write(self.resp_code)
      log_str.write('  ')
    if self.useragent is not None:
      log_str.write('useragent = ')
      log_str.write(self.useragent)
      log_str.write('  ')
    if self.node is not None:
      log_str.write('node = ')
      log_str.write(self.node)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.operation_type is not None:
      size += getsizeof(self.operation_type)
    if self.remote_ip is not None:
      size += getsizeof(self.remote_ip)
    if self.object_type is not None:
      size += getsizeof(self.object_type)
    if self.request_url is not None:
      size += getsizeof(self.request_url)
    if self.response_time_in_usec is not None:
      size += getsizeof(self.response_time_in_usec)
    if self.response_size_objects is not None:
      size += getsizeof(self.response_size_objects)
    if self.response_size_bytes is not None:
      size += getsizeof(self.response_size_bytes)
    if self.resp_code is not None:
      size += getsizeof(self.resp_code)
    if self.useragent is not None:
      size += getsizeof(self.useragent)
    if self.node is not None:
      size += getsizeof(self.node)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class uint64_t_P_(object):
  """
  This structure is used to send UserDefinedCounter data
  - name: user given name to identify the counter
  - rx_event it is hit everytime conter is hit
  - count total number of hits happened


  Attributes:
   - current
   - previous
  """

  thrift_spec = (
    None, # 0
    (1, TType.U64, 'current', None, None, ), # 1
    (2, TType.U64, 'previous', None, None, ), # 2
  )

  def __init__(self, current=None, previous=None,):
    self.current = current
    self.previous = previous

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.U64:
          (length, self.current) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.U64:
          (length, self.previous) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.current is not None:
      annotations = {}
      if oprot.writeFieldBegin('current', TType.U64, 1, annotations) < 0: return -1
      if oprot.writeU64(self.current) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.previous is not None:
      annotations = {}
      if oprot.writeFieldBegin('previous', TType.U64, 2, annotations) < 0: return -1
      if oprot.writeU64(self.previous) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.current is not None:
      log_str.write('current = ')
      log_str.write(str(self.current))
      log_str.write('  ')
    if self.previous is not None:
      log_str.write('previous = ')
      log_str.write(str(self.previous))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.current is not None:
      size += getsizeof(self.current)
    if self.previous is not None:
      size += getsizeof(self.previous)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UserDefinedCounter(object):
  """
  Attributes:
   - name
   - deleted
   - rx_event
   - count
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.BOOL, 'deleted', None, None, ), # 2
    (3, TType.U64, 'rx_event', None, None, ), # 3
    (4, TType.STRUCT, 'count', (uint64_t_P_, uint64_t_P_.thrift_spec), None, ), # 4
  )

  def __init__(self, name=None, deleted=None, rx_event=None, count=None,):
    self.name = name
    self.deleted = deleted
    self.rx_event = rx_event
    self.count = count
    self._table = 'UserDefinedCounterTable'

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.BOOL:
          (length, self.deleted) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.U64:
          (length, self.rx_event) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.STRUCT:
          self.count = uint64_t_P_()
          read_cnt += self.count.read(iprot)
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if self._table is None or self._table is '': return -1
      annotations['key'] = self._table
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.deleted is not None:
      annotations = {}
      if oprot.writeFieldBegin('deleted', TType.BOOL, 2, annotations) < 0: return -1
      if oprot.writeBool(self.deleted) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.rx_event is not None:
      annotations = {}
      annotations['hidden'] = 'yes'
      if oprot.writeFieldBegin('rx_event', TType.U64, 3, annotations) < 0: return -1
      if oprot.writeU64(self.rx_event) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.count is not None:
      annotations = {}
      annotations['stats'] = 'rx_event:DSSum:'
      annotations['tags'] = ''
      if oprot.writeFieldBegin('count', TType.STRUCT, 4, annotations) < 0: return -1
      if self.count.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.deleted is not None:
      log_str.write('deleted = ')
      if self.deleted:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    if self.rx_event is not None:
      log_str.write('rx_event = ')
      log_str.write(str(self.rx_event))
      log_str.write('  ')
    if self.count is not None:
      log_str.write('count = ')
      log_str.write('<<  ')
      log_str.write(self.count.log())
      log_str.write('>>')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.deleted is not None:
      size += getsizeof(self.deleted)
    if self.rx_event is not None:
      size += getsizeof(self.rx_event)
    if self.count is not None:
      size += getsizeof(self.count)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class ModuleCpuStateTrace(sandesh_base.SandeshUVE):

  thrift_spec = (
    None, # 0
    (1, TType.STRUCT, 'data', (ModuleCpuState, ModuleCpuState.thrift_spec), None, ), # 1
  )

  def __init__(self, data=None, table=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshUVE.__init__(self)
    self.data = data
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 39936400
    self._hints = 0 | SANDESH_KEY_HINT
    if table is not None:
      self.data._table = table

  def update_uve(self, tdata):
    if self.data.name is not None:
      tdata.name = self.data.name
    if self.data.deleted is not None:
      tdata.deleted = self.data.deleted
    if self.data.module_cpu_info is not None:
      tdata.module_cpu_info = self.data.module_cpu_info
    return tdata

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.data is not None:
      log_str.write('data = ')
      log_str.write('<<  ')
      log_str.write(self.data.log())
      log_str.write('>>')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRUCT:
          self.data = ModuleCpuState()
          read_cnt += self.data.read(iprot)
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.data is not None:
      annotations = {}
      if oprot.writeFieldBegin('data', TType.STRUCT, 1, annotations) < 0: return -1
      if self.data.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.data != other.data:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.data is not None:
      size += getsizeof(self.data)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class AnalyticsCpuStateTrace(sandesh_base.SandeshUVE):

  thrift_spec = (
    None, # 0
    (1, TType.STRUCT, 'data', (AnalyticsCpuState, AnalyticsCpuState.thrift_spec), None, ), # 1
  )

  def __init__(self, data=None, table=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshUVE.__init__(self)
    self.data = data
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3278957034
    self._hints = 0 | SANDESH_KEY_HINT
    if table is not None:
      self.data._table = table

  def update_uve(self, tdata):
    if self.data.name is not None:
      tdata.name = self.data.name
    if self.data.deleted is not None:
      tdata.deleted = self.data.deleted
    if self.data.cpu_info is not None:
      tdata.cpu_info = self.data.cpu_info
    return tdata

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.data is not None:
      log_str.write('data = ')
      log_str.write('<<  ')
      log_str.write(self.data.log())
      log_str.write('>>')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRUCT:
          self.data = AnalyticsCpuState()
          read_cnt += self.data.read(iprot)
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.data is not None:
      annotations = {}
      if oprot.writeFieldBegin('data', TType.STRUCT, 1, annotations) < 0: return -1
      if self.data.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.data != other.data:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.data is not None:
      size += getsizeof(self.data)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class NodeStatusUVE(sandesh_base.SandeshUVE):

  thrift_spec = (
    None, # 0
    (1, TType.STRUCT, 'data', (NodeStatus, NodeStatus.thrift_spec), None, ), # 1
  )

  def __init__(self, data=None, table=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshUVE.__init__(self)
    self.data = data
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1261747330
    self._hints = 0 | SANDESH_KEY_HINT
    if table is not None:
      self.data._table = table

  def update_uve(self, tdata):
    if self.data.name is not None:
      tdata.name = self.data.name
    if self.data.deleted is not None:
      tdata.deleted = self.data.deleted
    if self.data.status is not None:
      tdata.status = self.data.status
    if self.data.process_status is not None:
      tdata.process_status = self.data.process_status
    if self.data.process_info is not None:
      tdata.process_info = self.data.process_info
    if self.data.disk_usage_info is not None:
      tdata.disk_usage_info = self.data.disk_usage_info
    if self.data.description is not None:
      tdata.description = self.data.description
    if self.data.all_core_file_list is not None:
      tdata.all_core_file_list = self.data.all_core_file_list
    if self.data.process_mem_cpu_usage is not None:
      tdata.process_mem_cpu_usage = self.data.process_mem_cpu_usage
    if self.data.system_mem_cpu_usage is not None:
      tdata.system_mem_cpu_usage = self.data.system_mem_cpu_usage
    if self.data.system_cpu_info is not None:
      tdata.system_cpu_info = self.data.system_cpu_info
    return tdata

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.data is not None:
      log_str.write('data = ')
      log_str.write('<<  ')
      log_str.write(self.data.log())
      log_str.write('>>')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRUCT:
          self.data = NodeStatus()
          read_cnt += self.data.read(iprot)
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.data is not None:
      annotations = {}
      if oprot.writeFieldBegin('data', TType.STRUCT, 1, annotations) < 0: return -1
      if self.data.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.data != other.data:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.data is not None:
      size += getsizeof(self.data)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class QueryPerfInfo(sandesh_base.SandeshObject):

  thrift_spec = None

  def __init__(self, name=None, table=None, query_stats=None, file=None, line=None, category='__default__', level=SandeshLevel.SYS_INFO, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshObject.__init__(self)
    self.name = name
    self.table = table
    self.query_stats = query_stats
    self.file = file
    self.line = line
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 2266302257
    self._hints = 0 | SANDESH_KEY_HINT
    self._category = category
    self._level = level

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    if self._category is not None:
      log_str.write(self._category)
    log_str.write(' [')
    log_str.write(SandeshLevel._VALUES_TO_NAMES[self._level])
    log_str.write(']: ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.table is not None:
      log_str.write('table = ')
      log_str.write(self.table)
      log_str.write('  ')
    if self.query_stats is not None:
      log_str.write('query_stats = ')
      log_str.write('<<  ')
      log_str.write(self.query_stats.log())
      log_str.write('>>')
      log_str.write('  ')
    if self.file is not None:
      log_str.write('file = ')
      log_str.write(self.file)
      log_str.write('  ')
    if self.line is not None:
      log_str.write('line = ')
      log_str.write(str(self.line))
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.table) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 10:
        if ftype == TType.STRUCT:
          self.query_stats = QueryStats()
          read_cnt += self.query_stats.read(iprot)
        else:
          iprot.skip(ftype)
      elif fid == -32768:
        if ftype == TType.STRING:
          (length, self.file) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == -32767:
        if ftype == TType.I32:
          (length, self.line) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.file is not None:
      annotations = {}
      if oprot.writeFieldBegin('file', TType.STRING, -32768, annotations) < 0: return -1
      if oprot.writeString(self.file) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.line is not None:
      annotations = {}
      if oprot.writeFieldBegin('line', TType.I32, -32767, annotations) < 0: return -1
      if oprot.writeI32(self.line) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.name is not None:
      annotations = {}
      annotations['key'] = 'ObjectCollectorInfo'
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.table is not None:
      annotations = {}
      if oprot.writeFieldBegin('table', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.table) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.query_stats is not None:
      annotations = {}
      annotations['tags'] = 'table,name:.qid,.rows,.time'
      if oprot.writeFieldBegin('query_stats', TType.STRUCT, 10, annotations) < 0: return -1
      if self.query_stats.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.file != other.file:
      return False
    if self.line != other.line:
      return False
    if self.name != other.name:
      return False
    if self.table != other.table:
      return False
    if self.query_stats != other.query_stats:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.table is not None:
      size += getsizeof(self.table)
    if self.query_stats is not None:
      size += getsizeof(self.query_stats)
    if self.file is not None:
      size += getsizeof(self.file)
    if self.line is not None:
      size += getsizeof(self.line)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class AnalyticsApiStats(sandesh_base.SandeshObject):

  thrift_spec = None

  def __init__(self, api_stats=None, file=None, line=None, category='__default__', level=SandeshLevel.SYS_INFO, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshObject.__init__(self)
    self.api_stats = api_stats
    self.file = file
    self.line = line
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 1483083014
    self._hints = 0 | SANDESH_KEY_HINT
    self._category = category
    self._level = level

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    if self._category is not None:
      log_str.write(self._category)
    log_str.write(' [')
    log_str.write(SandeshLevel._VALUES_TO_NAMES[self._level])
    log_str.write(']: ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.api_stats is not None:
      log_str.write('api_stats = ')
      log_str.write('<<  ')
      log_str.write(self.api_stats.log())
      log_str.write('>>')
      log_str.write('  ')
    if self.file is not None:
      log_str.write('file = ')
      log_str.write(self.file)
      log_str.write('  ')
    if self.line is not None:
      log_str.write('line = ')
      log_str.write(str(self.line))
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRUCT:
          self.api_stats = AnalyticsApiSample()
          read_cnt += self.api_stats.read(iprot)
        else:
          iprot.skip(ftype)
      elif fid == -32768:
        if ftype == TType.STRING:
          (length, self.file) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == -32767:
        if ftype == TType.I32:
          (length, self.line) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.file is not None:
      annotations = {}
      if oprot.writeFieldBegin('file', TType.STRING, -32768, annotations) < 0: return -1
      if oprot.writeString(self.file) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.line is not None:
      annotations = {}
      if oprot.writeFieldBegin('line', TType.I32, -32767, annotations) < 0: return -1
      if oprot.writeI32(self.line) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.api_stats is not None:
      annotations = {}
      annotations['tags'] = '.operation_type,.remote_ip,.object_type'
      if oprot.writeFieldBegin('api_stats', TType.STRUCT, 1, annotations) < 0: return -1
      if self.api_stats.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.file != other.file:
      return False
    if self.line != other.line:
      return False
    if self.api_stats != other.api_stats:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.api_stats is not None:
      size += getsizeof(self.api_stats)
    if self.file is not None:
      size += getsizeof(self.file)
    if self.line is not None:
      size += getsizeof(self.line)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class UserDefinedCounterUVE(sandesh_base.SandeshUVE):

  thrift_spec = (
    None, # 0
    (1, TType.STRUCT, 'data', (UserDefinedCounter, UserDefinedCounter.thrift_spec), None, ), # 1
  )

  def __init__(self, data=None, table=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshUVE.__init__(self)
    self.data = data
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 2663974092
    self._hints = 0 | SANDESH_KEY_HINT
    if table is not None:
      self.data._table = table

  def update_uve(self, tdata):
    if self.data.name is not None:
      tdata.name = self.data.name
    if self.data.deleted is not None:
      tdata.deleted = self.data.deleted
    if self.data.rx_event is not None:
      tdata.rx_event = self.data.rx_event
    if self.data.count is not None:
      tdata.count = self.data.count
    return tdata

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.data is not None:
      log_str.write('data = ')
      log_str.write('<<  ')
      log_str.write(self.data.log())
      log_str.write('>>')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRUCT:
          self.data = UserDefinedCounter()
          read_cnt += self.data.read(iprot)
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.data is not None:
      annotations = {}
      if oprot.writeFieldBegin('data', TType.STRUCT, 1, annotations) < 0: return -1
      if self.data.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.data != other.data:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.data is not None:
      size += getsizeof(self.data)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)


_SANDESH_REQUEST_LIST = [
]


_SANDESH_UVE_LIST = [
(ModuleCpuStateTrace, ModuleCpuState),
(AnalyticsCpuStateTrace, AnalyticsCpuState),
(NodeStatusUVE, NodeStatus),
(UserDefinedCounterUVE, UserDefinedCounter),
]


_SANDESH_ALARM_LIST = [
]
