#
# Autogenerated by Sandesh Compiler (1.0)
#
# DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
#
#  options string: py:new_style
# Copyright (c) 2013 Juniper Networks, Inc. All rights reserved.
#

from pysandesh.Thrift import TType, TMessageType, TException

from pysandesh.transport import TTransport
from pysandesh.protocol import TBinaryProtocol, TProtocol
try:
  from pysandesh.protocol import fastbinary
except:
  fastbinary = None

import cStringIO
import uuid
import netaddr
from sys import getsizeof
from itertools import chain
import bottle
from pysandesh import sandesh_base
from pysandesh.sandesh_http import SandeshHttp
from pysandesh.sandesh_uve import SandeshUVETypeMaps
from pysandesh.util import UTCTimestampUsec, UTCTimestampUsecToString
from pysandesh import util
from pysandesh.gen_py.sandesh.constants import *


class PurgeStatus(object):
  """
  Definitions of structures used to send database purge statistics information
  """
  SUCCESS = 0
  FAILURE = 1

  _VALUES_TO_NAMES = {
    0: "SUCCESS",
    1: "FAILURE",
  }

  _NAMES_TO_VALUES = {
    "SUCCESS": 0,
    "FAILURE": 1,
  }


class DatabasePurgeStats(object):
  """
  structure to carry database purge statistics information

  Attributes:
   - purge_id
   - request_time
   - rows_deleted
   - duration
   - purge_status
   - purge_status_details
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'purge_id', None, None, ), # 1
    (2, TType.U64, 'request_time', None, None, ), # 2
    (3, TType.U64, 'rows_deleted', None, None, ), # 3
    (4, TType.U64, 'duration', None, None, ), # 4
    (5, TType.STRING, 'purge_status', None, None, ), # 5
    (6, TType.STRING, 'purge_status_details', None, None, ), # 6
  )

  def __init__(self, purge_id=None, request_time=None, rows_deleted=None, duration=None, purge_status=None, purge_status_details=None,):
    self.purge_id = purge_id
    self.request_time = request_time
    self.rows_deleted = rows_deleted
    self.duration = duration
    self.purge_status = purge_status
    self.purge_status_details = purge_status_details

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.purge_id) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.U64:
          (length, self.request_time) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.U64:
          (length, self.rows_deleted) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.U64:
          (length, self.duration) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.STRING:
          (length, self.purge_status) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.STRING:
          (length, self.purge_status_details) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.purge_id is not None:
      annotations = {}
      if oprot.writeFieldBegin('purge_id', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.purge_id) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.request_time is not None:
      annotations = {}
      if oprot.writeFieldBegin('request_time', TType.U64, 2, annotations) < 0: return -1
      if oprot.writeU64(self.request_time) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.rows_deleted is not None:
      annotations = {}
      if oprot.writeFieldBegin('rows_deleted', TType.U64, 3, annotations) < 0: return -1
      if oprot.writeU64(self.rows_deleted) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.duration is not None:
      annotations = {}
      if oprot.writeFieldBegin('duration', TType.U64, 4, annotations) < 0: return -1
      if oprot.writeU64(self.duration) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.purge_status is not None:
      annotations = {}
      if oprot.writeFieldBegin('purge_status', TType.STRING, 5, annotations) < 0: return -1
      if oprot.writeString(self.purge_status) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.purge_status_details is not None:
      annotations = {}
      if oprot.writeFieldBegin('purge_status_details', TType.STRING, 6, annotations) < 0: return -1
      if oprot.writeString(self.purge_status_details) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.purge_id is not None:
      log_str.write('purge_id = ')
      log_str.write(self.purge_id)
      log_str.write('  ')
    if self.request_time is not None:
      log_str.write('request_time = ')
      log_str.write(str(self.request_time))
      log_str.write('  ')
    if self.rows_deleted is not None:
      log_str.write('rows_deleted = ')
      log_str.write(str(self.rows_deleted))
      log_str.write('  ')
    if self.duration is not None:
      log_str.write('duration = ')
      log_str.write(str(self.duration))
      log_str.write('  ')
    if self.purge_status is not None:
      log_str.write('purge_status = ')
      log_str.write(self.purge_status)
      log_str.write('  ')
    if self.purge_status_details is not None:
      log_str.write('purge_status_details = ')
      log_str.write(self.purge_status_details)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.purge_id is not None:
      size += getsizeof(self.purge_id)
    if self.request_time is not None:
      size += getsizeof(self.request_time)
    if self.rows_deleted is not None:
      size += getsizeof(self.rows_deleted)
    if self.duration is not None:
      size += getsizeof(self.duration)
    if self.purge_status is not None:
      size += getsizeof(self.purge_status)
    if self.purge_status_details is not None:
      size += getsizeof(self.purge_status_details)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class DatabasePurgeInfo(sandesh_base.SandeshObject):

  thrift_spec = None

  def __init__(self, name=None, stats=None, file=None, line=None, category='__default__', level=SandeshLevel.SYS_INFO, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshObject.__init__(self)
    self.name = name
    self.stats = stats
    self.file = file
    self.line = line
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 2796496139
    self._hints = 0 | SANDESH_KEY_HINT
    self._category = category
    self._level = level

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    if self._category is not None:
      log_str.write(self._category)
    log_str.write(' [')
    log_str.write(SandeshLevel._VALUES_TO_NAMES[self._level])
    log_str.write(']: ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.stats is not None:
      log_str.write('stats = ')
      log_str.write('<<  ')
      log_str.write(self.stats.log())
      log_str.write('>>')
      log_str.write('  ')
    if self.file is not None:
      log_str.write('file = ')
      log_str.write(self.file)
      log_str.write('  ')
    if self.line is not None:
      log_str.write('line = ')
      log_str.write(str(self.line))
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRUCT:
          self.stats = DatabasePurgeStats()
          read_cnt += self.stats.read(iprot)
        else:
          iprot.skip(ftype)
      elif fid == -32768:
        if ftype == TType.STRING:
          (length, self.file) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == -32767:
        if ftype == TType.I32:
          (length, self.line) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.file is not None:
      annotations = {}
      if oprot.writeFieldBegin('file', TType.STRING, -32768, annotations) < 0: return -1
      if oprot.writeString(self.file) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.line is not None:
      annotations = {}
      if oprot.writeFieldBegin('line', TType.I32, -32767, annotations) < 0: return -1
      if oprot.writeI32(self.line) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.name is not None:
      annotations = {}
      annotations['key'] = 'ObjectDatabaseInfo'
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.stats is not None:
      annotations = {}
      annotations['tags'] = '.purge_id, .purge_status, .request_time, .rows_deleted, .duration'
      if oprot.writeFieldBegin('stats', TType.STRUCT, 2, annotations) < 0: return -1
      if self.stats.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.file != other.file:
      return False
    if self.line != other.line:
      return False
    if self.name != other.name:
      return False
    if self.stats != other.stats:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.stats is not None:
      size += getsizeof(self.stats)
    if self.file is not None:
      size += getsizeof(self.file)
    if self.line is not None:
      size += getsizeof(self.line)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)


_SANDESH_REQUEST_LIST = [
]


_SANDESH_UVE_LIST = [
]


_SANDESH_ALARM_LIST = [
]
