#
# Autogenerated by Sandesh Compiler (1.0)
#
# DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
#
#  options string: py:new_style
# Copyright (c) 2013 Juniper Networks, Inc. All rights reserved.
#

from pysandesh.Thrift import TType, TMessageType, TException

from pysandesh.transport import TTransport
from pysandesh.protocol import TBinaryProtocol, TProtocol
try:
  from pysandesh.protocol import fastbinary
except:
  fastbinary = None

import cStringIO
import uuid
import netaddr
from sys import getsizeof
from itertools import chain
import bottle
from pysandesh import sandesh_base
from pysandesh.sandesh_http import SandeshHttp
from pysandesh.sandesh_uve import SandeshUVETypeMaps
from pysandesh.util import UTCTimestampUsec, UTCTimestampUsecToString
from pysandesh import util
from pysandesh.gen_py.sandesh.constants import *



class RedisUveInfo(object):
  """
  Redis information that can be queried through Instrospect

  Attributes:
   - ip
   - port
   - status
   - update_no_conn
   - update_failed
   - update_succeeded
   - delete_no_conn
   - delete_failed
   - delete_succeeded
   - conn_call_disconnected
   - conn_call_failed
   - conn_call_succeeded
   - conn_cb_null
   - conn_cb_failed
   - conn_cb_succeeded
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'ip', None, None, ), # 1
    (2, TType.U16, 'port', None, None, ), # 2
    (3, TType.STRING, 'status', None, None, ), # 3
    None, # 4
    None, # 5
    (6, TType.U64, 'update_no_conn', None, None, ), # 6
    (7, TType.U64, 'update_failed', None, None, ), # 7
    (8, TType.U64, 'update_succeeded', None, None, ), # 8
    (9, TType.U64, 'delete_no_conn', None, None, ), # 9
    (10, TType.U64, 'delete_failed', None, None, ), # 10
    (11, TType.U64, 'delete_succeeded', None, None, ), # 11
    (12, TType.U64, 'conn_call_disconnected', None, None, ), # 12
    (13, TType.U64, 'conn_call_failed', None, None, ), # 13
    (14, TType.U64, 'conn_call_succeeded', None, None, ), # 14
    (15, TType.U64, 'conn_cb_null', None, None, ), # 15
    (16, TType.U64, 'conn_cb_failed', None, None, ), # 16
    (17, TType.U64, 'conn_cb_succeeded', None, None, ), # 17
  )

  def __init__(self, ip=None, port=None, status=None, update_no_conn=None, update_failed=None, update_succeeded=None, delete_no_conn=None, delete_failed=None, delete_succeeded=None, conn_call_disconnected=None, conn_call_failed=None, conn_call_succeeded=None, conn_cb_null=None, conn_cb_failed=None, conn_cb_succeeded=None,):
    self.ip = ip
    self.port = port
    self.status = status
    self.update_no_conn = update_no_conn
    self.update_failed = update_failed
    self.update_succeeded = update_succeeded
    self.delete_no_conn = delete_no_conn
    self.delete_failed = delete_failed
    self.delete_succeeded = delete_succeeded
    self.conn_call_disconnected = conn_call_disconnected
    self.conn_call_failed = conn_call_failed
    self.conn_call_succeeded = conn_call_succeeded
    self.conn_cb_null = conn_cb_null
    self.conn_cb_failed = conn_cb_failed
    self.conn_cb_succeeded = conn_cb_succeeded

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.ip) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.U16:
          (length, self.port) = iprot.readU16();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.status) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.U64:
          (length, self.update_no_conn) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 7:
        if ftype == TType.U64:
          (length, self.update_failed) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 8:
        if ftype == TType.U64:
          (length, self.update_succeeded) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 9:
        if ftype == TType.U64:
          (length, self.delete_no_conn) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 10:
        if ftype == TType.U64:
          (length, self.delete_failed) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 11:
        if ftype == TType.U64:
          (length, self.delete_succeeded) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 12:
        if ftype == TType.U64:
          (length, self.conn_call_disconnected) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 13:
        if ftype == TType.U64:
          (length, self.conn_call_failed) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 14:
        if ftype == TType.U64:
          (length, self.conn_call_succeeded) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 15:
        if ftype == TType.U64:
          (length, self.conn_cb_null) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 16:
        if ftype == TType.U64:
          (length, self.conn_cb_failed) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 17:
        if ftype == TType.U64:
          (length, self.conn_cb_succeeded) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.ip is not None:
      annotations = {}
      if oprot.writeFieldBegin('ip', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.ip) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.port is not None:
      annotations = {}
      if oprot.writeFieldBegin('port', TType.U16, 2, annotations) < 0: return -1
      if oprot.writeU16(self.port) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.status is not None:
      annotations = {}
      if oprot.writeFieldBegin('status', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.status) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.update_no_conn is not None:
      annotations = {}
      if oprot.writeFieldBegin('update_no_conn', TType.U64, 6, annotations) < 0: return -1
      if oprot.writeU64(self.update_no_conn) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.update_failed is not None:
      annotations = {}
      if oprot.writeFieldBegin('update_failed', TType.U64, 7, annotations) < 0: return -1
      if oprot.writeU64(self.update_failed) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.update_succeeded is not None:
      annotations = {}
      if oprot.writeFieldBegin('update_succeeded', TType.U64, 8, annotations) < 0: return -1
      if oprot.writeU64(self.update_succeeded) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.delete_no_conn is not None:
      annotations = {}
      if oprot.writeFieldBegin('delete_no_conn', TType.U64, 9, annotations) < 0: return -1
      if oprot.writeU64(self.delete_no_conn) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.delete_failed is not None:
      annotations = {}
      if oprot.writeFieldBegin('delete_failed', TType.U64, 10, annotations) < 0: return -1
      if oprot.writeU64(self.delete_failed) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.delete_succeeded is not None:
      annotations = {}
      if oprot.writeFieldBegin('delete_succeeded', TType.U64, 11, annotations) < 0: return -1
      if oprot.writeU64(self.delete_succeeded) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.conn_call_disconnected is not None:
      annotations = {}
      if oprot.writeFieldBegin('conn_call_disconnected', TType.U64, 12, annotations) < 0: return -1
      if oprot.writeU64(self.conn_call_disconnected) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.conn_call_failed is not None:
      annotations = {}
      if oprot.writeFieldBegin('conn_call_failed', TType.U64, 13, annotations) < 0: return -1
      if oprot.writeU64(self.conn_call_failed) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.conn_call_succeeded is not None:
      annotations = {}
      if oprot.writeFieldBegin('conn_call_succeeded', TType.U64, 14, annotations) < 0: return -1
      if oprot.writeU64(self.conn_call_succeeded) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.conn_cb_null is not None:
      annotations = {}
      if oprot.writeFieldBegin('conn_cb_null', TType.U64, 15, annotations) < 0: return -1
      if oprot.writeU64(self.conn_cb_null) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.conn_cb_failed is not None:
      annotations = {}
      if oprot.writeFieldBegin('conn_cb_failed', TType.U64, 16, annotations) < 0: return -1
      if oprot.writeU64(self.conn_cb_failed) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.conn_cb_succeeded is not None:
      annotations = {}
      if oprot.writeFieldBegin('conn_cb_succeeded', TType.U64, 17, annotations) < 0: return -1
      if oprot.writeU64(self.conn_cb_succeeded) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.ip is not None:
      log_str.write('ip = ')
      log_str.write(self.ip)
      log_str.write('  ')
    if self.port is not None:
      log_str.write('port = ')
      log_str.write(str(self.port))
      log_str.write('  ')
    if self.status is not None:
      log_str.write('status = ')
      log_str.write(self.status)
      log_str.write('  ')
    if self.update_no_conn is not None:
      log_str.write('update_no_conn = ')
      log_str.write(str(self.update_no_conn))
      log_str.write('  ')
    if self.update_failed is not None:
      log_str.write('update_failed = ')
      log_str.write(str(self.update_failed))
      log_str.write('  ')
    if self.update_succeeded is not None:
      log_str.write('update_succeeded = ')
      log_str.write(str(self.update_succeeded))
      log_str.write('  ')
    if self.delete_no_conn is not None:
      log_str.write('delete_no_conn = ')
      log_str.write(str(self.delete_no_conn))
      log_str.write('  ')
    if self.delete_failed is not None:
      log_str.write('delete_failed = ')
      log_str.write(str(self.delete_failed))
      log_str.write('  ')
    if self.delete_succeeded is not None:
      log_str.write('delete_succeeded = ')
      log_str.write(str(self.delete_succeeded))
      log_str.write('  ')
    if self.conn_call_disconnected is not None:
      log_str.write('conn_call_disconnected = ')
      log_str.write(str(self.conn_call_disconnected))
      log_str.write('  ')
    if self.conn_call_failed is not None:
      log_str.write('conn_call_failed = ')
      log_str.write(str(self.conn_call_failed))
      log_str.write('  ')
    if self.conn_call_succeeded is not None:
      log_str.write('conn_call_succeeded = ')
      log_str.write(str(self.conn_call_succeeded))
      log_str.write('  ')
    if self.conn_cb_null is not None:
      log_str.write('conn_cb_null = ')
      log_str.write(str(self.conn_cb_null))
      log_str.write('  ')
    if self.conn_cb_failed is not None:
      log_str.write('conn_cb_failed = ')
      log_str.write(str(self.conn_cb_failed))
      log_str.write('  ')
    if self.conn_cb_succeeded is not None:
      log_str.write('conn_cb_succeeded = ')
      log_str.write(str(self.conn_cb_succeeded))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.ip is not None:
      size += getsizeof(self.ip)
    if self.port is not None:
      size += getsizeof(self.port)
    if self.status is not None:
      size += getsizeof(self.status)
    if self.update_no_conn is not None:
      size += getsizeof(self.update_no_conn)
    if self.update_failed is not None:
      size += getsizeof(self.update_failed)
    if self.update_succeeded is not None:
      size += getsizeof(self.update_succeeded)
    if self.delete_no_conn is not None:
      size += getsizeof(self.delete_no_conn)
    if self.delete_failed is not None:
      size += getsizeof(self.delete_failed)
    if self.delete_succeeded is not None:
      size += getsizeof(self.delete_succeeded)
    if self.conn_call_disconnected is not None:
      size += getsizeof(self.conn_call_disconnected)
    if self.conn_call_failed is not None:
      size += getsizeof(self.conn_call_failed)
    if self.conn_call_succeeded is not None:
      size += getsizeof(self.conn_call_succeeded)
    if self.conn_cb_null is not None:
      size += getsizeof(self.conn_cb_null)
    if self.conn_cb_failed is not None:
      size += getsizeof(self.conn_cb_failed)
    if self.conn_cb_succeeded is not None:
      size += getsizeof(self.conn_cb_succeeded)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class RedisUVERequest(sandesh_base.SandeshRequest):

  thrift_spec = (
  )

  def __init__(self, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshRequest.__init__(self)
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 2471203225
    self._hints = 0

  @staticmethod
  def handle_http_request(sandesh=sandesh_base.sandesh_global):
    sandesh_req = RedisUVERequest()
    if not sandesh_req:
      return SandeshHttp.http_error('Sandesh Request "RedisUVERequest" not implemented')
    sandesh_req._context = bottle.request.url
    handle_req_fn = getattr(sandesh_req, "handle_request", None)
    if callable(handle_req_fn):
      handle_req_fn(sandesh_req)
    else:
      return SandeshHttp.http_error('Sandesh Request "RedisUVERequest" not implemented')
    resp = SandeshHttp.get_http_response()
    if resp:
      return resp
    else:
      return SandeshHttp.http_error('No Response for Sandesh Request "RedisUVERequest"')
    
  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    return True

  def __sizeof__(self):
    size = 0
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class RedisUVEResponse(sandesh_base.SandeshResponse):

  thrift_spec = (
    (0, TType.BOOL, 'more', None, None, ), # 0
    (1, TType.STRUCT, 'redis_uve_info', (RedisUveInfo, RedisUveInfo.thrift_spec), None, ), # 1
  )

  def __init__(self, redis_uve_info=None, more=None, sandesh=sandesh_base.sandesh_global):
    sandesh_base.SandeshResponse.__init__(self)
    self.redis_uve_info = redis_uve_info
    self.more = more
    self._scope = sandesh.scope()
    self._module = sandesh.module()
    self._source = sandesh.source_id()
    self._node_type = sandesh.node_type()
    self._instance_id = sandesh.instance_id()
    self._seqnum = 0
    self._timestamp = UTCTimestampUsec()
    self._versionsig = 3803187033
    self._hints = 0

  def log(self, trace=False):
    log_str = cStringIO.StringIO()
    if trace:
      log_str.write(str(self._timestamp))
      log_str.write(' ')
    log_str.write(self.__class__.__name__ + ': ')
    if self.redis_uve_info is not None:
      log_str.write('redis_uve_info = ')
      log_str.write('<<  ')
      log_str.write(self.redis_uve_info.log())
      log_str.write('>>')
      log_str.write('  ')
    if self.more is not None:
      log_str.write('more = ')
      if self.more:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return -1
    read_cnt = 0
    (length, sandesh_name) = iprot.readSandeshBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRUCT:
          self.redis_uve_info = RedisUveInfo()
          read_cnt += self.redis_uve_info.read(iprot)
        else:
          iprot.skip(ftype)
      elif fid == 0:
        if ftype == TType.BOOL:
          (length, self.more) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readSandeshEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeSandeshBegin(self.__class__.__name__) < 0: return -1
    if self.more is not None:
      annotations = {}
      if oprot.writeFieldBegin('more', TType.BOOL, 0, annotations) < 0: return -1
      if oprot.writeBool(self.more) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.redis_uve_info is not None:
      annotations = {}
      if oprot.writeFieldBegin('redis_uve_info', TType.STRUCT, 1, annotations) < 0: return -1
      if self.redis_uve_info.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeSandeshEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def compare(self, other):
    if not isinstance(other, self.__class__):
      return False
    if self.more != other.more:
      return False
    if self.redis_uve_info != other.redis_uve_info:
      return False
    return True

  def __sizeof__(self):
    size = 0
    if self.redis_uve_info is not None:
      size += getsizeof(self.redis_uve_info)
    if self.more is not None:
      size += getsizeof(self.more)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)


_SANDESH_REQUEST_LIST = [
RedisUVERequest,
]


_SANDESH_UVE_LIST = [
]


_SANDESH_ALARM_LIST = [
]
