#
# Autogenerated by Sandesh Compiler (1.0)
#
# DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
#
#  options string: py:new_style
# Copyright (c) 2013 Juniper Networks, Inc. All rights reserved.
#

from pysandesh.Thrift import TType, TMessageType, TException

from pysandesh.transport import TTransport
from pysandesh.protocol import TBinaryProtocol, TProtocol
try:
  from pysandesh.protocol import fastbinary
except:
  fastbinary = None

import cStringIO
import uuid
import netaddr
from sys import getsizeof
from itertools import chain
import bottle
from pysandesh import sandesh_base
from pysandesh.sandesh_http import SandeshHttp
from pysandesh.sandesh_uve import SandeshUVETypeMaps
from pysandesh.util import UTCTimestampUsec, UTCTimestampUsecToString
from pysandesh import util
from pysandesh.gen_py.sandesh.constants import *


class DbDataType(object):
  AsciiType = 1
  LexicalUUIDType = 2
  TimeUUIDType = 3
  Unsigned8Type = 4
  Unsigned16Type = 5
  Unsigned32Type = 6
  Unsigned64Type = 7
  DoubleType = 8
  UTF8Type = 9
  InetType = 10
  IntegerType = 11
  BlobType = 12

  _VALUES_TO_NAMES = {
    1: "AsciiType",
    2: "LexicalUUIDType",
    3: "TimeUUIDType",
    4: "Unsigned8Type",
    5: "Unsigned16Type",
    6: "Unsigned32Type",
    7: "Unsigned64Type",
    8: "DoubleType",
    9: "UTF8Type",
    10: "InetType",
    11: "IntegerType",
    12: "BlobType",
  }

  _NAMES_TO_VALUES = {
    "AsciiType": 1,
    "LexicalUUIDType": 2,
    "TimeUUIDType": 3,
    "Unsigned8Type": 4,
    "Unsigned16Type": 5,
    "Unsigned32Type": 6,
    "Unsigned64Type": 7,
    "DoubleType": 8,
    "UTF8Type": 9,
    "InetType": 10,
    "IntegerType": 11,
    "BlobType": 12,
  }


class DbTableInfo(object):
  """
  Attributes:
   - table_name
   - reads
   - read_fails
   - writes
   - write_fails
   - write_back_pressure_fails
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'table_name', None, None, ), # 1
    (2, TType.U64, 'reads', None, None, ), # 2
    (3, TType.U64, 'read_fails', None, None, ), # 3
    (4, TType.U64, 'writes', None, None, ), # 4
    (5, TType.U64, 'write_fails', None, None, ), # 5
    (6, TType.U64, 'write_back_pressure_fails', None, None, ), # 6
  )

  def __init__(self, table_name=None, reads=None, read_fails=None, writes=None, write_fails=None, write_back_pressure_fails=None,):
    self.table_name = table_name
    self.reads = reads
    self.read_fails = read_fails
    self.writes = writes
    self.write_fails = write_fails
    self.write_back_pressure_fails = write_back_pressure_fails

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.table_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.U64:
          (length, self.reads) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.U64:
          (length, self.read_fails) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.U64:
          (length, self.writes) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.U64:
          (length, self.write_fails) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.U64:
          (length, self.write_back_pressure_fails) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.table_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('table_name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.table_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.reads is not None:
      annotations = {}
      if oprot.writeFieldBegin('reads', TType.U64, 2, annotations) < 0: return -1
      if oprot.writeU64(self.reads) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.read_fails is not None:
      annotations = {}
      if oprot.writeFieldBegin('read_fails', TType.U64, 3, annotations) < 0: return -1
      if oprot.writeU64(self.read_fails) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.writes is not None:
      annotations = {}
      if oprot.writeFieldBegin('writes', TType.U64, 4, annotations) < 0: return -1
      if oprot.writeU64(self.writes) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.write_fails is not None:
      annotations = {}
      if oprot.writeFieldBegin('write_fails', TType.U64, 5, annotations) < 0: return -1
      if oprot.writeU64(self.write_fails) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.write_back_pressure_fails is not None:
      annotations = {}
      if oprot.writeFieldBegin('write_back_pressure_fails', TType.U64, 6, annotations) < 0: return -1
      if oprot.writeU64(self.write_back_pressure_fails) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.table_name is not None:
      log_str.write('table_name = ')
      log_str.write(self.table_name)
      log_str.write('  ')
    if self.reads is not None:
      log_str.write('reads = ')
      log_str.write(str(self.reads))
      log_str.write('  ')
    if self.read_fails is not None:
      log_str.write('read_fails = ')
      log_str.write(str(self.read_fails))
      log_str.write('  ')
    if self.writes is not None:
      log_str.write('writes = ')
      log_str.write(str(self.writes))
      log_str.write('  ')
    if self.write_fails is not None:
      log_str.write('write_fails = ')
      log_str.write(str(self.write_fails))
      log_str.write('  ')
    if self.write_back_pressure_fails is not None:
      log_str.write('write_back_pressure_fails = ')
      log_str.write(str(self.write_back_pressure_fails))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.table_name is not None:
      size += getsizeof(self.table_name)
    if self.reads is not None:
      size += getsizeof(self.reads)
    if self.read_fails is not None:
      size += getsizeof(self.read_fails)
    if self.writes is not None:
      size += getsizeof(self.writes)
    if self.write_fails is not None:
      size += getsizeof(self.write_fails)
    if self.write_back_pressure_fails is not None:
      size += getsizeof(self.write_back_pressure_fails)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class DbErrors(object):
  """
  Attributes:
   - write_tablespace_fails
   - read_tablespace_fails
   - write_table_fails
   - read_table_fails
   - write_column_fails
   - write_batch_column_fails
   - read_column_fails
  """

  thrift_spec = (
    None, # 0
    (1, TType.U64, 'write_tablespace_fails', None, None, ), # 1
    (2, TType.U64, 'read_tablespace_fails', None, None, ), # 2
    (3, TType.U64, 'write_table_fails', None, None, ), # 3
    (4, TType.U64, 'read_table_fails', None, None, ), # 4
    (5, TType.U64, 'write_column_fails', None, None, ), # 5
    (6, TType.U64, 'write_batch_column_fails', None, None, ), # 6
    (7, TType.U64, 'read_column_fails', None, None, ), # 7
  )

  def __init__(self, write_tablespace_fails=None, read_tablespace_fails=None, write_table_fails=None, read_table_fails=None, write_column_fails=None, write_batch_column_fails=None, read_column_fails=None,):
    self.write_tablespace_fails = write_tablespace_fails
    self.read_tablespace_fails = read_tablespace_fails
    self.write_table_fails = write_table_fails
    self.read_table_fails = read_table_fails
    self.write_column_fails = write_column_fails
    self.write_batch_column_fails = write_batch_column_fails
    self.read_column_fails = read_column_fails

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.U64:
          (length, self.write_tablespace_fails) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.U64:
          (length, self.read_tablespace_fails) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.U64:
          (length, self.write_table_fails) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.U64:
          (length, self.read_table_fails) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.U64:
          (length, self.write_column_fails) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 6:
        if ftype == TType.U64:
          (length, self.write_batch_column_fails) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 7:
        if ftype == TType.U64:
          (length, self.read_column_fails) = iprot.readU64();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.write_tablespace_fails is not None:
      annotations = {}
      if oprot.writeFieldBegin('write_tablespace_fails', TType.U64, 1, annotations) < 0: return -1
      if oprot.writeU64(self.write_tablespace_fails) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.read_tablespace_fails is not None:
      annotations = {}
      if oprot.writeFieldBegin('read_tablespace_fails', TType.U64, 2, annotations) < 0: return -1
      if oprot.writeU64(self.read_tablespace_fails) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.write_table_fails is not None:
      annotations = {}
      if oprot.writeFieldBegin('write_table_fails', TType.U64, 3, annotations) < 0: return -1
      if oprot.writeU64(self.write_table_fails) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.read_table_fails is not None:
      annotations = {}
      if oprot.writeFieldBegin('read_table_fails', TType.U64, 4, annotations) < 0: return -1
      if oprot.writeU64(self.read_table_fails) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.write_column_fails is not None:
      annotations = {}
      if oprot.writeFieldBegin('write_column_fails', TType.U64, 5, annotations) < 0: return -1
      if oprot.writeU64(self.write_column_fails) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.write_batch_column_fails is not None:
      annotations = {}
      if oprot.writeFieldBegin('write_batch_column_fails', TType.U64, 6, annotations) < 0: return -1
      if oprot.writeU64(self.write_batch_column_fails) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.read_column_fails is not None:
      annotations = {}
      if oprot.writeFieldBegin('read_column_fails', TType.U64, 7, annotations) < 0: return -1
      if oprot.writeU64(self.read_column_fails) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.write_tablespace_fails is not None:
      log_str.write('write_tablespace_fails = ')
      log_str.write(str(self.write_tablespace_fails))
      log_str.write('  ')
    if self.read_tablespace_fails is not None:
      log_str.write('read_tablespace_fails = ')
      log_str.write(str(self.read_tablespace_fails))
      log_str.write('  ')
    if self.write_table_fails is not None:
      log_str.write('write_table_fails = ')
      log_str.write(str(self.write_table_fails))
      log_str.write('  ')
    if self.read_table_fails is not None:
      log_str.write('read_table_fails = ')
      log_str.write(str(self.read_table_fails))
      log_str.write('  ')
    if self.write_column_fails is not None:
      log_str.write('write_column_fails = ')
      log_str.write(str(self.write_column_fails))
      log_str.write('  ')
    if self.write_batch_column_fails is not None:
      log_str.write('write_batch_column_fails = ')
      log_str.write(str(self.write_batch_column_fails))
      log_str.write('  ')
    if self.read_column_fails is not None:
      log_str.write('read_column_fails = ')
      log_str.write(str(self.read_column_fails))
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.write_tablespace_fails is not None:
      size += getsizeof(self.write_tablespace_fails)
    if self.read_tablespace_fails is not None:
      size += getsizeof(self.read_tablespace_fails)
    if self.write_table_fails is not None:
      size += getsizeof(self.write_table_fails)
    if self.read_table_fails is not None:
      size += getsizeof(self.read_table_fails)
    if self.write_column_fails is not None:
      size += getsizeof(self.write_column_fails)
    if self.write_batch_column_fails is not None:
      size += getsizeof(self.write_batch_column_fails)
    if self.read_column_fails is not None:
      size += getsizeof(self.read_column_fails)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)


_SANDESH_REQUEST_LIST = [
]


_SANDESH_UVE_LIST = [
]


_SANDESH_ALARM_LIST = [
]
