#
# Autogenerated by Sandesh Compiler (1.0)
#
# DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
#
#  options string: py:new_style
# Copyright (c) 2013 Juniper Networks, Inc. All rights reserved.
#

from pysandesh.Thrift import TType, TMessageType, TException
import gendb.ttypes


from pysandesh.transport import TTransport
from pysandesh.protocol import TBinaryProtocol, TProtocol
try:
  from pysandesh.protocol import fastbinary
except:
  fastbinary = None

import cStringIO
import uuid
import netaddr
from sys import getsizeof
from itertools import chain
import bottle
from pysandesh import sandesh_base
from pysandesh.sandesh_http import SandeshHttp
from pysandesh.sandesh_uve import SandeshUVETypeMaps
from pysandesh.util import UTCTimestampUsec, UTCTimestampUsecToString
from pysandesh import util
from pysandesh.gen_py.sandesh.constants import *


class TtlType(object):
  FLOWDATA_TTL = 0
  STATSDATA_TTL = 1
  CONFIGAUDIT_TTL = 2
  GLOBAL_TTL = 3

  _VALUES_TO_NAMES = {
    0: "FLOWDATA_TTL",
    1: "STATSDATA_TTL",
    2: "CONFIGAUDIT_TTL",
    3: "GLOBAL_TTL",
  }

  _NAMES_TO_VALUES = {
    "FLOWDATA_TTL": 0,
    "STATSDATA_TTL": 1,
    "CONFIGAUDIT_TTL": 2,
    "GLOBAL_TTL": 3,
  }

class FlowRecordFields(object):
  FLOWREC_FLOWUUID = 0
  FLOWREC_DIRECTION_ING = 1
  FLOWREC_SOURCEVN = 2
  FLOWREC_SOURCEIP = 3
  FLOWREC_DESTVN = 4
  FLOWREC_DESTIP = 5
  FLOWREC_PROTOCOL = 6
  FLOWREC_SPORT = 7
  FLOWREC_DPORT = 8
  FLOWREC_TOS = 9
  FLOWREC_TCP_FLAGS = 10
  FLOWREC_VM = 11
  FLOWREC_INPUT_INTERFACE = 12
  FLOWREC_OUTPUT_INTERFACE = 13
  FLOWREC_MPLS_LABEL = 14
  FLOWREC_REVERSE_UUID = 15
  FLOWREC_SETUP_TIME = 16
  FLOWREC_TEARDOWN_TIME = 17
  FLOWREC_MIN_INTERARRIVAL = 18
  FLOWREC_MAX_INTERARRIVAL = 19
  FLOWREC_MEAN_INTERARRIVAL = 20
  FLOWREC_STDDEV_INTERARRIVAL = 21
  FLOWREC_BYTES = 22
  FLOWREC_PACKETS = 23
  FLOWREC_DATA_SAMPLE = 24
  FLOWREC_VROUTER = 25
  FLOWREC_DIFF_BYTES = 26
  FLOWREC_DIFF_PACKETS = 27
  FLOWREC_SHORT_FLOW = 28
  FLOWREC_JSON = 29
  FLOWREC_ACTION = 30
  FLOWREC_SG_RULE_UUID = 31
  FLOWREC_NW_ACE_UUID = 32
  FLOWREC_VROUTER_IP = 33
  FLOWREC_OTHER_VROUTER_IP = 34
  FLOWREC_UNDERLAY_PROTO = 35
  FLOWREC_UNDERLAY_SPORT = 36
  FLOWREC_VMI_UUID = 37
  FLOWREC_DROP_REASON = 38
  FLOWREC_MAX = 39

  _VALUES_TO_NAMES = {
    0: "FLOWREC_FLOWUUID",
    1: "FLOWREC_DIRECTION_ING",
    2: "FLOWREC_SOURCEVN",
    3: "FLOWREC_SOURCEIP",
    4: "FLOWREC_DESTVN",
    5: "FLOWREC_DESTIP",
    6: "FLOWREC_PROTOCOL",
    7: "FLOWREC_SPORT",
    8: "FLOWREC_DPORT",
    9: "FLOWREC_TOS",
    10: "FLOWREC_TCP_FLAGS",
    11: "FLOWREC_VM",
    12: "FLOWREC_INPUT_INTERFACE",
    13: "FLOWREC_OUTPUT_INTERFACE",
    14: "FLOWREC_MPLS_LABEL",
    15: "FLOWREC_REVERSE_UUID",
    16: "FLOWREC_SETUP_TIME",
    17: "FLOWREC_TEARDOWN_TIME",
    18: "FLOWREC_MIN_INTERARRIVAL",
    19: "FLOWREC_MAX_INTERARRIVAL",
    20: "FLOWREC_MEAN_INTERARRIVAL",
    21: "FLOWREC_STDDEV_INTERARRIVAL",
    22: "FLOWREC_BYTES",
    23: "FLOWREC_PACKETS",
    24: "FLOWREC_DATA_SAMPLE",
    25: "FLOWREC_VROUTER",
    26: "FLOWREC_DIFF_BYTES",
    27: "FLOWREC_DIFF_PACKETS",
    28: "FLOWREC_SHORT_FLOW",
    29: "FLOWREC_JSON",
    30: "FLOWREC_ACTION",
    31: "FLOWREC_SG_RULE_UUID",
    32: "FLOWREC_NW_ACE_UUID",
    33: "FLOWREC_VROUTER_IP",
    34: "FLOWREC_OTHER_VROUTER_IP",
    35: "FLOWREC_UNDERLAY_PROTO",
    36: "FLOWREC_UNDERLAY_SPORT",
    37: "FLOWREC_VMI_UUID",
    38: "FLOWREC_DROP_REASON",
    39: "FLOWREC_MAX",
  }

  _NAMES_TO_VALUES = {
    "FLOWREC_FLOWUUID": 0,
    "FLOWREC_DIRECTION_ING": 1,
    "FLOWREC_SOURCEVN": 2,
    "FLOWREC_SOURCEIP": 3,
    "FLOWREC_DESTVN": 4,
    "FLOWREC_DESTIP": 5,
    "FLOWREC_PROTOCOL": 6,
    "FLOWREC_SPORT": 7,
    "FLOWREC_DPORT": 8,
    "FLOWREC_TOS": 9,
    "FLOWREC_TCP_FLAGS": 10,
    "FLOWREC_VM": 11,
    "FLOWREC_INPUT_INTERFACE": 12,
    "FLOWREC_OUTPUT_INTERFACE": 13,
    "FLOWREC_MPLS_LABEL": 14,
    "FLOWREC_REVERSE_UUID": 15,
    "FLOWREC_SETUP_TIME": 16,
    "FLOWREC_TEARDOWN_TIME": 17,
    "FLOWREC_MIN_INTERARRIVAL": 18,
    "FLOWREC_MAX_INTERARRIVAL": 19,
    "FLOWREC_MEAN_INTERARRIVAL": 20,
    "FLOWREC_STDDEV_INTERARRIVAL": 21,
    "FLOWREC_BYTES": 22,
    "FLOWREC_PACKETS": 23,
    "FLOWREC_DATA_SAMPLE": 24,
    "FLOWREC_VROUTER": 25,
    "FLOWREC_DIFF_BYTES": 26,
    "FLOWREC_DIFF_PACKETS": 27,
    "FLOWREC_SHORT_FLOW": 28,
    "FLOWREC_JSON": 29,
    "FLOWREC_ACTION": 30,
    "FLOWREC_SG_RULE_UUID": 31,
    "FLOWREC_NW_ACE_UUID": 32,
    "FLOWREC_VROUTER_IP": 33,
    "FLOWREC_OTHER_VROUTER_IP": 34,
    "FLOWREC_UNDERLAY_PROTO": 35,
    "FLOWREC_UNDERLAY_SPORT": 36,
    "FLOWREC_VMI_UUID": 37,
    "FLOWREC_DROP_REASON": 38,
    "FLOWREC_MAX": 39,
  }

class PartType(object):
  PART_TYPE_INVALID = 0
  PART_TYPE_CNODES = 1
  PART_TYPE_PNODES = 2
  PART_TYPE_VMS = 3
  PART_TYPE_IFS = 4
  PART_TYPE_OTHER = 5

  _VALUES_TO_NAMES = {
    0: "PART_TYPE_INVALID",
    1: "PART_TYPE_CNODES",
    2: "PART_TYPE_PNODES",
    3: "PART_TYPE_VMS",
    4: "PART_TYPE_IFS",
    5: "PART_TYPE_OTHER",
  }

  _NAMES_TO_VALUES = {
    "PART_TYPE_INVALID": 0,
    "PART_TYPE_CNODES": 1,
    "PART_TYPE_PNODES": 2,
    "PART_TYPE_VMS": 3,
    "PART_TYPE_IFS": 4,
    "PART_TYPE_OTHER": 5,
  }


class objtable_info(object):
  """
  Attributes:
   - objtable_display_name
   - log_query_name
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'objtable_display_name', None, None, ), # 1
    (2, TType.STRING, 'log_query_name', None, None, ), # 2
  )

  def __init__(self, objtable_display_name=None, log_query_name=None,):
    self.objtable_display_name = objtable_display_name
    self.log_query_name = log_query_name

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.objtable_display_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.log_query_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.objtable_display_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('objtable_display_name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.objtable_display_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.log_query_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('log_query_name', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.log_query_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.objtable_display_name is not None:
      log_str.write('objtable_display_name = ')
      log_str.write(self.objtable_display_name)
      log_str.write('  ')
    if self.log_query_name is not None:
      log_str.write('log_query_name = ')
      log_str.write(self.log_query_name)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.objtable_display_name is not None:
      size += getsizeof(self.objtable_display_name)
    if self.log_query_name is not None:
      size += getsizeof(self.log_query_name)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class schema_column(object):
  """
  Attributes:
   - name
   - datatype
   - key
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.I32, 'datatype', None, None, ), # 2
    (3, TType.BOOL, 'key', None, None, ), # 3
  )

  def __init__(self, name=None, datatype=None, key=None,):
    self.name = name
    self.datatype = datatype
    self.key = key

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.I32:
          (length, self.datatype) = iprot.readI32();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.BOOL:
          (length, self.key) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.datatype is not None:
      annotations = {}
      if oprot.writeFieldBegin('datatype', TType.I32, 2, annotations) < 0: return -1
      if oprot.writeI32(self.datatype) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.key is not None:
      annotations = {}
      if oprot.writeFieldBegin('key', TType.BOOL, 3, annotations) < 0: return -1
      if oprot.writeBool(self.key) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.datatype is not None:
      log_str.write('datatype = ')
      log_str.write(str(self.datatype))
      log_str.write('  ')
    if self.key is not None:
      log_str.write('key = ')
      if self.key:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.datatype is not None:
      size += getsizeof(self.datatype)
    if self.key is not None:
      size += getsizeof(self.key)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class query_column(object):
  """
  Attributes:
   - name
   - datatype
   - index
   - select
   - suffixes
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.STRING, 'datatype', None, None, ), # 2
    (3, TType.BOOL, 'index', None, None, ), # 3
    (4, TType.BOOL, 'select', None, None, ), # 4
    (5, TType.LIST, 'suffixes', (TType.STRING,None), None, ), # 5
  )

  def __init__(self, name=None, datatype=None, index=None, select=None, suffixes=None,):
    self.name = name
    self.datatype = datatype
    self.index = index
    self.select = select
    self.suffixes = suffixes

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.datatype) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.BOOL:
          (length, self.index) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.BOOL:
          (length, self.select) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.LIST:
          self.suffixes = []
          (length, _etype3, _size0) = iprot.readListBegin()
          read_cnt += length
          for _i4 in xrange(_size0):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem5) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.suffixes.append(_elem5)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.datatype is not None:
      annotations = {}
      if oprot.writeFieldBegin('datatype', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.datatype) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.index is not None:
      annotations = {}
      if oprot.writeFieldBegin('index', TType.BOOL, 3, annotations) < 0: return -1
      if oprot.writeBool(self.index) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.select is not None:
      annotations = {}
      if oprot.writeFieldBegin('select', TType.BOOL, 4, annotations) < 0: return -1
      if oprot.writeBool(self.select) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.suffixes is not None:
      annotations = {}
      if oprot.writeFieldBegin('suffixes', TType.LIST, 5, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.suffixes)) < 0: return -1
      for iter6 in self.suffixes:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter6) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.datatype is not None:
      log_str.write('datatype = ')
      log_str.write(self.datatype)
      log_str.write('  ')
    if self.index is not None:
      log_str.write('index = ')
      if self.index:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    if self.select is not None:
      log_str.write('select = ')
      if self.select:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    if self.suffixes is not None:
      log_str.write('suffixes = ')
      log_str.write('[ ')
      for iter7 in self.suffixes:
        log_str.write(iter7)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.datatype is not None:
      size += getsizeof(self.datatype)
    if self.index is not None:
      size += getsizeof(self.index)
    if self.select is not None:
      size += getsizeof(self.select)
    if self.suffixes is not None:
      size += getsizeof(self.suffixes)
      size += sum(map(getsizeof, self.suffixes))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class query_schema_type(object):
  """
  Attributes:
   - type
   - columns
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'type', None, None, ), # 1
    (2, TType.LIST, 'columns', (TType.STRUCT,(query_column, query_column.thrift_spec)), None, ), # 2
  )

  def __init__(self, type=None, columns=None,):
    self.type = type
    self.columns = columns

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.type) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.LIST:
          self.columns = []
          (length, _etype11, _size8) = iprot.readListBegin()
          read_cnt += length
          for _i12 in xrange(_size8):
            _elem13 = query_column()
            read_cnt += _elem13.read(iprot)
            self.columns.append(_elem13)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.type is not None:
      annotations = {}
      if oprot.writeFieldBegin('type', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.type) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.columns is not None:
      annotations = {}
      if oprot.writeFieldBegin('columns', TType.LIST, 2, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.columns)) < 0: return -1
      for iter14 in self.columns:
        if iter14.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.type is not None:
      log_str.write('type = ')
      log_str.write(self.type)
      log_str.write('  ')
    if self.columns is not None:
      log_str.write('columns = ')
      log_str.write('[ ')
      for iter15 in self.columns:
        log_str.write('<<  ')
        log_str.write(iter15.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.type is not None:
      size += getsizeof(self.type)
    if self.columns is not None:
      size += getsizeof(self.columns)
      size += sum(map(getsizeof, self.columns))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class query_table(object):
  """
  Attributes:
   - name
   - schema
   - columnvalues
   - display_name
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.STRUCT, 'schema', (query_schema_type, query_schema_type.thrift_spec), None, ), # 2
    (3, TType.LIST, 'columnvalues', (TType.STRING,None), None, ), # 3
    (4, TType.STRING, 'display_name', None, None, ), # 4
  )

  def __init__(self, name=None, schema=None, columnvalues=None, display_name=None,):
    self.name = name
    self.schema = schema
    self.columnvalues = columnvalues
    self.display_name = display_name

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRUCT:
          self.schema = query_schema_type()
          read_cnt += self.schema.read(iprot)
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.LIST:
          self.columnvalues = []
          (length, _etype19, _size16) = iprot.readListBegin()
          read_cnt += length
          for _i20 in xrange(_size16):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem21) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.columnvalues.append(_elem21)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.STRING:
          (length, self.display_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.schema is not None:
      annotations = {}
      if oprot.writeFieldBegin('schema', TType.STRUCT, 2, annotations) < 0: return -1
      if self.schema.write(oprot) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.columnvalues is not None:
      annotations = {}
      if oprot.writeFieldBegin('columnvalues', TType.LIST, 3, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.columnvalues)) < 0: return -1
      for iter22 in self.columnvalues:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter22) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.display_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('display_name', TType.STRING, 4, annotations) < 0: return -1
      if oprot.writeString(self.display_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.schema is not None:
      log_str.write('schema = ')
      log_str.write('<<  ')
      log_str.write(self.schema.log())
      log_str.write('>>')
      log_str.write('  ')
    if self.columnvalues is not None:
      log_str.write('columnvalues = ')
      log_str.write('[ ')
      for iter23 in self.columnvalues:
        log_str.write(iter23)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    if self.display_name is not None:
      log_str.write('display_name = ')
      log_str.write(self.display_name)
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.schema is not None:
      size += getsizeof(self.schema)
    if self.columnvalues is not None:
      size += getsizeof(self.columnvalues)
      size += sum(map(getsizeof, self.columnvalues))
    if self.display_name is not None:
      size += getsizeof(self.display_name)
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class stat_query_column(object):
  """
  Attributes:
   - name
   - datatype
   - index
   - suffixes
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'name', None, None, ), # 1
    (2, TType.STRING, 'datatype', None, None, ), # 2
    (3, TType.BOOL, 'index', None, None, ), # 3
    (4, TType.LIST, 'suffixes', (TType.STRING,None), None, ), # 4
  )

  def __init__(self, name=None, datatype=None, index=None, suffixes=None,):
    self.name = name
    self.datatype = datatype
    self.index = index
    self.suffixes = suffixes

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.datatype) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.BOOL:
          (length, self.index) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.LIST:
          self.suffixes = []
          (length, _etype27, _size24) = iprot.readListBegin()
          read_cnt += length
          for _i28 in xrange(_size24):
            read_cnt += iprot.readContainerElementBegin()
            (length, _elem29) = iprot.readString();
            if length < 0: return -1
            read_cnt += length
            self.suffixes.append(_elem29)
            read_cnt += iprot.readContainerElementEnd()
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.name is not None:
      annotations = {}
      if oprot.writeFieldBegin('name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.datatype is not None:
      annotations = {}
      if oprot.writeFieldBegin('datatype', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.datatype) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.index is not None:
      annotations = {}
      if oprot.writeFieldBegin('index', TType.BOOL, 3, annotations) < 0: return -1
      if oprot.writeBool(self.index) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.suffixes is not None:
      annotations = {}
      if oprot.writeFieldBegin('suffixes', TType.LIST, 4, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRING, len(self.suffixes)) < 0: return -1
      for iter30 in self.suffixes:
        if oprot.writeContainerElementBegin() < 0: return -1
        if oprot.writeString(iter30) < 0: return -1
        if oprot.writeContainerElementEnd() < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.name is not None:
      log_str.write('name = ')
      log_str.write(self.name)
      log_str.write('  ')
    if self.datatype is not None:
      log_str.write('datatype = ')
      log_str.write(self.datatype)
      log_str.write('  ')
    if self.index is not None:
      log_str.write('index = ')
      if self.index:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    if self.suffixes is not None:
      log_str.write('suffixes = ')
      log_str.write('[ ')
      for iter31 in self.suffixes:
        log_str.write(iter31)
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.name is not None:
      size += getsizeof(self.name)
    if self.datatype is not None:
      size += getsizeof(self.datatype)
    if self.index is not None:
      size += getsizeof(self.index)
    if self.suffixes is not None:
      size += getsizeof(self.suffixes)
      size += sum(map(getsizeof, self.suffixes))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class table_schema(object):
  """
  Attributes:
   - table_name
   - is_static
   - is_index_table
   - columns
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'table_name', None, None, ), # 1
    (2, TType.BOOL, 'is_static', None, None, ), # 2
    (3, TType.BOOL, 'is_index_table', None, None, ), # 3
    (4, TType.LIST, 'columns', (TType.STRUCT,(schema_column, schema_column.thrift_spec)), None, ), # 4
  )

  def __init__(self, table_name=None, is_static=None, is_index_table=None, columns=None,):
    self.table_name = table_name
    self.is_static = is_static
    self.is_index_table = is_index_table
    self.columns = columns

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 1:
        if ftype == TType.STRING:
          (length, self.table_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.BOOL:
          (length, self.is_static) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.BOOL:
          (length, self.is_index_table) = iprot.readBool();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 4:
        if ftype == TType.LIST:
          self.columns = []
          (length, _etype35, _size32) = iprot.readListBegin()
          read_cnt += length
          for _i36 in xrange(_size32):
            _elem37 = schema_column()
            read_cnt += _elem37.read(iprot)
            self.columns.append(_elem37)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.table_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('table_name', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.table_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.is_static is not None:
      annotations = {}
      if oprot.writeFieldBegin('is_static', TType.BOOL, 2, annotations) < 0: return -1
      if oprot.writeBool(self.is_static) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.is_index_table is not None:
      annotations = {}
      if oprot.writeFieldBegin('is_index_table', TType.BOOL, 3, annotations) < 0: return -1
      if oprot.writeBool(self.is_index_table) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.columns is not None:
      annotations = {}
      if oprot.writeFieldBegin('columns', TType.LIST, 4, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.columns)) < 0: return -1
      for iter38 in self.columns:
        if iter38.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.table_name is not None:
      log_str.write('table_name = ')
      log_str.write(self.table_name)
      log_str.write('  ')
    if self.is_static is not None:
      log_str.write('is_static = ')
      if self.is_static:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    if self.is_index_table is not None:
      log_str.write('is_index_table = ')
      if self.is_index_table:
        log_str.write('True')
      else:
        log_str.write('False')
      log_str.write('  ')
    if self.columns is not None:
      log_str.write('columns = ')
      log_str.write('[ ')
      for iter39 in self.columns:
        log_str.write('<<  ')
        log_str.write(iter39.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.table_name is not None:
      size += getsizeof(self.table_name)
    if self.is_static is not None:
      size += getsizeof(self.is_static)
    if self.is_index_table is not None:
      size += getsizeof(self.is_index_table)
    if self.columns is not None:
      size += getsizeof(self.columns)
      size += sum(map(getsizeof, self.columns))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)

class stat_table(object):
  """
  Attributes:
   - display_name
   - stat_type
   - stat_attr
   - obj_table
   - attributes
  """

  thrift_spec = (
    None, # 0
    (1, TType.STRING, 'stat_type', None, None, ), # 1
    (2, TType.STRING, 'stat_attr', None, None, ), # 2
    (3, TType.STRING, 'obj_table', None, None, ), # 3
    None, # 4
    (5, TType.LIST, 'attributes', (TType.STRUCT,(stat_query_column, stat_query_column.thrift_spec)), None, ), # 5
    (6, TType.STRING, 'display_name', None, None, ), # 6
  )

  def __init__(self, display_name=None, stat_type=None, stat_attr=None, obj_table=None, attributes=None,):
    self.display_name = display_name
    self.stat_type = stat_type
    self.stat_attr = stat_attr
    self.obj_table = obj_table
    self.attributes = attributes

  def read(self, iprot):
    if iprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None and fastbinary is not None:
      fastbinary.decode_binary(self, iprot.trans, (self.__class__, self.thrift_spec))
      return 0
    read_cnt = 0
    length = iprot.readStructBegin()
    if length < 0: return -1
    read_cnt += length
    while True:
      (length, fname, ftype, fid) = iprot.readFieldBegin()
      if length < 0: return -1
      read_cnt += length
      if ftype == TType.STOP:
        break
      if fid == 6:
        if ftype == TType.STRING:
          (length, self.display_name) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 1:
        if ftype == TType.STRING:
          (length, self.stat_type) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 2:
        if ftype == TType.STRING:
          (length, self.stat_attr) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 3:
        if ftype == TType.STRING:
          (length, self.obj_table) = iprot.readString();
          if length < 0: return -1
          read_cnt += length
        else:
          iprot.skip(ftype)
      elif fid == 5:
        if ftype == TType.LIST:
          self.attributes = []
          (length, _etype43, _size40) = iprot.readListBegin()
          read_cnt += length
          for _i44 in xrange(_size40):
            _elem45 = stat_query_column()
            read_cnt += _elem45.read(iprot)
            self.attributes.append(_elem45)
          read_cnt += iprot.readListEnd()
        else:
          iprot.skip(ftype)
      else:
        iprot.skip(ftype)
      length = iprot.readFieldEnd()
      if length < 0: return -1
      read_cnt += length
    length = iprot.readStructEnd()
    if length < 0: return -1
    read_cnt += length
    return read_cnt

  def write(self, oprot):
    if oprot.__class__ == TBinaryProtocol.TBinaryProtocolAccelerated and self.thrift_spec is not None and fastbinary is not None:
      oprot.trans.write(fastbinary.encode_binary(self, (self.__class__, self.thrift_spec)))
      return 0
    if oprot.writeStructBegin(self.__class__.__name__) < 0: return -1
    if self.stat_type is not None:
      annotations = {}
      if oprot.writeFieldBegin('stat_type', TType.STRING, 1, annotations) < 0: return -1
      if oprot.writeString(self.stat_type) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.stat_attr is not None:
      annotations = {}
      if oprot.writeFieldBegin('stat_attr', TType.STRING, 2, annotations) < 0: return -1
      if oprot.writeString(self.stat_attr) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.obj_table is not None:
      annotations = {}
      if oprot.writeFieldBegin('obj_table', TType.STRING, 3, annotations) < 0: return -1
      if oprot.writeString(self.obj_table) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.attributes is not None:
      annotations = {}
      if oprot.writeFieldBegin('attributes', TType.LIST, 5, annotations) < 0: return -1
      if oprot.writeListBegin(TType.STRUCT, len(self.attributes)) < 0: return -1
      for iter46 in self.attributes:
        if iter46.write(oprot) < 0: return -1
      if oprot.writeListEnd() < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if self.display_name is not None:
      annotations = {}
      if oprot.writeFieldBegin('display_name', TType.STRING, 6, annotations) < 0: return -1
      if oprot.writeString(self.display_name) < 0: return -1
      if oprot.writeFieldEnd() < 0: return -1
    if oprot.writeFieldStop() < 0: return -1
    if oprot.writeStructEnd() < 0: return -1
    return 0

  def validate(self):
    return


  def log(self):
    log_str = cStringIO.StringIO()
    if self.display_name is not None:
      log_str.write('display_name = ')
      log_str.write(self.display_name)
      log_str.write('  ')
    if self.stat_type is not None:
      log_str.write('stat_type = ')
      log_str.write(self.stat_type)
      log_str.write('  ')
    if self.stat_attr is not None:
      log_str.write('stat_attr = ')
      log_str.write(self.stat_attr)
      log_str.write('  ')
    if self.obj_table is not None:
      log_str.write('obj_table = ')
      log_str.write(self.obj_table)
      log_str.write('  ')
    if self.attributes is not None:
      log_str.write('attributes = ')
      log_str.write('[ ')
      for iter47 in self.attributes:
        log_str.write('<<  ')
        log_str.write(iter47.log())
        log_str.write('>>')
        log_str.write(', ')
      log_str.write(' ]')
      log_str.write('  ')
    return log_str.getvalue()

  def __sizeof__(self):
    size = 0
    if self.display_name is not None:
      size += getsizeof(self.display_name)
    if self.stat_type is not None:
      size += getsizeof(self.stat_type)
    if self.stat_attr is not None:
      size += getsizeof(self.stat_attr)
    if self.obj_table is not None:
      size += getsizeof(self.obj_table)
    if self.attributes is not None:
      size += getsizeof(self.attributes)
      size += sum(map(getsizeof, self.attributes))
    return size

  def __repr__(self):
    L = ['%s=%r' % (key, value)
      for key, value in self.__dict__.iteritems()]
    return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

  def __eq__(self, other):
    return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

  def __ne__(self, other):
    return not (self == other)


_SANDESH_REQUEST_LIST = [
]


_SANDESH_UVE_LIST = [
]


_SANDESH_ALARM_LIST = [
]
